// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// BCPC BasculaCocinaPesarCompras
// El archivo dibuja una bascula de cocina simple
// es compatible con POVRay 3.1.
// Permite dibujar la bandeja en forma independiente si se desea.
//
// #macro BCPC_BasculaCocina( PesoMedido, BanderaBandeja    )
//      PesoMedido              : Valor en Monica del peso medido,
//              entre 0 y 2000 M.  1 M = 1.67482E-4 Kg.
//      BanderaBandeja          : "on" dibuja la bandeja,
//                                "off" no la dibuja.
//
// La dimensiones de la bascula serian :
// Sin Bandeja
//      Minimo          = <  -84,    0,  -83 >*L
//      Maximo          = <   84,  255,   83 >*L
// Con Bandeja
//      Minimo          = < -104,    0, -130 >*L
//      Maximo          = <  104,  319,  104 >*L
// Bandeja sola
//      Minimo          = < -104,    0, -130 >*L
//      Maximo          = <  104,   68,  104 >*L
// Se dibuja centrado sobre el plano XZ,
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// Las siguientes macros permiten modificar las texturas facilmente.
// #macro BCPC_BasculaCocinaPesarCompras( PesoMedido, BanderaBandeja
//        FrenteInferior, FondoInferior, AltoInferior,
//        FrenteSuperior, FondoSuperior,
//        FrenteSoporteVertical, CorrimientoSoporteVertical,
//        FrenteBandeja   , FondoBandeja   , AltoBandeja   ,
//        TexturaPrincipal, TexturaBandeja   , TexturaCaratula,
//        MaterialTransparente, TexturaAguja,
//        TexturaCalibrador, TexturaPatitas )
//      PesoMedido              : Valor en Monica del peso medido,
//              entre 0 y 2000 M.  1 M = 1.67482E-4 Kg.
//      BanderaBandeja          : "on" dibuja la bandeja,
//                                "off" no la dibuja.
//      FrenteInferior          : Valor de referencia para el frente inferior.
//              Valor default es 170*L.
//      FondoInferior           : Valor de referencia para el fondo inferior.
//              Valor default es 168*L.
//      AltoInferior            : Valor de referencia para el alto
//              principal de la bascula.  Default es 160*L.
//      FrenteSuperior          : Valor de referencia para el frente
//              superior de la bascula.  Valor default es 111*L.
//      FondoSuperior           : Valor de referencia para el fondo Z
//              superior de la bascula.  Valor default es 118*L.
//      FrenteSoporteVertical   : Ancho X de la tablilla vertical
//              soporte de bandeja.  Default es 32*L.
//      CorrimientoSoporteVertical      : Referencia para el
//              desplazamiento de la tablilla soporte.  Default es 48*L.
//      FrenteBandeja           : Ancho X de la bandeja.
//              Default es 207*L.
//      FondoBandeja            : Referencia para la profundidad Z
//              de la bandeja.  Default es 207*L.
//      AltoBandeja             : Referencia para el alto de bandeja.
//              Default es 64*L.
//      TexturaPrincipal        : Textura principal de la bascula.
//              Default es BCPC_DefaultTexturaPrincipal.
//      TexturaBandeja          : Textura de la bandeja.
//              Default es BCPC_DefaultTexturaBandeja.
//      TexturaCaratula         : Textura de la caratula.
//              Incluye dibujo de unidades, etc...
//              Default es BCPC_DefaultTexturaCaratula.
//      MaterialTransparente    : Material a aplicar al plastico
//              transparente que cubre las manecillas.
//              Default es BCPC_DefaultMaterialTransparente.
//      TexturaAguja            : Textura a aplicar a la aguja indicadora.
//              Default es BCPC_DefaultTexturaAguja.
//      TexturaCalibrador       : Textura a aplicar a la perilla calibradora.
//              Default es BCPC_DefaultTexturaCalibrador.
//      TexturaPatitas          : Textura a aplicar al soporte inferior.
//              Default es BCPC_DefaultTexturaPatitas.
// 
// La siguiente macro dibuja unicamente la bandeja.
// #macro BCPC_BandejaComida( FrenteSuperior, FondoSuperior,
//        FrenteBandeja, FondoBandeja, AltoBandeja, TexturaBandeja )
//      FrenteSuperior          : Valor de referencia para el frente
//              superior de la bascula.  Valor default es 111*L.
//      FondoSuperior           : Valor de referencia para el fondo Z
//              superior de la bascula.  Valor default es 118*L.
//      FrenteBandeja           : Ancho X de la bandeja.
//              Default es 207*L.
//      FondoBandeja            : Referencia para la profundidad Z
//              de la bandeja.  Default es 207*L.
//      AltoBandeja             : Referencia para el alto de bandeja.
//              Default es 64*L.
//      TexturaBandeja          : Textura de la bandeja.
//              Default es BCPC_DefaultTexturaBandeja.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare BCPC_PosicionBandeja
//      Se genera automaticamente con las macros
//      BCPC_BasculaCocina() y BCPC_BasculaCocinaPesarCompras().
//      Indica la posicion inicial de la bandeja.
//      Para ubicarla en forma independiente con un translate.
// #declare BCPC_PosicionComida
//      Se genera automaticamente con cualquiera de las macros de esta
//      unidad.  Indica la posicion en el punto inferior de la bandeja.
//      Podria ubicarse algo alli.  Recuerde que el fondo de la bandeja
//      no es plano.
// #declare BCPC_TexturaPrincipal
//      Textura principal de la bascula.
// #declare BCPC_TexturaBandeja
//      Textura de la bandeja.
// #declare BCPC_TexturaCaratula
//      Textura de la caratula.  Incluye dibujo de unidades, etc...
// #declare BCPC_MaterialTransparente
//      Material a aplicar al plastico transparente que cubre las manecillas.
// #declare BCPC_TexturaAguja
//      Textura a aplicar a la aguja indicadora.
// #declare BCPC_TexturaCalibrador
//      Textura a aplicar a la perilla calibradora.
// #declare BCPC_TexturaPatitas
//      Textura a aplicar al soporte inferior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare BCPC_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare BCPC_ArchivoGIF                     = "BCPC_IM1.GIF"
//      Nombre de archivo para lectura de caratula.
//      Deberia declararse antes de la instruccion #include.
// #declare BCPC_DefaultTexturaPrincipal        = texture  { ... }
//      Textura principal de la bascula.
// #declare BCPC_DefaultTexturaBandeja          = texture  { ... }
//      Textura de la bandeja.
// #declare BCPC_TexturaCaratula                = texture  { ... }
//      Textura de la caratula.  Incluye dibujo de unidades, etc...
// #declare BCPC_MaterialTransparente           = material { ... }
//      Material a aplicar al plastico transparente que cubre las manecillas.
// #declare BCPC_TexturaAguja                   = texture  { ... }
//      Textura a aplicar a la aguja indicadora.
// #declare BCPC_TexturaCalibrador              = texture  { ... }
//      Textura a aplicar a la perilla calibradora.
// #declare BCPC_TexturaPatitas                 = texture  { ... }
//      Textura a aplicar al soporte inferior.
//
// Para colocarlo simplemente
// #include "BCPC.inc"
// object        { BCPC_BasculaCocina( 550, on ) }
//
// Un ejemplo con macro larga
// #include "BCPC.inc"
// object       { BCPC_BasculaCocinaPesarCompras( 0, on,
//      0.170, 0.168, 0.160, 0.111, 0.118, 0.032, 0.048, 0.207, 0.207, 0.064,
//        BCPC_DefaultTexturaPrincipal, BCPC_DefaultTexturaBandeja,
//        BCPC_DefaultTexturaCaratula, BCPC_DefaultMaterialTransparente,
//        BCPC_DefaultTexturaAguja, BCPC_DefaultTexturaCalibrador,
//        BCPC_DefaultTexturaPatitas ) }
//
// Para ubicar la Bandeja
// #include "BCPC.inc"
// object        { BCPC_BasculaCocina( 550, off ) }
// object        { BCPC_BandejaComida(0.111,0.118,0.207,0.207,0.064,
//                      BCPC_DefaultTexturaBandeja )
//   translate BCPC_PosicionBandeja
// }
//
// Otro ejemplo con modificador
// #include "BCPC.inc"
// #include "textures.inc"
// #declare BCPC_DefaultTexturaPrincipal        =
//      texture { average texture_map
//                { [ 0.5 Rust ][ 0.5 BCPC_TexturaPrincipal ] } }
// object        { BCPC_BasculaCocina( 0, off ) }
//

#include "colors.inc"
#include "textures.inc"

#declare BCPC_L         = 0.001;

#if ( version < 3.2 )
  #ifndef( BCPC_POV3_1 )
    #declare BCPC_POV3_1        = on;
  #end
#else
  #ifndef( BCPC_POV3_1 )
    #declare BCPC_POV3_1        = off;
  #end    
#end

#ifndef ( BCPC_ArchivoGIF )
  #declare BCPC_ArchivoGIF      = "BCPC_IM1.GIF"
#end

#declare BCPC_TexturaPrincipal                  =
  texture       {
    pigment     { Coral }
    normal      { bumps scale  0.1 }
  }

#ifndef ( BCPC_DefaultTexturaPrincipal )
  #declare BCPC_DefaultTexturaPrincipal         =
     texture    { BCPC_TexturaPrincipal }
#end

#declare BCPC_TexturaBandeja                    =
  texture       {
    pigment     { Coral }
    normal      { bumps scale  0.1 }
  }

#ifndef ( BCPC_DefaultTexturaBandeja )
  #declare BCPC_DefaultTexturaBandeja           =
     texture    { BCPC_TexturaBandeja }
#end

#declare BCPC_TexturaCaratula                   =
  texture       {
    pigment     { White }
  }
  texture       {
    pigment     {
      image_map {
        gif     BCPC_ArchivoGIF
        once
      }
      translate       -x/2-y/2
      scale   <2.1,1.60,2.1>
    }
  }

#ifndef ( BCPC_DefaultTexturaCaratula )
  #declare BCPC_DefaultTexturaCaratula          =
     texture    { BCPC_TexturaCaratula }
#end

#declare BCPC_MaterialTransparente              =
  material      {
    texture     {
      pigment   {
        agate
        scale   0.01
        pigment_map     {
          [ 0.95 color Wheat transmit 0.9 ]
          [ 0.95 color White transmit 0.9 ]
        }
      }
      normal    {
        bumps   0.3
      }
      finish      {
        specular 0.01
        roughness 0.001
        reflection 0.01
      }
    }
  }

#ifndef ( BCPC_DefaultMaterialTransparente )
  #declare BCPC_DefaultMaterialTransparente     =
     material   { BCPC_MaterialTransparente }
#end

#declare BCPC_TexturaAguja                      =
  texture       {
    pigment     { Red }
  }

#ifndef ( BCPC_DefaultTexturaAguja )
  #declare BCPC_DefaultTexturaAguja             =
     texture    { BCPC_TexturaAguja }
#end

#declare BCPC_TexturaCalibrador                 =
  texture       {
    pigment     { White }
    normal      {
      radial
      frequency 30
      sine_wave
    }
  }

#ifndef ( BCPC_DefaultTexturaCalibrador )
  #declare BCPC_DefaultTexturaCalibrador        =
     texture    { BCPC_TexturaCalibrador }
#end

#declare BCPC_TexturaPatitas                    =
  texture       {
    pigment     { Gray30 }
    normal      {
      agate
      scale     0.1
    }
  }

#ifndef ( BCPC_DefaultTexturaPatitas )
  #declare BCPC_DefaultTexturaPatitas           =
     texture    { BCPC_TexturaPatitas }
#end

#macro BCPC_BandejaComida( FrenteSuperior, FondoSuperior,
        FrenteBandeja, FondoBandeja, AltoBandeja,
        TexturaBandeja )
  difference            {
    #local FondoPlaca           = 84/118*FondoSuperior;
    #local FrentePlaca          = 106/111*FrenteSuperior;
    #local GruesoPlaca          = 8/106*FrentePlaca;
    union               {
      superellipsoid    {
        <0.1,0.1>
        scale   < FrenteBandeja/2, AltoBandeja, FondoBandeja/2 >
      }
      cone              {
        0               , 0.25, -0.6*y, 0
        rotate          -10*x
        translate       -z
        scale   < FrenteBandeja/2, AltoBandeja, FondoBandeja/2 >
      }
      cylinder          {
        0               , -0.05*y       , 0.26
        rotate          -10*x
        translate       -z
        scale   < FrenteBandeja   /2, AltoBandeja   , FondoBandeja   /2 >
      }
      difference        {
        superellipsoid    {
          <0.1,0.1>
          scale 1.01
        }
        superellipsoid    {
          <0.1,0.1>
          scale <1,2,1>
        }
        scale   < FrentePlaca/2, GruesoPlaca/2, FondoPlaca/2 >
        translate       -AltoBandeja   *y
      }
      superellipsoid    {
        <0.1,0.1>
        scale   1.01*
                < FrenteBandeja   /2, AltoBandeja   /30, FondoBandeja   /2 >
      }
    }
    union               {
      superellipsoid    {
        <0.1,0.1>
        scale   < FrenteBandeja   /2, AltoBandeja   , FondoBandeja   /2 >
      }
      cone              {
        +0.6*y          , 0.50, -0.6*y, 0
        rotate          -10*x
        translate       -z
        scale   < FrenteBandeja   /2, AltoBandeja   , FondoBandeja   /2 >
      }
      scale             0.98
    }
    plane               {
      -y, 0
    }
    #declare BCPC_PosicionComida        = GruesoPlaca/2*y+0.02*AltoBandeja*y;
    translate           AltoBandeja   *y+GruesoPlaca/2*y
    texture             {
      TexturaBandeja
    }
  }
#end

#macro BCPC_BasculaCocinaPesarCompras( PesoMedido, BanderaBandeja,
        FrenteInferior, FondoInferior, AltoInferior,
        FrenteSuperior, FondoSuperior,
        FrenteSoporteVertical, CorrimientoSoporteVertical,
        FrenteBandeja   , FondoBandeja   , AltoBandeja   ,
        TexturaPrincipal, TexturaBandeja   , TexturaCaratula,
        MaterialTransparente, TexturaAguja,
        TexturaCalibrador, TexturaPatitas )
  union                 {
    #local AlturaPlaca          = 35/160*AltoInferior;
    #local FondoPlaca           = 84/118*FondoSuperior;
    #local FrentePlaca          = 106/111*FrenteSuperior;
    #local GruesoPlaca          = 8/106*FrentePlaca;
    #local AlturaPlacaCorregida         =
                        ( 3000-PesoMedido )/3000*AlturaPlaca;
    #local FormaCaratula        =
      union     {
        cylinder        {
          -0.1*z        , +0.1*z,
          0.70
        }
        prism           {
          cubic_spline
          -0.1, 0.1,
          9,
          <-0.5,-0.1>,< -0.70,0>, <-0.50,0.7>,<0.5,0.7>,<0.7,0>,<0.50,0.1>,<-0.5,0.1>,<-0.70,0>,<-0.50,0.80>
          rotate        -90*x
        }
      }
    difference          {
      difference          {
        #local DeltaX     = ( FrenteInferior-FrenteSuperior )/FrenteInferior;
        #local DeltaZ     = ( FondoInferior-FondoSuperior )/FondoInferior;
        #local FraccionZ  = 0.7;
        #local AnguloZ    =
          degrees( atan2(
             0.5*FraccionZ*( FondoInferior-FondoSuperior ), AltoInferior ) );
        intersection        {
          superellipsoid          {
            <0.1,0.1>
            matrix        <1,0,0,-DeltaX,1,0,0,0,1,0,0,0>
          }
          superellipsoid          {
            <0.1,0.1>
            matrix        <1,0,0,0,1,-( 2-FraccionZ )*DeltaZ,0,0,1,0,0,0>
          }
          superellipsoid          {
            <0.1,0.1>
            matrix        <1,0,0,0,1,+FraccionZ*DeltaZ,0,0,1,0,0,0>
          }
          superellipsoid          {
            <0.1,0.1>
            matrix        <1,0,0,+DeltaX,1,0,0,0,1,0,0,0>
          }
        }
        cylinder                {
          0.5*y ,y, 0.15
        }
        cylinder                {
          0.5*y ,y, 0.05
          translate     -0.30*x
        }
        cylinder                {
          0.5*y ,y, 0.05
          translate     +0.30*x
        }
        box                 {
          -1, 1
          scale     <FrentePlaca/FrenteInferior*0.525,1,
                                GruesoPlaca/FondoInferior*0.525>
          translate         +( CorrimientoSoporteVertical*z
                        -FondoPlaca/2*z+GruesoPlaca/2*z )/FondoInferior
          translate 0.5*y
        }
        superellipsoid            {
          <0.5,0.3>
          scale   <0.5,0.5,1.2>
          translate       -x+z+y
        }
        superellipsoid            {
          <0.5,0.3>
          scale   <0.5,0.5,1.2>
          translate       +x+z+y
        }
        plane             {
          y               , 0
        }
        scale     < FrenteInferior/2,AltoInferior,FondoInferior/2>
      }
      object            {
        FormaCaratula
        texture         {
          TexturaCaratula
        }
        rotate          +AnguloZ*x
        scale           FrenteInferior/2
        translate       +AltoInferior/2*y-FondoInferior*0.4*z
      }
    }
    // Plastico Caratula
    difference          {
      union             {
        object          {
          FormaCaratula
        }
        object          {
          FormaCaratula
          scale         <0.95,0.95,1.20>
        }
      }
      union             {
        object          {
          FormaCaratula
        }
        object          {
          FormaCaratula
          scale         <0.95,0.95,1.20>
        }
        scale   0.90
        translate       +0.05*z
      }
      rotate          +AnguloZ*x
      scale           FrenteInferior/2
      translate       +AltoInferior/2*y-FondoInferior*0.4*z
      material          {
        MaterialTransparente
      }
    }
    // Aguja caratula
    union               {
      cylinder          {
        0       , 0.1*z, 0.01
      }
      cylinder          {
        -0.010*z,+0.010*z, 0.05
      }
      difference        {
        cylinder        {
          -0.010*z,+0.010*z, 0.05
          scale <1,3,1>
        }
        plane           {
          -y,0
        }
      }
      cone              {
        0       , 0.01  , 0.70*y, 0.0
        scale   <1,1,5>
      }
      rotate          -180*PesoMedido/1000*z
      rotate          +AnguloZ*x
      scale           FrenteInferior/2
      translate       +AltoInferior/2*y-FondoInferior*0.4*z
      texture   {
        TexturaAguja
      }
    }
    // Placa base de Bandeja   
    difference          {
      superellipsoid    {
        <0.1,0.1>
      }
      box               {
        -1, 1
        scale   <1,0.15,1>*0.9
        translate       y
      }
      box               {
        -1, 1
        scale   <0.5,0.20,0.5>*0.9
        translate       y
      }
      plane             {
        y        , 0
      }
      scale   <FrentePlaca/2,GruesoPlaca,FondoPlaca/2>
      translate       AltoInferior*y+AlturaPlacaCorregida*y
    }
    // Tornillo Calibrador
    union               {
      difference        {
        cylinder        {
          0.10*AlturaPlaca*y    , 0.25*AlturaPlaca*y  ,
          0.30*AlturaPlaca
        }
        cylinder        {
          0.05*AlturaPlaca*y    , 0.30*AlturaPlaca*y  ,
          0.10*AlturaPlaca
        }
      }
      cylinder        {
        -0.10*AltoInferior*y    , 0.20*AlturaPlaca*y  ,
        0.20*AlturaPlaca
      }
      translate         AltoInferior*y
      texture           {
        TexturaCalibrador
      }
    }
    // SoporteVertical
    box                 {
      -1, 1
      scale     <FrenteSoporteVertical/2,AlturaPlaca,GruesoPlaca/2>
      translate         +CorrimientoSoporteVertical*z
                        -FondoPlaca/2*z+GruesoPlaca/2*z
      translate ( AlturaPlacaCorregida-AlturaPlaca )*y
      translate AltoInferior*y
    }
    #if ( BanderaBandeja    )
      object      {
        BCPC_BandejaComida( FrenteSuperior, FondoSuperior,
        FrenteBandeja   , FondoBandeja   , AltoBandeja   ,
        TexturaBandeja    )
        translate       -GruesoPlaca/2*y
        translate       AltoInferior*y+AlturaPlacaCorregida*y
                        +GruesoPlaca*y
      }
    #end
    prism               {
      cubic_spline
      0.1, -0.02, 18
      <0.0,0.70>,<+0.80,+0.80>,<+0.80,-0.80>,<0.0,-0.70>,<-0.80,-0.80>,
      <-0.80,+0.80>,<0.0,+0.70>,<+0.80,+0.80>,<0.80,-0.80>,
      <0.0,0.20>,<+0.40,+0.40>,<+0.40,-0.40>,<0.0,-0.20>,<-0.40,-0.40>,
      <-0.40,+0.40>,<0.0,+0.20>,<+0.40,+0.40>,<0.40,-0.40>
      scale             < FrenteInferior/2, AltoInferior, FondoInferior/2 >
      texture           {
        TexturaPatitas
      }
    }
    translate   +0.02*AltoInferior*y
    #declare BCPC_PosicionBandeja       =
                0.02*AltoInferior*y+GruesoPlaca/2*y
                +AltoInferior*y+AlturaPlacaCorregida*y;
                
    #declare BCPC_PosicionComida        =  GruesoPlaca/2*y+
                0.02*AltoBandeja*y+BCPC_PosicionBandeja;
    texture             {
      TexturaPrincipal
    }
  }
#end

#macro BCPC_BasculaCocina( PesoMedido, BanderaBandeja    )
  object                {
    #local L                    = BCPC_L;
    #local FrenteInferior       = 170*L;
    #local FondoInferior        = 168*L;
    #local AltoInferior         = 160*L;
    #local FrenteSuperior       = 111*L;
    #local FondoSuperior        = 118*L;
    #local FrenteSoporteVertical        = 32*L;
    #local CorrimientoSoporteVertical   = 48*L;
    #local FrenteBandeja        = 207*L;
    #local FondoBandeja         = 207*L;
    #local AltoBandeja          = 64*L;
    BCPC_BasculaCocinaPesarCompras( PesoMedido, BanderaBandeja   ,
        FrenteInferior, FondoInferior, AltoInferior,
        FrenteSuperior, FondoSuperior,
        FrenteSoporteVertical, CorrimientoSoporteVertical,
        FrenteBandeja   , FondoBandeja   , AltoBandeja   ,
        BCPC_DefaultTexturaPrincipal,
        BCPC_DefaultTexturaBandeja,
        BCPC_DefaultTexturaCaratula,
        BCPC_DefaultMaterialTransparente,
        BCPC_DefaultTexturaAguja,
        BCPC_DefaultTexturaCalibrador,
        BCPC_DefaultTexturaPatitas )
  }
#end

