// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// BCPC BasculaCocinaPesarCompras
// El archivo dibuja una bascula de cocina simple
// es compatible con POVRay 3.1.
// Permite dibujar la bandeja en forma independiente si se desea.
//
// #macro BCPC_BasculaCocina( PesoMedido, BanderaBandeja    )
//      PesoMedido              : Valor en Monica del peso medido,
//              entre 0 y 2000 M.  1 M = 1.67482E-4 Kg.
//      BanderaBandeja          : "on" dibuja la bandeja,
//                                "off" no la dibuja.
//
// La dimensiones de la bascula serian :
// Sin Bandeja
//      Minimo          = <  -84,    0,  -83 >*L
//      Maximo          = <   84,  255,   83 >*L
// Con Bandeja
//      Minimo          = < -104,    0, -130 >*L
//      Maximo          = <  104,  319,  104 >*L
// Bandeja sola
//      Minimo          = < -104,    0, -130 >*L
//      Maximo          = <  104,   68,  104 >*L
// Se dibuja centrado sobre el plano XZ,
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// Las siguientes macros permiten modificar las texturas facilmente.
// #macro BCPC_BasculaCocinaPesarCompras( PesoMedido, BanderaBandeja
//        FrenteInferior, FondoInferior, AltoInferior,
//        FrenteSuperior, FondoSuperior,
//        FrenteSoporteVertical, CorrimientoSoporteVertical,
//        FrenteBandeja   , FondoBandeja   , AltoBandeja   ,
//        TexturaPrincipal, TexturaBandeja   , TexturaCaratula,
//        MaterialTransparente, TexturaAguja,
//        TexturaCalibrador, TexturaPatitas )
//      PesoMedido              : Valor en Monica del peso medido,
//              entre 0 y 2000 M.  1 M = 1.67482E-4 Kg.
//      BanderaBandeja          : "on" dibuja la bandeja,
//                                "off" no la dibuja.
//      FrenteInferior          : Valor de referencia para el frente inferior.
//              Valor default es 170*L.
//      FondoInferior           : Valor de referencia para el fondo inferior.
//              Valor default es 168*L.
//      AltoInferior            : Valor de referencia para el alto
//              principal de la bascula.  Default es 160*L.
//      FrenteSuperior          : Valor de referencia para el frente
//              superior de la bascula.  Valor default es 111*L.
//      FondoSuperior           : Valor de referencia para el fondo Z
//              superior de la bascula.  Valor default es 118*L.
//      FrenteSoporteVertical   : Ancho X de la tablilla vertical
//              soporte de bandeja.  Default es 32*L.
//      CorrimientoSoporteVertical      : Referencia para el
//              desplazamiento de la tablilla soporte.  Default es 48*L.
//      FrenteBandeja           : Ancho X de la bandeja.
//              Default es 207*L.
//      FondoBandeja            : Referencia para la profundidad Z
//              de la bandeja.  Default es 207*L.
//      AltoBandeja             : Referencia para el alto de bandeja.
//              Default es 64*L.
//      TexturaPrincipal        : Textura principal de la bascula.
//              Default es BCPC_DefaultTexturaPrincipal.
//      TexturaBandeja          : Textura de la bandeja.
//              Default es BCPC_DefaultTexturaBandeja.
//      TexturaCaratula         : Textura de la caratula.
//              Incluye dibujo de unidades, etc...
//              Default es BCPC_DefaultTexturaCaratula.
//      MaterialTransparente    : Material a aplicar al plastico
//              transparente que cubre las manecillas.
//              Default es BCPC_DefaultMaterialTransparente.
//      TexturaAguja            : Textura a aplicar a la aguja indicadora.
//              Default es BCPC_DefaultTexturaAguja.
//      TexturaCalibrador       : Textura a aplicar a la perilla calibradora.
//              Default es BCPC_DefaultTexturaCalibrador.
//      TexturaPatitas          : Textura a aplicar al soporte inferior.
//              Default es BCPC_DefaultTexturaPatitas.
// 
// La siguiente macro dibuja unicamente la bandeja.
// #macro BCPC_BandejaComida( FrenteSuperior, FondoSuperior,
//        FrenteBandeja, FondoBandeja, AltoBandeja, TexturaBandeja )
//      FrenteSuperior          : Valor de referencia para el frente
//              superior de la bascula.  Valor default es 111*L.
//      FondoSuperior           : Valor de referencia para el fondo Z
//              superior de la bascula.  Valor default es 118*L.
//      FrenteBandeja           : Ancho X de la bandeja.
//              Default es 207*L.
//      FondoBandeja            : Referencia para la profundidad Z
//              de la bandeja.  Default es 207*L.
//      AltoBandeja             : Referencia para el alto de bandeja.
//              Default es 64*L.
//      TexturaBandeja          : Textura de la bandeja.
//              Default es BCPC_DefaultTexturaBandeja.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare BCPC_PosicionBandeja
//      Se genera automaticamente con las macros
//      BCPC_BasculaCocina() y BCPC_BasculaCocinaPesarCompras().
//      Indica la posicion inicial de la bandeja.
//      Para ubicarla en forma independiente con un translate.
// #declare BCPC_PosicionComida
//      Se genera automaticamente con cualquiera de las macros de esta
//      unidad.  Indica la posicion en el punto inferior de la bandeja.
//      Podria ubicarse algo alli.  Recuerde que el fondo de la bandeja
//      no es plano.
// #declare BCPC_TexturaPrincipal
//      Textura principal de la bascula.
// #declare BCPC_TexturaBandeja
//      Textura de la bandeja.
// #declare BCPC_TexturaCaratula
//      Textura de la caratula.  Incluye dibujo de unidades, etc...
// #declare BCPC_MaterialTransparente
//      Material a aplicar al plastico transparente que cubre las manecillas.
// #declare BCPC_TexturaAguja
//      Textura a aplicar a la aguja indicadora.
// #declare BCPC_TexturaCalibrador
//      Textura a aplicar a la perilla calibradora.
// #declare BCPC_TexturaPatitas
//      Textura a aplicar al soporte inferior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare BCPC_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare BCPC_ArchivoGIF                     = "BCPC_IM1.GIF"
//      Nombre de archivo para lectura de caratula.
//      Deberia declararse antes de la instruccion #include.
// #declare BCPC_DefaultTexturaPrincipal        = texture  { ... }
//      Textura principal de la bascula.
// #declare BCPC_DefaultTexturaBandeja          = texture  { ... }
//      Textura de la bandeja.
// #declare BCPC_TexturaCaratula                = texture  { ... }
//      Textura de la caratula.  Incluye dibujo de unidades, etc...
// #declare BCPC_MaterialTransparente           = material { ... }
//      Material a aplicar al plastico transparente que cubre las manecillas.
// #declare BCPC_TexturaAguja                   = texture  { ... }
//      Textura a aplicar a la aguja indicadora.
// #declare BCPC_TexturaCalibrador              = texture  { ... }
//      Textura a aplicar a la perilla calibradora.
// #declare BCPC_TexturaPatitas                 = texture  { ... }
//      Textura a aplicar al soporte inferior.
//
// Para colocarlo simplemente
// #include "BCPC.inc"
// object        { BCPC_BasculaCocina( 550, on ) }
//
// Un ejemplo con macro larga
// #include "BCPC.inc"
// object       { BCPC_BasculaCocinaPesarCompras( 0, on,
//      0.170, 0.168, 0.160, 0.111, 0.118, 0.032, 0.048, 0.207, 0.207, 0.064,
//        BCPC_DefaultTexturaPrincipal, BCPC_DefaultTexturaBandeja,
//        BCPC_DefaultTexturaCaratula, BCPC_DefaultMaterialTransparente,
//        BCPC_DefaultTexturaAguja, BCPC_DefaultTexturaCalibrador,
//        BCPC_DefaultTexturaPatitas ) }
//
// Para ubicar la Bandeja
// #include "BCPC.inc"
// object        { BCPC_BasculaCocina( 550, off ) }
// object        { BCPC_BandejaComida(0.111,0.118,0.207,0.207,0.064,
//                      BCPC_DefaultTexturaBandeja )
//   translate BCPC_PosicionBandeja
// }
//
// Otro ejemplo con modificador
// #include "BCPC.inc"
// #include "textures.inc"
// #declare BCPC_DefaultTexturaPrincipal        =
//      texture { average texture_map
//                { [ 0.5 Rust ][ 0.5 BCPC_TexturaPrincipal ] } }
// object        { BCPC_BasculaCocina( 0, off ) }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}

#include "BCPC.inc"

#declare FactorAcercamiento     = 4;

object          {
  BCPC_BasculaCocina( 0, on )
  translate       -0.125*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z  
}


