// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 5 de febrero, 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// BLDP BarcoLegoDinamarcaPersonal
// El modelo es original, esta es la historia:
//      Yo le dije a varias personas que el nuevo paquete
//      FreeRay2012 contendria un barco modelado en Moray.
//      Por falta de tiempo no pude satisfacer este
//      proyecto en esta version de FreeRay.
//      Como consolacion modele con mi LEGO de marca de DINAMARCA
//      este barco de mi imaginacion (para tranquilidad de
//      los usuarios de la patente LGPL).
//      Use Moray, que puede exporta a POVRay.
//      Como la Biblioteca oficial POVRay no acepta
//      archivos tipo Moray puro, no incluyo el codigo original.
//      Lo siento...
//
// El archivo dibuja un barco de LEGO para menores de edad.
// Puede dibujarse por etapas.
// #macro BLDP_BarcoLegoDinamarcaPersonal( Etapa )
//      Etapa           : Valor entero entre 0 y 5.  El valor 0 dibuja
//                        la base de color verde.  Cada valor agrega
//                        un piso.  El valor 4 un mastil, el valor 5
//                        dos mastiles.
//
// Las dimensiones del barco de lego.
// El microfono descansa en el plano XZ.
// El barco se encuentra parcialmente centrado en el origen.
// El microfono sobresale hacia Y+, frente hacia X+.
//      Minimo      : < -95,   0,-34>*L aprox
//      Maximo      : < 102, 114, 34>*L aprox
//
// Al usuario le podrian ser utiles las siguientes declaraciones de bloque.
// Nota: En Moray la orientacion preferida es Z+ hacia arriba.
// Nosotros preferimos en POVRay Y+ hacia arriba (mi proyecto LibreN3D es dextrogiro 
// con Y+ hacia abajo, pero por el momento eso no deberia preocupar al usuario).
// Para pasar a unidades de nuestro barco, usted deberia aplicar 
// scale BLDP_FactorEscala,
// y probablemente rotate -90*x previamente si el usuario prefiere como nosotros, el eje
// Y+ orientado hacia arriba.  Se indican dimensiones sin tomar en cuenta los
// puntos de ligadura que le agregan 0.1 unidades al alto sin el scale.
// #declare BLDP_Bloque2x4     
//      Object que genera un bloque de construccion de <0,0,0> a <4,2,1.2> aproximadamente.
// #declare BLDP_Bloque2x2
//      Object que genera un bloque de construccion de <0,0,0> a <2,2,1.2> aproximadamente.
// #declare BLDP_Bloque2x8     
//      Object que genera un bloque de construccion de <0,0,0> a <8,2,1.2> aproximadamente.
// #declare BLDP_Bloque2x10     
//      Object que genera un bloque de construccion de <0,0,0> a <10,2,1.2> aproximadamente.
// #declare BLDP_Bloque4x12     
//      Object que genera un bloque de construccion de <0,0,0> a <12,4,1.2> aproximadamente.
// #declare BLDP_FactorEscala                   = 0.0068;
//      Valor para dimensionar los bloques a escala del dibujo.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare BLDP_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare BLDP_Verde                         = texture { ... }
//      Permite modificar la textura de los bloques de color
//      verde.  Debe declararse antes del #include.
// #declare BLDP_Azul                          = texture { ... }
//      Permite modificar la textura de los bloques de color
//      azul.  Debe declararse antes del #include.
// #declare BLDP_Rojo                          = texture { ... }
//      Permite modificar la textura de los bloques de color
//      rojo.  Debe declararse antes del #include.
// #declare BLDP_Blanco                        = texture { ... }
//      Permite modificar la textura de los bloques de color
//      blanco.  Debe declararse antes del #include.
// #declare BLDP_Negro                         = texture { ... }
//      Permite modificar la textura de los bloques de color
//      negro.  Debe declararse antes del #include.
// #declare BLDP_Gris                          = texture { ... }
//      Permite modificar la textura de los bloques de color
//      gris.  Debe declararse antes del #include.
// #declare BLDP_Amarillo                      = texture { ... }
//      Permite modificar la textura de los bloques de color
//      amarillo.  Debe declararse antes del #include.
//
// Para colocarlo simplemente
// #include "BLDP.inc"
// object        { BLDP_BarcoLegoDinamarcaPersonal(5) }
//
// Otro ejemplo con modificador
// #declare BLDP_Amarillo       = texture { PinkAlabaster }
// #include "BLDP.inc"
//
// object        {
//      BLDP_BarcoLegoDinamarcaPersonal(4)
// }
//
// Y solo una pieza de construccion:
// #include "BLDP.inc"
//
// object       { BLDP_Bloque2x4 rotate -90*x scale BLDP_FactorEscala }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  ,-500   , -3000 >*L
         White
}
background      {
         Gray50
}    
#include "BLDP.inc"

#local FactorAcercamiento       = 9;

object          {
  BLDP_BarcoLegoDinamarcaPersonal(5)
  translate     -0.05*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
}


