// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CCBR CrucifijoCristalBlancoResistente
// El archivo dibuja un crucifijo cristiano sencillo,
// lamentablemente no es compatible con POVRay 3.1.
// #macro CCBR_CrucifijoCristal()
//
// La dimensiones del crucifijo son :
//      Alto total              = 172*L;
//      Alto Base               =  35*L;
//      Fondo total             =  50*L;
//      Fondo Crucifijo         =  12*L;
//      Frente                  =  80*L;
// Se dibuja centrado en el eje Y sobre el plano XZ, 
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// Las siguientes macros permiten modificar las texturas facilmente.
// #macro CCBR_Crucifijo( MaterialCruz, MaterialGrabado, MaterialBase )
//      MaterialCruz            : Material principal de la cruz.
//      MaterialGrabado         : Material para el grabado.
//      MaterialBase            : Material para aplicar a la base.
// 
// La siguiente macro dibuja unicamente la base.
// #macro CCBR_BaseCruz( MaterialBase )
//      MaterialBase            : Material para aplicar a la base.
// 
// Esta macro dibuja unicamente la cruz.
// #macro CCBR_CruzPrincipal( MaterialCruz, MaterialGrabado )
//      MaterialCruz            : Material principal de la cruz.
//      MaterialGrabado         : Material para el grabado.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare CCBR_MaterialCristal
//      Material principal del crucifijo de cristal.
// #declare CCBR_MaterialCristal2
//      Material a aplicar a los grabados por diferencia.
//      Se definio como material, para poder usar el mismo
//      que CCBR_MaterialCristal.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CCBR_DefaultMaterialCristal         = material { ... }
//      Material principal del crucifijo.
// #declare TMEE_DefaultMaterialCristal2        = material { ... }
//      Material a utilizar para los grabados.
//
// Para colocarlo simplemente
// #include "CCBR.inc"
// object        { CCBR_CrucifijoCristal() }
//
// Otro ejemplo con modificador
// #include "CCBR.inc"
// #include "textures.inc"
// #declare CCBR_DefaultMaterialCristal         = 
//      material      { texture { PinkAlabaster } }
// #declare CCBR_DefaultMaterialCristal2        =
//      material      { texture { PinkAlabaster } }      
// object        {
//      CCBR_CrucifijoCristal()
// }
//
 
#declare CCBR_L         = 0.001; 

#include "glass.inc" 

#declare CCBR_MaterialCristal   = material      {  
  texture  { pigment { color <0.7412, 0.8235, 0.8431> transmit 0.9 }
             normal { bumps 0.01 turbulence 0.01 scale 10 }
              
  finish {
    specular 1.6
    roughness 0.01
    ambient 0
    diffuse 0.15
    brilliance 7
    reflection {
      0.3, 1.0
      fresnel on
    }       
    irid        {
      0.25
    }
    conserve_energy
 }

             }
  interior {
    ior 1.5
    fade_distance 0.025
    fade_power 1001 
    fade_color  <0.7412, 0.8235, 0.8431>
  }
}

#ifndef ( CCBR_DefaultMaterialCristal )
  #declare CCBR_DefaultMaterialCristal  = material      {
    CCBR_MaterialCristal
  }
#end
  
#declare CCBR_MaterialCristal2   = material      {  
  texture  { pigment { color <0.7412, 0.8235, 0.8431> transmit 0.9 }
             normal { bumps 0.01 turbulence 0.01 scale 1 }
              
  finish {
    specular 2.0
    roughness 0.01
    ambient 0
    diffuse 0.15
    brilliance 7
    reflection {
      0.3, 1.0
      fresnel on
    }           
    irid        {
      0.25
    }
    conserve_energy
 }

             }
  interior {
    ior 1.5
    fade_distance 0.025
    fade_power 1001
    fade_color  <0.7412, 0.8235, 0.8431>
  }
}

#ifndef ( CCBR_DefaultMaterialCristal2 )
  #declare CCBR_DefaultMaterialCristal2  = material      {
    CCBR_MaterialCristal2
  }
#end
  
#declare CCBR_PuntoCruz = array [22]        
  {
    <-0.1538, 0.9921, 0.0000 >,
    < 0.0000, 1.0000, 0.0000 >,
    < 0.1538, 0.9921, 0.0000 >,
    < 0.2500, 0.9763, 0.0000 >,
    < 0.2307, 0.9448, 0.0000 >,
    < 0.1538, 0.8188, 0.0000 >,
    < 0.3076, 0.7716, 0.0000 >,
    < 0.8846, 0.8031, 0.0000 >,
    < 0.9615, 0.7874, 0.0000 >,
    < 1.0000, 0.7322, 0.0000 >,
    < 0.9615, 0.6771, 0.0000 >,
    < 0.8846, 0.6614, 0.0000 >,
    < 0.3076, 0.6929, 0.0000 >,
    < 0.1923, 0.6456, 0.0000 >,
    < 0.2307, 0.4094, 0.0000 >,
    < 0.2692, 0.3149, 0.0000 >,
    < 0.3076, 0.1889, 0.0000 >,
    < 0.3461, 0.0949, 0.0000 >,
    < 0.2692, 0.0629, 0.0000 >,
    < 0.4230, 0.0000, 0.0000 >,
    < 0.5768,-0.0659, 0.0000 >,
    < 2.0000,-0.7450, 0.0000 >
  }
  
#declare CCBR_SplineCruz =
  spline                {
    cubic_spline
    #local Tamano       = dimension_size( CCBR_PuntoCruz, 1 );
    #local Divisor      = Tamano-4;
    #local C            = 0;
    #while ( C < Tamano )
      ( C-2 )/Divisor   , CCBR_PuntoCruz[ Tamano-1-C ]  
      #local C          = C+1;
    #end      
  }  
        
#macro CCBR_BaseCruz( MaterialBase )
  difference            {
    #local L            = 0.001;
    #local BaseX        = 79*L;
    #local BaseZ        = 49*L;
    #local AltoGrada1   = 13*L;
    #local BaseY        = 35*L;
    #local PrismaBase   =
      prism             {
        cubic_spline 0, 1, 13,
        < 0.0266,-0.2388 >,
        < 0.0000, 0.0000 >,
        < 0.0266, 0.2388 >,
        < 0.1066, 0.8358 >,
        < 0.1333, 0.9552 >,
        < 0.2400, 1.0000 >,
        < 1.0000, 0.9552 >,
        < 1.7500, 0.9552 >,
        < 1.0000, 0.0000 >,  
        < 0.2066,-0.5000 >,
        < 0.0266,-0.2388 >,
        < 0.0000, 0.0000 >,
        < 0.0266, 0.2388 >
        scale           < 0.5,1.0,0.5>  
        translate       -0.5*x
      }
      
    #local ObjetoBase   =
      merge             {
        object          {
          PrismaBase
        }
        object          {
          PrismaBase          
          translate     -0.001
          scale         < 1.0, 1.0,-1.0 >
        }  
        object          {
          PrismaBase
          translate     +0.001
          scale         <-1.0, 1.0,-1.0 >          
        }
        object          {
          PrismaBase
          translate     -0.0005
          scale         <-1.0, 1.0, 1.0 >
        }  
      }  
      
    merge               {
      object            {
        ObjetoBase
        scale           < BaseX, AltoGrada1, BaseZ >
      }
      object            {
        ObjetoBase
        scale           < BaseX, AltoGrada1, BaseZ >*<0.85,1.0,0.8>
        translate       AltoGrada1*y
      }
      object            {
        ObjetoBase
        scale           < BaseX, BaseY-2*AltoGrada1, BaseZ >*
                                        <0.85,1.0,0.8>*<0.85,1.0,0.8>
        translate       2*AltoGrada1*y
      }     
    }
    union               {
      object            {
        ObjetoBase
        translate       -0.10*AltoGrada1*y
        scale           < BaseX, AltoGrada1, BaseZ >*<0.85,0.8,0.8>
      }
      object            {
        ObjetoBase
        translate       -0.11*AltoGrada1*y
        scale           < BaseX, AltoGrada1, BaseZ >*
                                <0.85,1.0,0.8>*<0.85,1.0,0.8>
        translate       0.8*AltoGrada1*y
      } 
      object            {
        ObjetoBase
        translate       -0.12*AltoGrada1*y
        scale           < BaseX, BaseY-2*AltoGrada1, BaseZ >*
                          <0.85,1.0,0.8>*<0.85,1.0,0.8>*<0.85,0.5,0.8>
        translate       1.8*AltoGrada1*y
      }  
    }    
    bounded_by          {
      sphere    { BaseY/2*y         , BaseX }
    }
    material            {
      MaterialBase     
    }
  }
#end  

#macro CCBR_CruzPrincipal( MaterialCruz, MaterialGrabado )
  difference            {
    #local L            = 0.001;
    #local AltoCruz     = 132*L;
    #local FrenteCruz   = 76*L;
    #local ProfundidadCruz              = 11*L;
    #local TamanoSpline     = dimension_size( CCBR_PuntoCruz, 1 )-3;
    #local TotalPuntos      = 2*TamanoSpline+6;
    merge               {
      prism             {
        cubic_spline 0, 1, TotalPuntos,
        #local C        = 0;
        #while ( C < TotalPuntos )
          #switch ( C )
            #range ( 0, TamanoSpline+1 )
              #local Piv    = CCBR_SplineCruz( ( C-1 )/TamanoSpline );
            #break     
            #range ( TamanoSpline+2, 2*TamanoSpline+2 )
              #local Piv    = <-1,1,1>*CCBR_SplineCruz( 
                                ( 2*TamanoSpline+1-C )/TamanoSpline );
            #break
            #range ( 2*TamanoSpline+3, TotalPuntos )
              #local Piv    = CCBR_SplineCruz( 
                      ( C-2*TamanoSpline-4 )/TamanoSpline );
            #break
          #end     
          < Piv.x, Piv.y >
          #local C      = C+1;
        #end   
        rotate          -90*x   
        scale           < FrenteCruz/2, AltoCruz, ProfundidadCruz > 
        translate       +ProfundidadCruz*z/2
      }        
      sphere_sweep      {
        cubic_spline,   TotalPuntos,
        #local C        = 0;
        #while ( C < TotalPuntos )
          #switch ( C )
            #range ( 0, TamanoSpline+1 )
              #local Piv    = CCBR_SplineCruz( ( C-1 )/TamanoSpline );
            #break     
            #range ( TamanoSpline+2, 2*TamanoSpline+2 )
              #local Piv    = <-1,1,1>*CCBR_SplineCruz( 
                                ( 2*TamanoSpline+1-C )/TamanoSpline );
            #break
            #range ( 2*TamanoSpline+3, TotalPuntos )
              #local Piv    = CCBR_SplineCruz( 
                      ( C-2*TamanoSpline-4 )/TamanoSpline );
            #break
          #end     
          Piv, 1/30
          #local C      = C+1;
        #end            
        scale   <1,1,15>*< FrenteCruz/2, AltoCruz, ProfundidadCruz >   
      }
    }   
    union             {
      #local RDec     = 0.0050;
      #local C          = 0;
      #while ( C < 2 ) 
        union     {
          sphere_sweep    {
            cubic_spline, 6
            < 1.1500, 0.9022, 0.0000 >, RDec
            < 0.8500, 0.7822, 0.0000 >, RDec
            < 0.3000, 0.7322, 0.0000 >, RDec
            < 0.0000, 0.6522, 0.0000 >, RDec
            <-0.1500, 0.3000, 0.0000 >, 2.0*RDec
            <-0.1500, 0.0000, 0.0000 >, RDec
          } 
          cylinder        {
            < 0.6500, 0.7322, 0.0000 >,
            < 0.9500, 0.7322, 0.0000 >,
            RDec
          }   
          cylinder        {
            < 0.1500, 0.7822, 0.0000 >,
            <-0.1500, 0.6822, 0.0000 >
            RDec
          }
          sphere_sweep    {
            cubic_spline, 6
            < 1.1500, 0.5622, 0.0000 >, RDec
            < 0.8500, 0.6822, 0.0000 >, RDec
            < 0.3000, 0.7322, 0.0000 >, RDec 
            < 0.0000, 0.8122, 0.0000 >, RDec
            <-0.1500, 0.9500, 0.0000 >, 2.0*RDec
            <-0.1500, 1.0000, 0.0000 >, RDec
          }    
          cylinder        {
            < 0.2000, 0.1000, 0.0000 >,
            <-0.1000, 0.2000, 0.0000 >,
            RDec
          }
          cylinder        {
            < 0.2100, 0.1700, 0.0000 >,
            < 0.0000, 0.1000, 0.0000 >,
            RDec
          }    
          #if ( C = 0 )
            scale         <-1,1,1>
          #end 
        }
        #local C          = C+1;
      #end  
      cylinder        {
        < 0.0000, 0.8900, 0.0000 >,
        < 0.0000, 0.9750, 0.0000 >,
        RDec*2
      }
      cylinder        {
        < 0.0000, 0.5000, 0.0000 >,
        < 0.0000, 0.2500, 0.0000 >,
        RDec*2
      }
      scale           < FrenteCruz/2, AltoCruz, 3*ProfundidadCruz > 
      translate       -ProfundidadCruz/2*z
      material        { MaterialGrabado }
    }
    box                 {
      -AltoCruz,        (x+z+0.001)*AltoCruz
    }   
    translate           -0.001*y*AltoCruz
    bounded_by        {
      sphere    { AltoCruz/2*y, 0.75*AltoCruz }
    }
    material            {
      MaterialCruz
    }
  }
#end

#macro CCBR_Crucifijo( MaterialCruz, MaterialGrabado, MaterialBase )
  merge         {
    #local L            = 0.001;
    #local BaseY        = 35*L;
    object      {
      CCBR_CruzPrincipal( MaterialCruz, MaterialGrabado )
      translate         BaseY*y*0.9975
    }
    object      {  
      CCBR_BaseCruz( MaterialBase ) 
    }
  }
#end

#macro CCBR_CrucifijoCristal()
  object                {
    CCBR_Crucifijo( CCBR_DefaultMaterialCristal,
      CCBR_DefaultMaterialCristal2, CCBR_DefaultMaterialCristal )
  }
#end