// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CCBR CrucifijoCristalBlancoResistente
// El archivo dibuja un crucifijo cristiano sencillo,
// lamentablemente no es compatible con POVRay 3.1.
// #macro CCBR_CrucifijoCristal()
//
// La dimensiones del crucifijo son :
//      Alto total              = 172*L;
//      Alto Base               =  35*L;
//      Fondo total             =  50*L;
//      Fondo Crucifijo         =  12*L;
//      Frente                  =  80*L;
// Se dibuja centrado en el eje Y sobre el plano XZ, 
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// Las siguientes macros permiten modificar las texturas facilmente.
// #macro CCBR_Crucifijo( MaterialCruz, MaterialGrabado, MaterialBase )
//      MaterialCruz            : Material principal de la cruz.
//      MaterialGrabado         : Material para el grabado.
//      MaterialBase            : Material para aplicar a la base.
// 
// La siguiente macro dibuja unicamente la base.
// #macro CCBR_BaseCruz( MaterialBase )
//      MaterialBase            : Material para aplicar a la base.
// 
// Esta macro dibuja unicamente la cruz.
// #macro CCBR_CruzPrincipal( MaterialCruz, MaterialGrabado )
//      MaterialCruz            : Material principal de la cruz.
//      MaterialGrabado         : Material para el grabado.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare CCBR_MaterialCristal
//      Material principal del crucifijo de cristal.
// #declare CCBR_MaterialCristal2
//      Material a aplicar a los grabados por diferencia.
//      Se definio como material, para poder usar el mismo
//      que CCBR_MaterialCristal.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CCBR_DefaultMaterialCristal         = material { ... }
//      Material principal del crucifijo.
// #declare TMEE_DefaultMaterialCristal2        = material { ... }
//      Material a utilizar para los grabados.
//
// Para colocarlo simplemente
// #include "CCBR.inc"
// object        { CCBR_CrucifijoCristal() }
//
// Otro ejemplo con modificador
// #include "CCBR.inc"
// #include "textures.inc"
// #declare CCBR_DefaultMaterialCristal         = 
//      material      { texture { PinkAlabaster } }
// #declare CCBR_DefaultMaterialCristal2        =
//      material      { texture { PinkAlabaster } }      
// object        {
//      CCBR_CrucifijoCristal()
// }
//

#include "colors.inc"  

global_settings {
  max_trace_level       15
}

#declare EjeMejorado            = false;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}     
                                        
#include "CCBR.inc"

#local   FactorAcercamiento     = 7.5;

object          {
  CCBR_CrucifijoCristal( ) 
  translate     -0.085*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z
}

