// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 4 setiembre 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CCCU ColganteCucharonesCocinaUtiles
// El archivo dibuja el soporte para colgar un set utensilios de cocina.
// #macro CCCU_SetColgante( BanderaRosa )
//      BanderaRosa             : "on" dibuja un decorado de rosa
//                                "false" dibuja un decorado de circulos.
//                                POVRay 3.1. no interpreta esta alternativa,
//                                y dibuja unicamente el decorado de circulos.
//
// La dimensiones son :
//      Frente                  = 245*L
//      Profundidad             = 19*L
//      Altura modelo Rosa      = +86*L..-64*L
//      Alto modelo Circulos    = +60*L..-64*L
// El objeto descansa casi centrado sobre el plano XY,
// con frente hacia Z- y gravedad Y-.
//
// La siguiente macro permite modificar varias caracteristicas.
// #macro CCCU_ColganteCucharonesCocinaUtiles( BanderaRosa,
//        Frente, AltoMedio, DiametroAlambre, DiametroFino, TotalFlores,
//        DiametroResorte, VueltasResorte,
//        ColumnaSuperior, ColumnaInferior, DiametroColgante,
//        TexturaPrincipal, TexturaSoporte, TexturaRosa )
//      BanderaRosa             : "on" dibuja un decorado de rosa
//                                "false" dibuja un decorado de circulos.
//                                POVRay 3.1. no interpreta esta alternativa,
//                                y dibuja unicamente el decorado de circulos.
//      Frente                  : Referencia para el frente del objeto.
//                                Default es 243*L.
//      AltoMedio               : Referencia para el alto del soporte central.
//                                Default es 36*L.
//      DiametroAlambre         : Grueso del alambre principal.
//                                Default es 2*L.
//      DiametroFino            : Grueso del alambrito para
//                                decoracion superior.  Default es 1.4*L.
//      TotalFlores             : Numero de elementos de decorado.
//                                Default es 5.
//      DiametroResorte         : Referencia para el diametro de la vuelta
//                                de resorte.  Default es 14.3*L.
//      VueltasResorte          : Total de vueltas de resorte.  Default es 4.
//      ColumnaSuperior         : Referencia para el alto de seccion
//                                superior.  Default es 21*L.
//      ColumnaInferior         : Referencia para el alto de seccion
//                                inferior.  Default es 35*L.
//      DiametroColgante        : Referencia para el tamano de la seccion
//                                curva para soporte de cucharones.
//                                Default es 19*L.
//      TexturaPrincipal        : Textura principal a aplicar.
//                                Default es Default_TexturaPrincipal.
//      TexturaSoporte          : Textura a aplicar al soporte medio.
//                                Default es Default_TexturaSoporte.
//      TexturaRosa             : Textura a aplicar al decorado superior.
//                                Default es Default_TexturaRosa.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare CCCU_TexturaPrincipal
//      Textura principal del objeto.
// #declare CCCU_TexturaSoporte
//      Textura a aplicar al soporte medio.
// #declare CCCU_TexturaRosa
//      Textura a aplicar al decorado superior.
// #declare CCCU_ArregloTornillo        = array [2]
//      Arreglo de vectores para ubicar
//      el centro de la arandela para tornillo;  la cara hacia Z-.
//      El elemento 0 en X-, y el 1 en X+.
// #declare CCCU_ArregloColgante        = array [TotalFlores]
//      Arreglo de vectores para facilitar colgar objetos.
//      Orden desde X- hacia X+.
//      El vector se ubica en el punto extremo inferior del colgante,
//      directamente sobre el metal.  Considere que esta zona es
//      una curva circular de radio ( DiametroColgante-DiametroAlambre )/2.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare TMEE_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal del objeto.
// #declare TMEE_DefaultTexturaSoporte          = texture { ... }
//      Textura del soporte medio.
// #declare TMEE_DefaultTexturaRosa             = texture { ... }
//      Textura a aplicar a la decoracion superior.
//
// Para colocarlo simplemente
// #include "CCCU.inc"
// object        { CCCU_SetColgante( on ) }
//
// Otro ejemplo con modificador
// #include "CCCU.inc"
// #declare CCCU_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 CCCU_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      CCCU_SetColgante( off )
// }
//
// Otro ejemplo con macro larga
// #include "CCCU.inc"
// #include "textures.inc"
// object             {
//   CCCU_ColganteCucharonesCocinaUtiles
//     ( on, 0.243, 0.036, 0.002, 0.0014, 5, 0.0143, 4, 0.021, 0.035, 0.019,
//                      PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#declare CCCU_L                 = 0.001;
#include "colors.inc"
#include "textures.inc"

#if ( version < 3.2 )
  #ifndef( CCCU_POV3_1 )
    #declare CCCU_POV3_1        = on;
  #end
#else
  #ifndef( CCCU_POV3_1 )
    #declare CCCU_POV3_1        = off;
  #end    
#end

#declare CCCU_TexturaPrincipal                  = texture       {
  pigment               {
    Silver*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.05
  }
  finish                {
    specular            1.0
    roughness           0.05
    metallic
  }
}

#ifndef ( CCCU_DefaultTexturaPrincipal )
  #declare CCCU_DefaultTexturaPrincipal         = texture       {
    CCCU_TexturaPrincipal
  }
#end

#declare CCCU_TexturaSoporte            = texture       {
  PinkAlabaster
}

#ifndef ( CCCU_DefaultTexturaSoporte )
  #declare CCCU_DefaultTexturaSoporte           = texture       {
    CCCU_TexturaSoporte
  }
#end

#declare CCCU_TexturaRosa               = texture       {
  pigment               {
    Silver*0.60+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.02
  }
  finish                {
    specular            1.0
    roughness           0.02
    metallic
  }
}

#ifndef ( CCCU_DefaultTexturaRosa )
  #declare CCCU_DefaultTexturaRosa              = texture       {
    CCCU_TexturaRosa
  }
#end


#macro CCCU_Resorte( RadioResorte, PasoResorte, MediasVueltas, Grueso )
  // El resorte alineado en Y+ comenzara en <RadioResorte,0,0> y
  // enrosca antihorario
  union         {
    #local Paridad      = false;
    #local C            = 0;
    #local RadioReal    = sqrt( RadioResorte*RadioResorte
                                +PasoResorte*PasoResorte/16 );
    #local AnguloReal   = degrees( asin( 0.25*PasoResorte/RadioReal ) );
    #while ( C < MediasVueltas )
      difference        {
        torus               {
          RadioResorte          , Grueso/2
        }
        plane               {
          -z, 0
        }
        scale         < RadioReal/RadioResorte, 1, 1 >
        rotate          -AnguloReal*z
        #if ( Paridad )
          scale         <1,-1,-1>
        #end
        translate       0.5*( C+0.5 )*PasoResorte*y
        translate       -MediasVueltas/2*PasoResorte/2*y
      }
      #local Paridad    = ( !Paridad );
      #local C          = C+1;
    #end
  }
#end

#macro CCCU_ColganteCucharonesCocinaUtiles( BanderaRosa,
        Frente, AltoMedio, DiametroAlambre, DiametroFino, TotalFlores,
        DiametroResorte, VueltasResorte,
        ColumnaSuperior, ColumnaInferior, DiametroColgante,
        TexturaPrincipal, TexturaSoporte, TexturaRosa )
  union                 {
    #local PasoResorte  = ( 16/36*AltoMedio )/VueltasResorte;
    #local SeparacionFlores     =
                ( Frente-43/36*AltoMedio )/( TotalFlores-1 );
    #declare CCCU_ArregloTornillo       = array [4]
    union               {
      cylinder            {
        -( Frente/2-AltoMedio/2 )*x,
        +( Frente/2-AltoMedio/2 )*x,
        DiametroAlambre/2
        translate         +AltoMedio/2*y-DiametroAlambre/2*z
      }
      cylinder            {
        -( Frente/2-AltoMedio/2 )*x,
        +( Frente/2-AltoMedio/2 )*x,
        DiametroAlambre/2
        translate         -AltoMedio/2*y-DiametroAlambre/2*z
      }
      // Union para elementos simetricos no quintuplicados
      #local C            = 0;
      #while ( C < 2 )
        union             {
          // Arandela
          difference              {
            #local RadioSoporteTornillo   = 13/36*AltoMedio/2;
            #local PerforacionTornillo    = 5/13*RadioSoporteTornillo;
            cylinder              {
              0                   , +DiametroAlambre/4*z  ,
              RadioSoporteTornillo
            }
            cylinder              {
              +DiametroAlambre*z  , -DiametroAlambre*z    ,
              PerforacionTornillo
            }
            translate             ( Frente/2-RadioSoporteTornillo )*x
            #declare CCCU_ArregloTornillo[C]    = ( 2*C-1 )*
                                ( Frente/2-RadioSoporteTornillo )*x
                                -DiametroAlambre/4*z;
          }
          difference            {
            torus               {
              AltoMedio/2       , DiametroAlambre/2
              rotate            90*x
            }
            plane               {
              x, 0
            }
            translate           ( Frente/2-AltoMedio/2 )*x
                                -DiametroAlambre/2*z
          }
          #if ( C = 0 )
            scale         <-1,1,1>
          #end
        }
        #local C          = C+1;
      #end
      texture   {
        TexturaSoporte
      }
    }
    // Resorte
    #declare CCCU_ArregloColgante       = array [TotalFlores]
    #local D            = 0;
      #while ( D < TotalFlores )
        union           {
          #local MediasVueltas  = 2*VueltasResorte-1;
          object              {
            CCCU_Resorte( DiametroResorte/2, PasoResorte,
                            MediasVueltas, DiametroAlambre )
          }
          #local PuntoGuiaInf   =
                        -MediasVueltas/2*PasoResorte/2*y;
          #local PuntoGuiaSup   = PuntoGuiaInf*<1,-1,1>;
          #if ( CCCU_POV3_1 )
            #local CC           = 0;
            #while ( CC < 2 )
              union       {
                sphere      {
                  0.5*DiametroResorte*x          , DiametroAlambre/2
                  translate PuntoGuiaInf
                }
                cylinder    {
                  0.5*DiametroResorte*x          ,
                  -PasoResorte*y+0.5*DiametroResorte*z,
                  DiametroAlambre/2
                  translate PuntoGuiaInf
                }
                sphere      {
                  -PasoResorte*y+0.5*DiametroResorte*z,
                  DiametroAlambre/2
                  translate PuntoGuiaInf
                }
                #if ( CC = 0 )
                    scale   <-1,-1,1>
                #end
              }
              #local CC         = CC+1;
            #end
          #else   
            #local PuntoA     = PuntoGuiaInf+0.5*DiametroResorte*x;
            #local PuntoB     =
                        PuntoGuiaInf-PasoResorte*y+0.5*DiametroResorte*z;  
            #local CC           = 0;
            #while ( CC < 2 )            
              sphere_sweep        {
                cubic_spline 
                4,
                PuntoA+( PuntoB-PuntoA )*<1,-1,1> , DiametroAlambre/2,
                PuntoA                    , DiametroAlambre/2       ,
                PuntoB                    , DiametroAlambre/2       ,
                PuntoB+( PuntoA-PuntoB )*<1,-1,1> , DiametroAlambre/2       
                #if ( CC = 0 )
                    scale   <-1,-1,1>
                #end
              }   
              #local CC         = CC+1;
            #end
          #end
          cylinder          {
            PuntoGuiaInf-PasoResorte*y      ,
            -AltoMedio/2*y-ColumnaInferior*y,
            DiametroAlambre/2
            translate       0.5*DiametroResorte*z
          }
          cylinder          {
            PuntoGuiaSup+PasoResorte*y      ,
            +AltoMedio/2*y+ColumnaSuperior*y,
            DiametroAlambre/2
            translate       0.5*DiametroResorte*z
          }
          // Decoracion Flor 
          #local ColumnaDecoracion      =  35/50*SeparacionFlores;
          #if ( CCCU_POV3_1 | !BanderaRosa )
            #local CC         = 0;
            #while ( CC< 8 )
              torus           {
                0.5*ColumnaDecoracion/2 , DiametroFino/2
                rotate        90*x
                rotate          5*y
                translate     -0.25*ColumnaDecoracion*y
                rotate        360*CC/8*z
                translate       +0.50*ColumnaDecoracion*y
                                +AltoMedio/2*y+ColumnaInferior/2*y
                                +DiametroResorte/2*z
                                -( DiametroAlambre+DiametroFino )/2*z
                texture         {
                  TexturaRosa
                }
              }
              #local CC       = CC+1;
            #end
          #else  
            union               {
              #local DatoGuia   = 
                  < ColumnaDecoracion, ColumnaDecoracion, DiametroFino >;
              sphere_sweep      {
                cubic_spline
                12,
                <0,-1.0,0>*DatoGuia, DiametroFino/2,
                <0,-0.5,0>*DatoGuia, DiametroFino/2,
                <0,0,0>*DatoGuia, DiametroFino/2,
                <0.375,+0.3,0>*DatoGuia, DiametroFino/2,
                <0.30,+0.9,0>*DatoGuia, DiametroFino/2,
                <0.15,+0.775,0>*DatoGuia, DiametroFino/2,
                <0,+0.9,0>*DatoGuia, DiametroFino/2,
                <-0.15,+0.775,0>*DatoGuia, DiametroFino/2,
                <-0.30,+0.9,0>*DatoGuia, DiametroFino/2,
                <-0.375,+0.3,0>*DatoGuia, DiametroFino/2,
                <0,0,-1>*DatoGuia, DiametroFino/2,
                <+0,-0.5,2>*DatoGuia, DiametroFino/2               
              }      
              sphere_sweep      {
                cubic_spline
                9,
                <+0.35,-0.35,-1>*DatoGuia, DiametroFino/2,
                <0,-0.45,-1>*DatoGuia, DiametroFino/2,
                <-0.35,-0.35,-1>*DatoGuia, DiametroFino/2,
                <-0.6,+0.10,-1>*DatoGuia, DiametroFino/2,
                <0,-0.20,-1>*DatoGuia, DiametroFino/2,
                <+0.6,+0.10,-1>*DatoGuia, DiametroFino/2,
                <+0.35,-0.35,-1>*DatoGuia, DiametroFino/2,                
                <0,-0.45,-1>*DatoGuia, DiametroFino/2,
                <-0.35,-0.35,-1>*DatoGuia, DiametroFino/2
              }
              #local Azar       = seed( 10 );
              scale             ( 0.95+0.10*( rand( Azar ) ) )*y
              rotate            2*(<0.5,rand(Azar),rand(Azar)>-0.5)
              translate       +0.50*ColumnaDecoracion*y
                              +AltoMedio/2*y+36/21*ColumnaSuperior/2*y
                              +DiametroResorte/2*z
                              -( DiametroAlambre+DiametroFino )/2*z                
              texture   {
                TexturaRosa
              }
            }
          #end
          // estructura colgante final
          union         {
            union               {
              cylinder          {
                0       , 0.75*DiametroColgante*y  ,
                DiametroAlambre/2
              }
              sphere            {
                0.75*DiametroColgante*y    ,
                DiametroAlambre
              }
              translate         -DiametroColgante/2*z
              rotate    -20*x
            }
            difference          {
              torus             {
                DiametroColgante/2      , DiametroAlambre/2
                rotate          90*z
              }
              plane             {
                -y               , 0
              }
              plane             {
                -y              , 0
                rotate  -20*x
              }
            }
            translate   -AltoMedio/2*y-ColumnaInferior*y
                        -1.5*DiametroAlambre*z
          }
         // rotate        90*y
          translate     ( D-0.5*( TotalFlores-1 ) )*SeparacionFlores*x
          translate     -DiametroResorte/2*z-DiametroAlambre*z
          #declare CCCU_ArregloColgante[ D ]    =
                     -AltoMedio/2*y-ColumnaInferior*y-DiametroAlambre*z
                       +( D-0.5*( TotalFlores-1 ) )*SeparacionFlores*x
                        -DiametroResorte/2*z-DiametroAlambre*z
                     -DiametroColgante/2*y+DiametroAlambre/2*y
                     -DiametroAlambre/4*z;
        }
      #local D          = D+1;
    #end
    texture             {
      TexturaPrincipal
    }
    // Para acomodar arandela
    translate           -DiametroAlambre/4*z
  }
#end

#macro CCCU_SetColgante( BanderaRosa )
  object                {
    #local L                    = CCCU_L;
    #local Frente               = 243*L;
    #local AltoMedio            = 36*L;
    #local DiametroAlambre      = 2*L;
    #local DiametroFino         = 1.4*L;
    #local DiametroResorte      = 14.3*L;
    #local VueltasResorte       = 4;
    #local TotalFlores          = 5;
    #local ColumnaSuperior      = 21*L;
    #local ColumnaInferior      = 35*L;
    #local DiametroColgante     = 19*L;
    CCCU_ColganteCucharonesCocinaUtiles( BanderaRosa,
      Frente, AltoMedio, DiametroAlambre, DiametroFino, TotalFlores,
      DiametroResorte, VueltasResorte,
      ColumnaSuperior, ColumnaInferior, DiametroColgante,
      CCCU_DefaultTexturaPrincipal,
      CCCU_DefaultTexturaSoporte,
      CCCU_DefaultTexturaRosa
    )
  }
#end

