// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 4 setiembre 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CCCU ColganteCucharonesCocinaUtiles
// El archivo dibuja el soporte para colgar un set utensilios de cocina.
// #macro CCCU_SetColgante( BanderaRosa )
//      BanderaRosa             : "on" dibuja un decorado de rosa
//                                "false" dibuja un decorado de circulos.
//                                POVRay 3.1. no interpreta esta alternativa,
//                                y dibuja unicamente el decorado de circulos.
//
// La dimensiones son :
//      Frente                  = 245*L
//      Profundidad             = 19*L
//      Altura modelo Rosa      = +86*L..-64*L
//      Alto modelo Circulos    = +60*L..-64*L
// El objeto descansa casi centrado sobre el plano XY,
// con frente hacia Z- y gravedad Y-.
//
// La siguiente macro permite modificar varias caracteristicas.
// #macro CCCU_ColganteCucharonesCocinaUtiles( BanderaRosa,
//        Frente, AltoMedio, DiametroAlambre, DiametroFino, TotalFlores,
//        DiametroResorte, VueltasResorte,
//        ColumnaSuperior, ColumnaInferior, DiametroColgante,
//        TexturaPrincipal, TexturaSoporte, TexturaRosa )
//      BanderaRosa             : "on" dibuja un decorado de rosa
//                                "false" dibuja un decorado de circulos.
//                                POVRay 3.1. no interpreta esta alternativa,
//                                y dibuja unicamente el decorado de circulos.
//      Frente                  : Referencia para el frente del objeto.
//                                Default es 243*L.
//      AltoMedio               : Referencia para el alto del soporte central.
//                                Default es 36*L.
//      DiametroAlambre         : Grueso del alambre principal.
//                                Default es 2*L.
//      DiametroFino            : Grueso del alambrito para
//                                decoracion superior.  Default es 1.4*L.
//      TotalFlores             : Numero de elementos de decorado.
//                                Default es 5.
//      DiametroResorte         : Referencia para el diametro de la vuelta
//                                de resorte.  Default es 14.3*L.
//      VueltasResorte          : Total de vueltas de resorte.  Default es 4.
//      ColumnaSuperior         : Referencia para el alto de seccion
//                                superior.  Default es 21*L.
//      ColumnaInferior         : Referencia para el alto de seccion
//                                inferior.  Default es 35*L.
//      DiametroColgante        : Referencia para el tamano de la seccion
//                                curva para soporte de cucharones.
//                                Default es 19*L.
//      TexturaPrincipal        : Textura principal a aplicar.
//                                Default es Default_TexturaPrincipal.
//      TexturaSoporte          : Textura a aplicar al soporte medio.
//                                Default es Default_TexturaSoporte.
//      TexturaRosa             : Textura a aplicar al decorado superior.
//                                Default es Default_TexturaRosa.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare CCCU_TexturaPrincipal
//      Textura principal del objeto.
// #declare CCCU_TexturaSoporte
//      Textura a aplicar al soporte medio.
// #declare CCCU_TexturaRosa
//      Textura a aplicar al decorado superior.
// #declare CCCU_ArregloTornillo        = array [2]
//      Arreglo de vectores para ubicar
//      el centro de la arandela para tornillo;  la cara hacia Z-.
//      El elemento 0 en X-, y el 1 en X+.
// #declare CCCU_ArregloColgante        = array [TotalFlores]
//      Arreglo de vectores para facilitar colgar objetos.
//      Orden desde X- hacia X+.
//      El vector se ubica en el punto extremo inferior del colgante,
//      directamente sobre el metal.  Considere que esta zona es
//      una curva circular de radio ( DiametroColgante-DiametroAlambre )/2.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare TMEE_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal del objeto.
// #declare TMEE_DefaultTexturaSoporte          = texture { ... }
//      Textura del soporte medio.
// #declare TMEE_DefaultTexturaRosa             = texture { ... }
//      Textura a aplicar a la decoracion superior.
//
// Para colocarlo simplemente
// #include "CCCU.inc"
// object        { CCCU_SetColgante( on ) }
//
// Otro ejemplo con modificador
// #include "CCCU.inc"
// #declare CCCU_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 CCCU_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      CCCU_SetColgante( off )
// }
//
// Otro ejemplo con macro larga
// #include "CCCU.inc"
// #include "textures.inc"
// object             {
//   CCCU_ColganteCucharonesCocinaUtiles
//     ( on, 0.243, 0.036, 0.002, 0.0014, 5, 0.0143, 4, 0.021, 0.035, 0.019,
//                      PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare EjeMejorado            = false;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "CCCU.inc"

#local FactorAcercamiento       = 7;

object          {
  CCCU_SetColgante( on )
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z
}


