// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 4 junio 2012
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// CEUP_Au1.inc           archivo original
// CEUP_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// CEUP_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// CEUP_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// CEUP_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// CEUP_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CEUP CaminadoraEjecicioUniPersonal
// Dibuja una caminadora para ejercicios a nivel domstico.
// Incluye macros de textura y permite modificaciones leves.
// #macro CEUP_Caminadora( FraccionElevacion, FactorAvance, F1, F2 )
//      FraccionElevacion       : Fraccion entre cero y uno...
//              que permite "bajar" (0.0) o "recoger" (1.0)
//              la tabla de ejercicio.
//      FactorAvance            : Para simular el movimiento de la andadera
//              desplaza linealmente la textura en unidades L.
//              Utiliza un valor float positivo.
//              La textura se desplazara hacia X- con
//              translate -FactorAvance*x.
//      F1                      : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona delantera de izquierda a derecha.
//      F2                      : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona posterior de izquierda a derecha.
//
// Las dimensiones de la caminadora depende si esta extendida o no.
// Caminadora extendida :
// Frente               451*L
// Alto                 920*L
// Profundidad          980*L
// Caminadora recogida  :
// Frente               451*L
// Alto                 970*L
// Profundidad          450*L
// Por defecto se ubica sobre el plano XZ, sobresaliendo hacia X-
// con gravedad Y- y centrada con respecto al eje X.
// El avance virtual del potencial usuario seria hacia X+.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro CEUP_CaminadoraEjercicioUniPersonal
//        ( Ancho, ProfundidadP, Altura, RadioBotella,
//          FraccionEje, LargoTabla,
//          F1,F2, FraccionElevacion, FactorAvance,
//          TexturaPrincipal, TexturaBaseTabla,
//          TexturaMetalizada, TexturaPlastica,
//          TexturaNegra, TexturaFirme, TexturaBoton,
//          TexturaPantalla, TexturaBanda )
//      Ancho           : Referencia para el frente de la caminadora.
//              Default es 408*L.
//      ProfundidadP    : Referencia para la profundidad de la base
//              de la caminadora.  Default es 300*L.
//      Altura          : Referencia para la altura de la caminadora.
//              Default es 787*L.
//      RadioBotella    : Radio para una botellita de agua (no incluida)
//              de la caminadora.  Default 25*L.
//      FraccionEje     : Altura como fraccion del eje de la tabla
//              deslizante.  Default es 136/787.
//      LargoTabla      : Referencia para el largo de la tabla deslizante.
//              Default es 894*L.
//      F1              : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona delantera de izquierda a derecha.
//      F2              : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona posterior de izquierda a derecha.
//      FraccionElevacion       : Fraccion entre cero y uno...
//              que permite "bajar" (0.0) o "recoger" (1.0)
//              la tabla de ejercicio.
//      FactorAvance            : Para simular el movimiento de la andadera
//              desplaza linealmente la textura en unidades L.
//              Utiliza un valor float positivo.
//              La textura se desplazara hacia X- con
//              translate -FactorAvance*x.
//      TexturaPrincipal        : Textura principal del aparato.
//              Default es CEUP_DefaultTexturaPrincipal.
//      TexturaBaseTabla        : Textura a aplicar a la base principal
//              de la tabla deslizante.
//              Default es CEUP_DefaultTexturaBaseTabla.
//      TexturaMetalizada       : Textura a aplicar a ciertos
//              elementos metalizados de la estructura.
//              Default es CEUP_DesfultTexturaMetalizada.
//      TexturaPlastica         : Textura a aplicar a ciertos elementos
//              plasticos de la estructura.  Por ejemplo, las ruedas,
//              controles, soportes, etc.
//              Default es CEUP_DefaultTexturaPlastica.
//      TexturaNegra            : Textura a aplicar a elementos de caucho.
//              Los que sirven de agarre para las manos.
//              Default es CEUP_DefaultTexturaNegra.
//      TexturaFirme            : Textura a aplicar a la base firme
//              de la tabla deslizante.
//              Default es CEUP_DefaultTexturaFirme.
//      TexturaBoton            : Textura para los botones de control.
//              Default es CEUP_DefaultTexturaBoton.
//      TexturaPantalla         : Textura a aplicar a la pantalla.
//              Se aplica por diferencia.
//              Default es CEUP_DefaultTexturaPantalla.
//      TexturaBanda            : Textura a aplicar a la banda deslizante.
//              Sobre esta textura aplica translate -FactorAvance*x.
//              Default es CEUP_DefaultTexturaBanda.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// CEUP_TexturaPrincipal
//      Textura principal del aparato.
// CEUP_TexturaBaseTabla
//      Textura a aplicar a la base principal de la tabla de ejercicios.
// CEUP_TexturaMetalizada
//      Textura a aplicar a ciertos
//      elementos metalizados de la estructura.
// CEUP_TexturaPlastica
//      Textura a aplicar a ciertos elementos
//      plasticos de la estructura.  Por ejemplo, las ruedas,
//      controles, soportes, etc.
// CEUP_TexturaNegra
//      Textura a aplicar a elementos de caucho.
//      Los que sirven de agarre para las manos.
// CEUP_TexturaFirme
//      Textura a aplicar a la base firme de la tabla deslizante.
// CEUP_TexturaBoton
//      Textura para los botones de control.
// CEUP_TexturaPantalla
//      Textura a aplicar a la pantalla.  Se aplica por diferencia.
// CEUP_TexturaBanda
//      Textura a aplicar a la banda deslizante.
//      Sobre esta textura aplica translate -FactorAvance*x.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare CEUP_DefaultTexturaPrincipal               =
//              texture { CEUP_TexturaPrincipal }
//      Textura principal del aparato.
// #declare CEUP_DefaultTexturaBaseTabla               =
//              texture { CEUP_TexturaBaseTabla }
//      Textura a aplicar a la base principal de la tabla de ejercicio.
// #declare CEUP_DefaultTexturaMetalizada              =
//              texture { CEUP_TexturaMetalizada }
//      Textura a aplicar a ciertos
//      elementos metalizados de la estructura.
// #declare CEUP_DefaultTexturaPlastica                =
//              texture { CEUP_TexturaPlastica }
//      Textura a aplicar a ciertos elementos
//      plasticos de la estructura.  Por ejemplo, las ruedas,
//      controles, soportes, etc.
// #declare CEUP_DefaultTexturaNegra                   =
//              texture { CEUP_TexturaNegra }
//      Textura a aplicar a elementos de caucho.
//      Los que sirven de agarre para las manos.
// #declare CEUP_DefaultTexturaFirme                   =
//              texture { CEUP_TexturaFirme }
//      Textura a aplicar a la base firme de la tabla deslizante.
// #declare CEUP_DefaultTexturaBoton                   =
//              texture { CEUP_TexturaBoton }
//      Textura para los botones de control.
// #declare CEUP_DefaultTexturaPantalla                =
//              texture { CEUP_TexturaPantalla }
//      Textura a aplicar a la pantalla.  Se aplica por diferencia.
// #declare CEUP_DefaultTexturaBanda                   =
//              texture { CEUP_TexturaBanda }
//      Textura a aplicar a la banda deslizante.
//      Sobre esta textura aplica translate -FactorAvance*x.
// #declare CEUP_AnguloColores
//      Valor real, que aplica solo si se define.
//      En los colores de control de la perilla.
//      #ifdef ( CEUP_AnguloColores )
//        rotate        CEUP_AnguloColores*z
//      #end
// #declare CEUP_TexturaPerilla
//      Textura que se aplica solo si se define.
//      Para modificar la perilla.  Se aplica antes
//      de escalar en una perilla de radio 0.65,
//      cuando sale del origen hacia Z-.
//      #ifdef ( CEUP_TexturaPerilla )
//        texture       { CEUP_TexturaPerilla }
//      #end
// #declare CEUP_TexturaControl
//      Textura que se aplica solo si se define.
//      Para modificar los controles.
//      #ifdef ( CEUP_TexturaControl )
//        texture       { CEUP_TexturaControl }
//      #end
// #declare CEUP_GifBoton        = "CEUP_IM1.GIF"
//      Imagen GIF que se aplica a los controles.
//      No aplica si define CEUP_TexturaControl.
// #declare CEUP_AnguloMayor     = 97.5;
//      Angulo de rotacion de la tabla, cuando se cierra.
//      Podria ser necesario modificarlo si se cambian las caracteristicas,
//      por defecto.
//
// Para colocarlo simplemente
// #include "CEUP.inc"
// object        { CEUP_Caminadora( 0,0,0,0 ) }
//
// Otro ejemplo con modificador
// #include "CEUP.inc"
// #declare CEUP_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 CEUP_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      CEUP_Caminadora( 0,0,-0.5,0.6)
// }
//
// Otro ejemplo con macro de texturas
// #include "CEUP.inc"
// #include "textures.inc"
// object             {
//   CEUP_CaminadoraEjercicioUniPersonal
//      ( 0.408, 0.300, 0.787, 0.025, 0.18, 0.894, 0, 0, 0, 0,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"
#include "CEUP_AU1.inc"
#include "metals.inc"

#declare CEUP_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( CEUP_POV3_1 )
    #declare CEUP_POV3_1        = on;
  #end
#else
  #ifndef( CEUP_POV3_1 )
    #declare CEUP_POV3_1        = off;
  #end    
#end

//          rotate        CEUP_AnguloColores*z
//        CEUP_TexturaPerilla

#ifndef ( CEUP_GifBoton )
  #declare CEUP_GifBoton        = "CEUP_IM1.GIF"
#end

#ifndef ( CEUP_AnguloMayor )
  #declare CEUP_AnguloMayor     = 97.5;
#end

#declare CEUP_TexturaPrincipal                  = texture       {
  pigment               {
    Silver*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.01
    scale               1
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaPrincipal )
  #declare CEUP_DefaultTexturaPrincipal         = texture       {
    CEUP_TexturaPrincipal
  }
#end

#declare CEUP_TexturaBaseTabla                  = texture       {
  pigment               {
    Silver*0.50+GreenCopper*0.50
  }
  normal                {
    bumps
    rotate      100
    turbulence          0.01
    scale               0.3
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaBaseTabla )
  #declare CEUP_DefaultTexturaBaseTabla         = texture       {
    CEUP_TexturaBaseTabla
  }
#end

#declare CEUP_TexturaMetalizada                 = texture       {
  pigment               {
    Silver*0.70+GreenCopper*0.30
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaMetalizada )
  #declare CEUP_DefaultTexturaMetalizada        = texture       {
    CEUP_TexturaMetalizada
  }
#end

#declare CEUP_TexturaPlastica                   = texture       {
  pigment               {
    Gray35*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.1
  }
}

#ifndef ( CEUP_DefaultTexturaPlastica )
  #declare CEUP_DefaultTexturaPlastica          = texture       {
    CEUP_TexturaPlastica
  }
#end

#declare CEUP_TexturaBanda                      = texture       {
  pigment               {
    Gray35*0.80+GreenCopper*0.20
  }
  normal                {
    gradient  x
    sine_wave
    turbulence          0.05
    scale               0.01
  }
}

#ifndef ( CEUP_DefaultTexturaBanda    )
  #declare CEUP_DefaultTexturaBanda             = texture       {
    CEUP_TexturaBanda
  }
#end

#declare CEUP_TexturaNegra                      = texture       {
  pigment               {
    Gray15*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaNegra )
  #declare CEUP_DefaultTexturaNegra             = texture       {
    CEUP_TexturaNegra
  }
#end

#declare CEUP_TexturaFirme                      = texture       {
  pigment               {
    Gray15*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaFirme )
  #declare CEUP_DefaultTexturaFirme             = texture       {
    CEUP_TexturaFirme
  }
#end

#declare CEUP_TexturaBoton                      = texture       {
  pigment               {
    Green
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaBoton )
  #declare CEUP_DefaultTexturaBoton             = texture       {
    CEUP_TexturaBoton
  }
#end

#declare CEUP_TexturaPantalla                   = texture       {
  pigment               {
    White*0.6+Green*0.2
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.1
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( CEUP_DefaultTexturaPantalla )
  #declare CEUP_DefaultTexturaPantalla          = texture       {
    CEUP_TexturaPantalla
  }
#end

#macro CEUP_ImplementationUInvertida
        ( Ancho, Profundidad, RadioCurva, Diametro )
  union                 {
    cylinder            {
      -( Ancho/2-RadioCurva )*z         ,
      +( Ancho/2-RadioCurva )*z         ,
      Diametro/2
    }
    cylinder            {
      -RadioCurva*x                     ,
      -Profundidad*x                    ,
      Diametro/2
      translate         +Ancho/2*z
    }
    cylinder            {
      -RadioCurva*x                     ,
      -Profundidad*x                    ,
      Diametro/2
      translate         -Ancho/2*z
    }
    #local C            = 0;
    #while ( C < 2 )
      difference          {
        torus             {
          RadioCurva      , Diametro/2
        }
        plane             {
          x               , 0
        }
        plane             {
          z               , 0
        }
        translate         +( Ancho/2-RadioCurva )*z
                          -RadioCurva*x
        #if ( C = 0 )
          scale           <1,1,-1>
        #end
      }
      #local C          = C+1;
    #end
  }
#end

#macro CEUP_ImplementationControlador
        ( Ancho, Profundidad, Alto, RadioDecorativo, RadioBotella,
                TexturaPlastica, TexturaMetalizada, TexturaPantalla,
                TexturaBoton )
  difference            {
    union                 {
      box                 {
        <-Profundidad/2   , 0                     ,
                  -Ancho/2        >,
        <+Profundidad/2   , Alto-RadioDecorativo  ,
                  +Ancho/2        >
      }
      cylinder            {
        -Ancho/2*z        , +Ancho/2*z            ,
        RadioDecorativo
        translate         +( Profundidad/2-RadioDecorativo )*x
                          +( Alto-RadioDecorativo )*y
      }
      cylinder            {
        -Ancho/2*z        , +Ancho/2*z            ,
        RadioDecorativo
        translate         -( Profundidad/2-RadioDecorativo )*x
                          +( Alto-RadioDecorativo )*y
      }
      torus               {
        ( Profundidad/2-RadioDecorativo   ),
        RadioDecorativo
        translate         +Ancho/2*z+( Alto-RadioDecorativo )*y
      }
      torus               {
        ( Profundidad/2-RadioDecorativo   ),
        RadioDecorativo
        translate         -Ancho/2*z+( Alto-RadioDecorativo )*y
      }
      box                 {
        <-Profundidad/2+RadioDecorativo   , 0                     ,
                  -Ancho/2        >,
        <+Profundidad/2-RadioDecorativo   , Alto                  ,
                  +Ancho/2        >
      }
      cylinder            {
        0                 ,
        +Alto*y           ,
        Profundidad/2-RadioDecorativo
        translate         +Ancho/2*z
      }
      cylinder            {
        0                 ,
        +Alto*y           ,
        Profundidad/2-RadioDecorativo
        translate         -Ancho/2*z
      }
      cylinder            {
        0                 ,
        +( Alto-RadioDecorativo )*y        ,
        Profundidad/2
        translate         +Ancho/2*z
      }
      cylinder            {
        0                 ,
        +( Alto-RadioDecorativo )*y        ,
        Profundidad/2
        translate         -Ancho/2*z
      }
      box               {
        <-0.3*Profundidad       , Alto*0.3      , -Ancho/4  >,
        <+Profundidad/2       , Alto*1.2      , +Ancho/4 >
      }
      difference        {
        box               {
          <-0.2*Profundidad       , Alto*0.3      , -Ancho/5  >,
          <+Profundidad/2       , Alto*1.5      , +Ancho/5 >
        }
        box               {
          <-0.2       , 1.45      , -0.2 >,
          <+0.5       , 1.51      , +0.2 >
          #ifdef ( CEUP_TexturaControl )
            texture     {
              CEUP_TexturaControl
            }
          #else
            texture       { 
              pigment                 {
                image_map             {
                  gif CEUP_GifBoton
                }
                rotate    90*x
                rotate    90*y
                //rotate    
                scale     <0.7,1,0.4>
                translate   -0.2*x-0.2*z
              }
            }
          #end
          scale         <Profundidad*0.9,Alto,Ancho*0.9>
        }
        superellipsoid  {
          <0.4,0.4>
          scale         <0.1*Profundidad,0.05*Alto,Ancho/8>
          translate     Alto*1.45*y
                        +0.30*Profundidad*x
          texture       {
            TexturaPlastica
          }
        }
        box             {
          -<0.1*Profundidad*0.70,0.051*Alto,Ancho/8*0.8>,
          +<0.1*Profundidad*0.70,0.051*Alto,Ancho/8*0.8>
          translate     Alto*1.45*y
                        +0.30*Profundidad*x
          texture       {
            TexturaPantalla
          }
        }
        texture         {
          TexturaPlastica
        }
      }
    }
    sphere              {
      0 , 0.03*Ancho 
      scale     <1,0.30,1>
      translate     <0.1*Profundidad*0.9,1.45*Alto,+0.125*Ancho*0.9>
      texture           {
        TexturaBoton
      }
    }
    sphere              {
      0 , 0.03*Ancho 
      scale     <1,0.30,1>
      translate     <0.1*Profundidad*0.9,1.45*Alto,+0.025*Ancho*0.9>
      texture           {
        TexturaBoton
      }
    }
    sphere              {
      0 , 0.03*Ancho 
      scale     <1,0.30,1>
      translate     <-0.07*Profundidad*0.9,1.45*Alto,-0.025*Ancho*0.9>
      texture           {
        TexturaBoton
      }
    }
    sphere              {
      0 , 0.03*Ancho 
      scale     <1,0.30,1>
      translate     <-0.07*Profundidad*0.9,1.45*Alto,-0.125*Ancho*0.9>
      texture           {
        TexturaBoton
      }
    }
    cylinder            {
      -Alto*y           , +2*Alto*y     ,
      RadioBotella
      translate         -Ancho/2*z
    }
    #local C            = 0;
    #while ( C < 2 )
      union             {
        cylinder        {
          +0.1*Alto*y   , +2*Alto*y     ,
          RadioBotella*1.05
          translate     +Ancho/2*z
                        +( Profundidad/2-2*RadioDecorativo-RadioBotella )*x
        }
        cylinder        {
          +0.1*Alto*y   , +2*Alto*y     ,
          RadioBotella*1.05
          translate     +Ancho/2*z
                        -( Profundidad/2-2*RadioDecorativo-RadioBotella )*x
        }
        box             {
          < -( Profundidad/2-2*RadioDecorativo-RadioBotella ),
            0.1*Alto    , -RadioBotella*1.05 >,
          < +( Profundidad/2-2*RadioDecorativo-RadioBotella ),
            2.0*Alto    , +RadioBotella*1.05 >
          translate     +Ancho/2*z
        }
        #if ( C = 1 )
          translate     +0.8*Alto*y
          scale         <1,1,-1>
        #end
      }
      #local C          = C+1;
    #end
    texture             {
      TexturaPlastica
    }
  }
#end

#macro CEUP_ImplementationDeslizante
        ( F1, F2, Ancho, Largo, Alto, FactorAvance, TexturaBanda )
  difference            {
    union       {
      box         {
        <0,-Alto/2,-Ancho/2>,
        <-Largo,Alto/2,Ancho/2>
      }
      cylinder    {
        -Ancho/2*z,+Ancho/2*z,Alto/2
        translate         -Largo*x
      }
      cylinder    {
        -Ancho/2*z,+Ancho/2*z,Alto/2
      }
    }
    box         {
        <0,-Alto/2,-Ancho/2>,
        <-Largo,Alto/2,Ancho/2>
        scale   0.995
    }
    #local MayorDesplazamiento  = Ancho/18;
    #local Corr                 = MayorDesplazamiento/Largo;
    texture     {
      TexturaBanda
      translate -FactorAvance*x
    }
    matrix      <
      1,0,(F2-F1)*Corr,
      0,1,0,
      0,0,1,
      0,0,-F1*MayorDesplazamiento
    >
  }  
#end

#macro CEUP_ImplementationPerilla( TexturaPlastica )
  union                 {
    box                 {
      <-0.5,-0.5,0>,
      <0.5,0.5,-0.20>
    }
    cylinder            {
      0                 , -0.30*z
      0.3
    }
    difference          {
      cylinder            {
        -0.25*z           , -0.50*z       ,
        0.60
      }
      torus             {
        0.30            , 0.05
        rotate          90*x
        translate       -0.50*z
      }
      torus             {
        0.55            , 0.05
        rotate          90*x
        translate       -0.50*z
      }
      difference        {
        cylinder            {
          -0.49*z           , -0.51*z       ,
          0.53
        }
        cylinder            {
          -0.48*z           , -0.52*z       ,
          0.32
        }
        plane           {
          x            , 0
          rotate        45*z
        }
        #ifndef ( CEUP_TexturaPerilla )
          pigment         {
            radial
            frequency     4
          }
          #ifdef ( CEUP_AnguloColores )
            rotate        CEUP_AnguloColores*z
          #end
        #end
      }
    }
    #local C            = 0;
    #local TotalCilindros               = 14;
    #while ( C < TotalCilindros )
      cylinder          {
        0               , -0.20*z
        0.05
        translate       -0.25*z +0.60*x
        rotate          C/TotalCilindros*360*z
      }
      #local C          = C+1;
    #end
    #ifdef ( CEUP_TexturaPerilla )
      texture           {
        CEUP_TexturaPerilla
      }
    #else
      texture             {
        TexturaPlastica
      }
    #end
  }
#end

#macro CEUP_Tornillo( TexturaTornillo )
  union         {
    difference  {
      sphere    {
        0       , 1
        scale   <1,0.50,1>
      }
      sphere    {
        0.50*y  , 0.40
      }
      plane     {
        y       , 0
      }
    }
    cylinder    {
      0         , 0.05*y
      1
    }
    texture     {
      TexturaTornillo
    }
  }
#end

#macro CEUP_CaminadoraEjercicioUniPersonal
        ( Ancho, ProfundidadP, Altura, RadioBotella,
          FraccionEje, LargoTabla,
          F1,F2, FraccionElevacion, FactorAvance,
          TexturaPrincipal, TexturaBaseTabla,
          TexturaMetalizada, TexturaPlastica,
          TexturaNegra, TexturaFirme, TexturaBoton,
          TexturaPantalla, TexturaBanda )
  union                 {
    #local L                    = CEUP_L;
    #local RadioUInvertida      = 86/408*Ancho;
    #local ProfundidadSuperior  = 357/300*ProfundidadP;
    #local RadioSuperior        = 57/408*Ancho;
    #local DiametroSuperior     = 21/408*Ancho;
    #local ProfundidadCuero     = 104/300*ProfundidadP;
    #local DiametroCuero        = 25/408*Ancho;
    #local FraccionSinCuero     = 67*L/Ancho;
    #local ProfundidadAgarradera                = 113/300*ProfundidadP;
    #local DesplazarAgarradera                  = 250/300*ProfundidadP;
    #local AltoControlador      = 25/408*Ancho;
    #local ProfundidadControlador               = 107/408*Ancho;
    #local AnchoControlador     = 143/408*Ancho;
    #local RadioDecorativoControlador           = 7.15/408*Ancho;
    #local AltoPatillas         = 11/86*RadioUInvertida;
    union               {
      object              {
        CEUP_ImplementationUInvertida
                  ( Ancho, ProfundidadP, RadioUInvertida, RadioUInvertida/2 )
        texture           {
          TexturaPrincipal
        }
      }
      union             {
        cylinder          {
          0               , -AltoPatillas*y       ,
          RadioUInvertida/6
          translate       -RadioUInvertida*y/4
                          -( Ancho/2-RadioUInvertida )*z
        }
        cylinder          {
          0               , -AltoPatillas*y       ,
          RadioUInvertida/6
          translate       -RadioUInvertida*y/4
                          +( Ancho/2-RadioUInvertida )*z
        }
        cylinder          {
          0               , -AltoPatillas*y       ,
          RadioUInvertida/6
          translate       -0.9*ProfundidadP*x
                          -RadioUInvertida*y/4
                          -Ancho/2*z
        }
        cylinder          {
          0               , -AltoPatillas*y       ,
          RadioUInvertida/6
          translate       -0.9*ProfundidadP*x
                          -RadioUInvertida*y/4
                          +Ancho/2*z
        }
        #local PatillasRodantes = union         {
          cylinder        {
            -0.75*RadioUInvertida/8*z          ,
            +0.75*RadioUInvertida/8*z          ,
            ( AltoPatillas+RadioUInvertida/4 )
            texture             {
              TexturaNegra
            }
          }
          difference    {
            cylinder        {
              -RadioUInvertida/7*z          ,
              +RadioUInvertida/7*z          ,
              ( 2*AltoPatillas+RadioUInvertida/4 )
            }
            plane               {
              y                , 0
            }
            plane               {
              y                , 0
              rotate            -40*z
            }
          }
          cylinder      {
            0           , ( 2*AltoPatillas+RadioUInvertida/4 )*x
            RadioUInvertida/4
          }
          sphere        {
            0           , RadioUInvertida/4
          }
        }
        object          {
          PatillasRodantes
          translate       -Ancho/2*z
                          -( ProfundidadP+2*AltoPatillas+RadioUInvertida/4 )*x
        }
        object          {
          PatillasRodantes
          translate       +Ancho/2*z
                          -( ProfundidadP+2*AltoPatillas+RadioUInvertida/4 )*x
        }
        texture         {
          TexturaPlastica
          normal        {
            dents
            scale       0.001
          }
        }
      }
      union               {
        object              {
          CEUP_ImplementationUInvertida
                    ( Ancho, ProfundidadSuperior,
                            RadioSuperior, DiametroSuperior )
          texture           {
            TexturaPrincipal
          }
        }
        difference          {
          object          {
            CEUP_ImplementationUInvertida
                  ( Ancho, ProfundidadCuero,
                          RadioSuperior, DiametroCuero )
          }
          cylinder                {
            -FraccionSinCuero*Ancho/2*z   ,
            +FraccionSinCuero*Ancho/2*z   ,
            2*DiametroCuero
          }
          texture                 {
            TexturaNegra
          }
        }
        #local C                  = 0;
        #while ( C < 2 )
          union                   {
            cylinder              {
              0                                   ,
              -ProfundidadAgarradera*x            ,
              DiametroCuero/2
              texture             {
                TexturaNegra
              }
            }
            cylinder              {
              -ProfundidadAgarradera/2*x          ,
              -1.02*ProfundidadAgarradera*x       ,
              0.9*DiametroSuperior/2
              texture             {
                TexturaNegra
              }
            }
            union                 {
              difference          {
                sphere            {
                  0               ,
                  0.4*ProfundidadAgarradera
                  scale           <1.0,0.1,0.2>
                }
                sphere            {
                  0.4*ProfundidadAgarradera*y     ,
                  0.30*ProfundidadAgarradera
                  scale           <1.0,0.1,0.2>
                }
                texture           {
                  TexturaNegra
                }
              }
              difference          {
                sphere            {
                  0.4*ProfundidadAgarradera*y     ,
                  0.30*ProfundidadAgarradera
                  scale           <1.0,0.1,0.2>
                }
                sphere            {
                  0.425*ProfundidadAgarradera*y     ,
                  0.30*ProfundidadAgarradera
                  scale           <1.0,0.1,0.2>
                }
                cylinder          {
                  -ProfundidadAgarradera*z        ,
                  +ProfundidadAgarradera*z        ,
                  0.035*ProfundidadAgarradera
                  translate       0.03*ProfundidadAgarradera*y
                }
                texture           {
                  TexturaMetalizada
                }
              }
              translate           -ProfundidadAgarradera/2*x
                                  +DiametroCuero/2*y
            }
            translate             -DesplazarAgarradera*x
                                  +Ancho/2*z
            #if ( C = 0 )
              scale               <1,1,-1>
            #end
          }
          #local C                = C+1;
        #end
        object            {
          CEUP_ImplementationControlador
                  ( AnchoControlador, ProfundidadControlador,
                          AltoControlador, RadioDecorativoControlador,
                          RadioBotella, TexturaPlastica, TexturaPrincipal,
                          TexturaPantalla, TexturaBoton )
          translate       +( ProfundidadControlador/2-DiametroCuero/2 )*x
                          +DiametroCuero/2*y
          rotate          20*z
        }
        // interseccion base inferior, base superior
        // un triangulo curvo de plastico
        #local ProfundidadTriangular      =
                  ( DesplazarAgarradera-ProfundidadCuero )/2*0.85;
        #local PuntoA             =
          -( ProfundidadCuero+DesplazarAgarradera )/2*x;
        #local PuntoB             = PuntoA+ProfundidadTriangular*x;
        #local PuntoC             = PuntoA-ProfundidadTriangular*x;
        #local PuntoD             = PuntoA-0.20*ProfundidadTriangular*x
                                    -3*DiametroCuero*y;
        #local PuntoD2            =
                  ( PuntoC+PuntoD )/2+0.2*ProfundidadTriangular*x;
        #local PuntoE             = PuntoA+0.20*ProfundidadTriangular*x
                                    -3*DiametroCuero*y;
        #local PuntoE2            =
                  ( PuntoB+PuntoE )/2-0.2*ProfundidadTriangular*x;
        #local PuntoA             = PuntoA+0.50*DiametroCuero*y;
        #local C          = 0;
        #while ( C < 2 )
          union             {
            object          {
              CEUP_SegmentoTriplePunto( PuntoB, PuntoA, PuntoC,
                            DiametroCuero, true, true )
            }
            #local D        = 0;
            #while ( D < 2 )
              difference      {
                union         {
                  triangle        {
                    PuntoC, PuntoD, PuntoB
                  }
                  triangle        {
                    PuntoC, PuntoE, PuntoB
                  }
                  triangle            {
                    PuntoD, PuntoE, ( PuntoC+PuntoB )/2
                  }
                }
                object          {
                  CEUP_SegmentoTriplePunto( PuntoC, PuntoD2, PuntoD,
                              DiametroCuero/2, false false )
                }
                object          {
                  CEUP_SegmentoTriplePunto( PuntoB, PuntoE2, PuntoE,
                              DiametroCuero/2, false false )
                }
                #if ( D = 0 )
                  translate     +DiametroCuero/2*z
                #else
                  translate     -DiametroCuero/2*z
                #end
              }
              #local D      = D+1;
            #end
            object          {
              CEUP_SweepTriplePunto( PuntoC, PuntoD2, PuntoD,
                            DiametroCuero/2, false )
            }
            object          {
              CEUP_SweepTriplePunto( PuntoB, PuntoE2, PuntoE,
                            DiametroCuero/2, false )
            }
            #if ( C = 0 )
              translate       +Ancho/2*z
            #else
              translate       -Ancho/2*z
            #end
            texture         {
              TexturaPlastica
            }
          }
          #local C        = C+1;
        #end
        rotate            15*z
        translate         Altura*y
      }
      #local C          = 0;
      #while ( C < 2 )
        union             {
          cylinder          {
            0           , 0.9*Altura*y
            DiametroSuperior/2
          }
          cylinder          {
            0           , 0.9*Altura*y
            DiametroSuperior/2
            translate   -DiametroSuperior*x
          }
          box           {
            <0,0,-DiametroSuperior/2>,
            <-DiametroSuperior,0.9*Altura,+DiametroSuperior/2>
          }
          cylinder      {
            +2*DiametroSuperior*z, -0.75*DiametroSuperior*z   ,
            DiametroSuperior/2
            translate       -0*DiametroSuperior*z
                                +FraccionEje*Altura*y
                            -DiametroSuperior/2*x
          }
          cylinder      {
            +2.5*DiametroSuperior*z, +3.5*DiametroSuperior*z   ,
            43/787*Altura
            translate       -0*DiametroSuperior*z
                                +FraccionEje*Altura*y
                            -DiametroSuperior/2*x
            texture     {
              TexturaMetalizada
            }
          }
          object    {
            CEUP_Tornillo( TexturaMetalizada )
            scale   DiametroSuperior/3
            rotate      -90*x
            translate       -0.75*DiametroSuperior*z
                                +FraccionEje*Altura*y
                            -DiametroSuperior/2*x
          }
          // Base de soporte vertical
          difference    {
            union       {
              cylinder    {
                -2*DiametroSuperior*x    ,
                +2*DiametroSuperior*x   ,
                1.2*RadioUInvertida/4
              }
              object    {
                CEUP_Tornillo( TexturaMetalizada )
                scale   DiametroSuperior/3
                translate       1.2*RadioUInvertida/4*y
                                +1.5*DiametroSuperior*x
              }
              object    {
                CEUP_Tornillo( TexturaMetalizada )
                scale   DiametroSuperior/3
                translate       1.2*RadioUInvertida/4*y
                                -1.5*DiametroSuperior*x
              }
            }
            plane       {
              z         , 0
              rotate    -60*x
            }
            plane       {
              -z         , 0
              rotate    +60*x
            }
            texture     {
              TexturaPrincipal
            }
            translate   -DiametroSuperior/2*x
          }
          translate     -Ancho/2*z-0.4*ProfundidadSuperior*x
          #if ( C = 0 )
            scale               <1,1,-1>
          #end
          texture               {
            TexturaPrincipal
          }
        }
        #local C        = C+1;
      #end
      object            {
        CEUP_ImplementationPerilla( TexturaPlastica )
        scale           1.6*DiametroSuperior
        translate     -Ancho/2*z-0.4*ProfundidadSuperior*x
                        -DiametroSuperior/2*z
                        +0.75*Altura*y
                        -DiametroSuperior/2*x
      }
    }
    // Placa movible
    union               {
      cylinder          {
        -Ancho/2*z      , +Ancho/2*z    ,
        DiametroSuperior*0.2
      }
      #local AltoTabla  = 43/787*Altura;
      #local AnchoPiv   = 21/43*AltoTabla;
      #local DelanteTabla       = 114/787*Altura;
      #local AnchoTabla = 358/408*Ancho;
      cylinder          {
        +( Ancho/2-3*AnchoPiv )*z,
        -( Ancho/2-3*AnchoPiv )*z,
        AnchoPiv*0.50
        translate       ( 0.6*AltoTabla-AnchoPiv*0.50 )*y
        texture         {
          TexturaFirme
        }
      }
      #local C          = 0;
      #while ( C < 5 )
        union           {
          box           {
            <-AnchoPiv*0.48,-AnchoPiv*0.48,-(AnchoTabla*0.48)>,
            < AnchoPiv*0.48,+AnchoPiv*0.28,+(AnchoTabla*0.48)>
          }
          object    {
            CEUP_Tornillo( TexturaMetalizada )
            scale   DiametroSuperior/3
            rotate      180*x
            translate   -AnchoPiv*0.48*y
                        -( AnchoTabla*0.40 )*z
          }
          object    {
            CEUP_Tornillo( TexturaMetalizada )
            scale   DiametroSuperior/3
            rotate      180*x
            translate   -AnchoPiv*0.48*y
                        +( AnchoTabla*0.40 )*z
          }
          translate       ( 0.6*AltoTabla-AnchoPiv*0.50 )*y
                      -( LargoTabla-DelanteTabla )*0.95*x
          translate   +0.95*( LargoTabla-DelanteTabla )/6*( C+1 )*x
          texture     {
              TexturaBaseTabla
          }
        }
        #local C        = C+1;
      #end
      cylinder          {
        +( Ancho/2-3*AnchoPiv )*z,
        -( Ancho/2-3*AnchoPiv )*z,
        AnchoPiv*0.50
        translate       ( 0.6*AltoTabla-AnchoPiv*0.50 )*y
                        -( LargoTabla-DelanteTabla )*0.95*x
        texture         {
          TexturaFirme
        }
      }
      cylinder          {
        +( Ancho/2-AnchoPiv )*z,
        -( Ancho/2-AnchoPiv )*z,
        AnchoPiv*0.20
        translate       ( 0.6*AltoTabla-AnchoPiv*0.50 )*y
                        -( LargoTabla-DelanteTabla )*0.95*x
        texture         {
          TexturaMetalizada
        }
      }
      box               {
        -( LargoTabla-DelanteTabla )*0.05*x+
        +0.2*AltoTabla*y
        -AnchoTabla/2*z*0.95,
        -( LargoTabla-DelanteTabla )*0.90*x+
        +AltoTabla*0.6*y
        +AnchoTabla/2*z*0.95
        texture         {
          TexturaFirme
        }
      }
      #local C          = 0;
      #while ( C < 2 )
        union           {
          box           {
            -0.05*AnchoPiv*z
            +DelanteTabla*x
            -AltoTabla*0.4*y,
            -( LargoTabla-DelanteTabla )*x
            +AltoTabla*0.6*y
            -AnchoPiv*z
            translate   AnchoTabla/2*z
            texture     {
              TexturaFirme
            }
          }
          union                 {
            difference          {
              superellipsoid      {
                < 0.2, 0.2 >
                translate         -0.75*x
                rotate            45*z
              }
              plane       {
                y        , 0.1
              }
              plane       {
                -z        , 0
                translate +0.5*z
              }
              plane       {
                z        , 0
                translate -0.5*z
              }
            }
            difference    {
              superellipsoid      {
                < 0.2, 0.2 >
                translate         -0.75*x
                rotate            15*z
              }
              superellipsoid      {
                < 0.8, 0.8 >
                scale     <2.5,1,0.35>
                rotate            15*z
                translate         -2.0*x+0.50*y
              }
              box       {
                -2*x
                -0.1*y
                -0.45*z,
                +0.5*x
                +0.2*y
                +0.45*z
              }
              plane       {
                y        , 0
              }
              plane       {
                -z        , 0
                translate +0.5*z
              }
              plane       {
                z        , 0
                translate -0.5*z
              }
            }
            scale       <0.1125*LargoTabla,1.5*AltoTabla,AnchoTabla>
            translate   +AltoTabla*0.6*y+0.7*DelanteTabla*x
            texture     {
              TexturaBaseTabla
            }
          }
          cylinder      {
            0,
            -2.0*AnchoPiv*z     ,
            AltoTabla/2+0.1*AltoTabla
            translate   -( LargoTabla-DelanteTabla )*0.95*x
                        +( AnchoTabla/2-AnchoPiv )*z
            texture     {
              TexturaBaseTabla
            }
          }
          cylinder      {
            -AltoTabla*0.4*y,
            +AltoTabla*0.61*y,
            AnchoPiv
            translate   -( LargoTabla-DelanteTabla-AnchoPiv )*x
                        +( AnchoTabla/2-AnchoPiv )*z
            texture     {
              TexturaBaseTabla
            }
          }
          box           {
            -( LargoTabla-DelanteTabla-AnchoPiv )*x*0.90
            +AltoTabla*0.6*y,
            -( LargoTabla-DelanteTabla-AnchoPiv )*x
            +AltoTabla*0.61*y
            -2.75*AnchoPiv*z
            translate   AnchoTabla/2*z
            texture     {
              TexturaBaseTabla
            }
          }
          box           {
            +AltoTabla*0.6*y,
            -( LargoTabla-DelanteTabla-AnchoPiv )*x
            +AltoTabla*0.61*y
            -2*AnchoPiv*z
            translate   AnchoTabla/2*z
            texture     {
              TexturaBaseTabla
            }
          }
          box           {
            +DelanteTabla*x
            -AltoTabla*0.4*y,
            -( LargoTabla-DelanteTabla )*x
            +AltoTabla*0.6*y
            -AnchoPiv*z
            scale       <0.99,1.005,1.005>
            translate   AnchoTabla/2*z
            texture     {
              TexturaBaseTabla
            }
          }
          // Pata hule tabla
          #local CAng           = 0;
          #local AnguloMenor    = 0.0;
          #while ( CAng < 2 )
            #local AnguloMenor    =  asin (
                        ( FraccionEje*Altura
                          -( 5/12+0.4*cos( AnguloMenor )+1/3 )*AltoTabla
                          +( RadioUInvertida/4+AltoPatillas ) )/
                        ( ( LargoTabla-DelanteTabla )*0.90
                                -( 0.4*AltoTabla )*tan( AnguloMenor ) ) );
            #local CAng         = CAng+1;
          #end
          #local AnguloMenor    = degrees( AnguloMenor );
          cylinder          {
            -( AnchoTabla/2 )*1.05*z,
            -( AnchoTabla/2-AnchoPiv )*z,
            5/12*AltoTabla
            translate       -( 0.4+1/3 )*AltoTabla*y
                            -( LargoTabla-DelanteTabla)*0.90*x
            texture         {
              TexturaPlastica
            }
          }
          #if ( C = 1 )
            scale       <1,1,-1>
          #end
        }
        #local C        = C+1;
      #end
      cylinder          {
        -AnchoTabla*z/2, AnchoTabla/2*z
        1/3*AltoTabla
        translate       -( 0.4+1/3 )*AltoTabla*y
                        -( LargoTabla-DelanteTabla)*0.90*x
        texture         {
          TexturaBaseTabla
        }
      }
      object            {
        CEUP_ImplementationDeslizante( F1,F2,234/358*AnchoTabla,
                ( LargoTabla-DelanteTabla )*0.95, AnchoPiv*1.1,
                  FactorAvance, TexturaBanda )
        translate       ( 0.6*AltoTabla-AnchoPiv/2 )*y
      }
      rotate            +AnguloMenor*z
      rotate            -FraccionElevacion*( CEUP_AnguloMayor+AnguloMenor )*z
      translate         FraccionEje*Altura*y
                        -0.4*ProfundidadSuperior*x
    }
    translate           ( RadioUInvertida/4+AltoPatillas )*y
  }
#end

#macro CEUP_Caminadora( FraccionElevacion, FactorAvance, F1, F2 )
  #local L              = CEUP_L;
  #local Ancho          = 408*L;
  #local ProfundidadP   = 300*L;
  #local Altura         = 787*L;
  #local RadioBotella   = 25*L;
  #local FraccionEje    = 136/787;
  #local LargoTabla     = 894*L;
  object                {
    CEUP_CaminadoraEjercicioUniPersonal
        ( Ancho, ProfundidadP, Altura, RadioBotella,
          FraccionEje, LargoTabla,
          F1,F2, FraccionElevacion, FactorAvance,
          CEUP_DefaultTexturaPrincipal,
          CEUP_DefaultTexturaBaseTabla,
          CEUP_DefaultTexturaMetalizada,
          CEUP_DefaultTexturaPlastica,
          CEUP_DefaultTexturaNegra,
          CEUP_DefaultTexturaFirme,
          CEUP_DefaultTexturaBoton,
          CEUP_DefaultTexturaPantalla,
          CEUP_DefaultTexturaBanda
        )
  }
#end


