// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 4 junio 2012
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// CEUP_Au1.inc           archivo original
// CEUP_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// CEUP_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// CEUP_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// CEUP_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// CEUP_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CEUP CaminadoraEjecicioUniPersonal
// Dibuja una caminadora para ejercicios a nivel domstico.
// Incluye macros de textura y permite modificaciones leves.
// #macro CEUP_Caminadora( FraccionElevacion, FactorAvance, F1, F2 )
//      FraccionElevacion       : Fraccion entre cero y uno...
//              que permite "bajar" (0.0) o "recoger" (1.0)
//              la tabla de ejercicio.
//      FactorAvance            : Para simular el movimiento de la andadera
//              desplaza linealmente la textura en unidades L.
//              Utiliza un valor float positivo.
//              La textura se desplazara hacia X- con
//              translate -FactorAvance*x.
//      F1                      : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona delantera de izquierda a derecha.
//      F2                      : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona posterior de izquierda a derecha.
//
// Las dimensiones de la caminadora depende si esta extendida o no.
// Caminadora extendida :
// Frente               451*L
// Alto                 920*L
// Profundidad          980*L
// Caminadora recogida  :
// Frente               451*L
// Alto                 970*L
// Profundidad          450*L
// Por defecto se ubica sobre el plano XZ, sobresaliendo hacia X-
// con gravedad Y- y centrada con respecto al eje X.
// El avance virtual del potencial usuario seria hacia X+.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro CEUP_CaminadoraEjercicioUniPersonal
//        ( Ancho, ProfundidadP, Altura, RadioBotella,
//          FraccionEje, LargoTabla,
//          F1,F2, FraccionElevacion, FactorAvance,
//          TexturaPrincipal, TexturaBaseTabla,
//          TexturaMetalizada, TexturaPlastica,
//          TexturaNegra, TexturaFirme, TexturaBoton,
//          TexturaPantalla, TexturaBanda )
//      Ancho           : Referencia para el frente de la caminadora.
//              Default es 408*L.
//      ProfundidadP    : Referencia para la profundidad de la base
//              de la caminadora.  Default es 300*L.
//      Altura          : Referencia para la altura de la caminadora.
//              Default es 787*L.
//      RadioBotella    : Radio para una botellita de agua (no incluida)
//              de la caminadora.  Default 25*L.
//      FraccionEje     : Altura como fraccion del eje de la tabla
//              deslizante.  Default es 136/787.
//      LargoTabla      : Referencia para el largo de la tabla deslizante.
//              Default es 894*L.
//      F1              : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona delantera de izquierda a derecha.
//      F2              : Para simular la oscilacion de la base
//              deslizante de la andadera.  Fraccion entre -1.0 a 1.0.
//              Desde el punto de vista del usuario virtual.
//              Aplica a la zona posterior de izquierda a derecha.
//      FraccionElevacion       : Fraccion entre cero y uno...
//              que permite "bajar" (0.0) o "recoger" (1.0)
//              la tabla de ejercicio.
//      FactorAvance            : Para simular el movimiento de la andadera
//              desplaza linealmente la textura en unidades L.
//              Utiliza un valor float positivo.
//              La textura se desplazara hacia X- con
//              translate -FactorAvance*x.
//      TexturaPrincipal        : Textura principal del aparato.
//              Default es CEUP_DefaultTexturaPrincipal.
//      TexturaBaseTabla        : Textura a aplicar a la base principal
//              de la tabla deslizante.
//              Default es CEUP_DefaultTexturaBaseTabla.
//      TexturaMetalizada       : Textura a aplicar a ciertos
//              elementos metalizados de la estructura.
//              Default es CEUP_DesfultTexturaMetalizada.
//      TexturaPlastica         : Textura a aplicar a ciertos elementos
//              plasticos de la estructura.  Por ejemplo, las ruedas,
//              controles, soportes, etc.
//              Default es CEUP_DefaultTexturaPlastica.
//      TexturaNegra            : Textura a aplicar a elementos de caucho.
//              Los que sirven de agarre para las manos.
//              Default es CEUP_DefaultTexturaNegra.
//      TexturaFirme            : Textura a aplicar a la base firme
//              de la tabla deslizante.
//              Default es CEUP_DefaultTexturaFirme.
//      TexturaBoton            : Textura para los botones de control.
//              Default es CEUP_DefaultTexturaBoton.
//      TexturaPantalla         : Textura a aplicar a la pantalla.
//              Se aplica por diferencia.
//              Default es CEUP_DefaultTexturaPantalla.
//      TexturaBanda            : Textura a aplicar a la banda deslizante.
//              Sobre esta textura aplica translate -FactorAvance*x.
//              Default es CEUP_DefaultTexturaBanda.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// CEUP_TexturaPrincipal
//      Textura principal del aparato.
// CEUP_TexturaBaseTabla
//      Textura a aplicar a la base principal de la tabla de ejercicios.
// CEUP_TexturaMetalizada
//      Textura a aplicar a ciertos
//      elementos metalizados de la estructura.
// CEUP_TexturaPlastica
//      Textura a aplicar a ciertos elementos
//      plasticos de la estructura.  Por ejemplo, las ruedas,
//      controles, soportes, etc.
// CEUP_TexturaNegra
//      Textura a aplicar a elementos de caucho.
//      Los que sirven de agarre para las manos.
// CEUP_TexturaFirme
//      Textura a aplicar a la base firme de la tabla deslizante.
// CEUP_TexturaBoton
//      Textura para los botones de control.
// CEUP_TexturaPantalla
//      Textura a aplicar a la pantalla.  Se aplica por diferencia.
// CEUP_TexturaBanda
//      Textura a aplicar a la banda deslizante.
//      Sobre esta textura aplica translate -FactorAvance*x.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare CEUP_DefaultTexturaPrincipal               =
//              texture { CEUP_TexturaPrincipal }
//      Textura principal del aparato.
// #declare CEUP_DefaultTexturaBaseTabla               =
//              texture { CEUP_TexturaBaseTabla }
//      Textura a aplicar a la base principal de la tabla de ejercicio.
// #declare CEUP_DefaultTexturaMetalizada              =
//              texture { CEUP_TexturaMetalizada }
//      Textura a aplicar a ciertos
//      elementos metalizados de la estructura.
// #declare CEUP_DefaultTexturaPlastica                =
//              texture { CEUP_TexturaPlastica }
//      Textura a aplicar a ciertos elementos
//      plasticos de la estructura.  Por ejemplo, las ruedas,
//      controles, soportes, etc.
// #declare CEUP_DefaultTexturaNegra                   =
//              texture { CEUP_TexturaNegra }
//      Textura a aplicar a elementos de caucho.
//      Los que sirven de agarre para las manos.
// #declare CEUP_DefaultTexturaFirme                   =
//              texture { CEUP_TexturaFirme }
//      Textura a aplicar a la base firme de la tabla deslizante.
// #declare CEUP_DefaultTexturaBoton                   =
//              texture { CEUP_TexturaBoton }
//      Textura para los botones de control.
// #declare CEUP_DefaultTexturaPantalla                =
//              texture { CEUP_TexturaPantalla }
//      Textura a aplicar a la pantalla.  Se aplica por diferencia.
// #declare CEUP_DefaultTexturaBanda                   =
//              texture { CEUP_TexturaBanda }
//      Textura a aplicar a la banda deslizante.
//      Sobre esta textura aplica translate -FactorAvance*x.
// #declare CEUP_AnguloColores
//      Valor real, que aplica solo si se define.
//      En los colores de control de la perilla.
//      #ifdef ( CEUP_AnguloColores )
//        rotate        CEUP_AnguloColores*z
//      #end
// #declare CEUP_TexturaPerilla
//      Textura que se aplica solo si se define.
//      Para modificar la perilla.  Se aplica antes
//      de escalar en una perilla de radio 0.65,
//      cuando sale del origen hacia Z-.
//      #ifdef ( CEUP_TexturaPerilla )
//        texture       { CEUP_TexturaPerilla }
//      #end
// #declare CEUP_TexturaControl
//      Textura que se aplica solo si se define.
//      Para modificar los controles.
//      #ifdef ( CEUP_TexturaControl )
//        texture       { CEUP_TexturaControl }
//      #end
// #declare CEUP_GifBoton        = "CEUP_IM1.GIF"
//      Imagen GIF que se aplica a los controles.
//      No aplica si define CEUP_TexturaControl.
// #declare CEUP_AnguloMayor     = 97.5;
//      Angulo de rotacion de la tabla, cuando se cierra.
//      Podria ser necesario modificarlo si se cambian las caracteristicas,
//      por defecto.
//
// Para colocarlo simplemente
// #include "CEUP.inc"
// object        { CEUP_Caminadora( 0,0,0,0 ) }
//
// Otro ejemplo con modificador
// #include "CEUP.inc"
// #declare CEUP_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 CEUP_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      CEUP_Caminadora( 0,0,-0.5,0.6)
// }
//
// Otro ejemplo con macro de texturas
// #include "CEUP.inc"
// #include "textures.inc"
// object             {
//   CEUP_CaminadoraEjercicioUniPersonal
//      ( 0.408, 0.300, 0.787, 0.025, 0.18, 0.894, 0, 0, 0, 0,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White*0.5
}
light_source    {
         <-500  , 500   , -3000 >*L
         White*0.5
}
background      {
         Gray50
}

#include "CEUP.inc"

object          {
  CEUP_Caminadora(0.0,0.0,0.3,-0.4)
  translate     -0.425*y+0.4*x-0.80*z
}

