// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 agosto 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// LHNU LoncheraHieleraNivelUniversitario
// El archivo dibuja una hielera algo pequena, pero funcional.
//
// El objeto por defecto se dibuja con la siguiente macro
// #macro LHNU_Hielera( FraccionTapa, FraccionGiroAgarradera )
//      FraccionTapa            : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 110 grados.
//      FraccionGiroAgarradera  : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 123 grados.
//
// Las dimensiones de la hielera son :
//      Alto                    = 150*L
//              (mayor a 250*L completamente abierto)
//      Frente                  = 196*L
//      Fondo en Z              = -84*L..+75*L
// La base se encuentra casi centrada en el origen sobre el plano XZ.
// Frente hacia Z-, y gravedad Y-.
//
// #macro LHNU_LoncheraHieleraNivelUniversitario
//      ( FraccionTapa, FraccionGiroAgarradera,
//        FrentePrincipal, ProfundidadPrincipal, AltoInferior, AltoIntermedio,
//        AnchoAgarradera, AltoInterior,
//        GruesoPrincipal, RadioDecorativo, AltoTapa, CizallaTapa,
//        TexturaPrincipal, TexturaTapa, TexturaIntermedia,
//        TexturaAgarradera, TexturaInterior )
//      FraccionTapa            : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 110 grados.
//      FraccionGiroAgarradera  : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 123 grados.
//      FrentePrincipal         : Referencia para el frente X de la hielera.
//                      Default es 194.5*L.
//      ProfundidadPrincipal    : Referencia para la profundidad Z de hielera.
//                      Default es 150*L.
//      AltoInferior            : Alto de la zona azul inferior.
//                      Default es 107*L.
//      AltoIntermedio          : Referencia para el alto
//                      de la franja central.  Default es 18*L.
//      AnchoAgarradera         : Ancho de la agarradera.
//                      Default es 14.3*L.
//      AltoInterior            : Alto inferior del interior de la hielera.
//                      Default es 114*L.
//      GruesoPrincipal         : Grueso del borde de la hielera.
//                      Default es 14.3*L.
//      RadioDecorativo         : Valor para el radio de las esquinas.
//                      Default es 14.3*L.
//      AltoTapa                : Referencia para el alto de la tapa.
//                      Default es 28*L.
//      CizallaTapa             : Referencia para corrimiento oblicuo
//                      de la parte superior de la tapa.
//                      A menor valor, la tapa tendra mayor verticalidad.
//                      Default es 14.3*L.
//      TexturaPrincipal        : Textura azul a aplicar a la base inferior.
//                      Default es LHNU_DefaultTexturaPrincipal.
//      TexturaTapa             : Textura para la tapa superior.
//                      Default es LHNU_DefaultTexturaTapa.
//      TexturaIntermedia       : Textura para la franja blanca intermedia,
//                      y algunos relieves en la tapa.
//                      Default es LHNU_DefaultTexturaIntermedia.
//      TexturaAgarradera       : Textura para la agarradera.
//                      Default es LHNU_DefaultTexturaAgarradera.
//      TexturaInterior         : Textura para el interior y el tapon
//                      inferior.  Default es LHNU_DefaultTexturaInterior.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare LHNU_VolumenLiquido
//      Objeto sin textura para facilitar la ubicacion de liquidos en el
//      interior del objeto.  Por ejemplo agua de hielo derretido por
//      intersection.  Solo define la zona inferior de la hielera.
// #declare LHNU_TexturaPrincipal
//      Textura principal de la hielera a aplicar a la zona azul.
// #declare LHNU_TexturaTapa
//      Textura a aplicar a la tapa.
// #declare LHNU_TexturaIntermedia
//      Textura a aplicar a la franja blanca intermedia y algunos elementos
//      decorativos de la tapa.
// #declare LHNU_TexturaAgarradera
//      Textura a aplicar a la agarradera.
// #declare LHNU_TexturaInterior
//      Textura a aplicar al interior y al tapon inferior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LHNU_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare LHNU_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal de la hielera a aplicar a la zona azul.
// #declare LHNU_DefaultTexturaTapa             = texture { ... }
//      Textura a aplicar a la tapa.
// #declare LHNU_DefaultTexturaIntermedia       = texture { ... }
//      Textura a aplicar a la franja blanca intermedia y algunos elementos
//      decorativos de la tapa.
// #declare LHNU_DefaultTexturaAgarradera       = texture { ... }
//      Textura a aplicar a la agarradera.
// #declare LHNU_DefaultTexturaInterior         = texture { ... }
//      Textura a aplicar al interior y al tapon inferior.
//
// Para colocarlo simplemente
// #include "LHNU.inc"
// object        { LHNU_Hielera(0,0) }
//
// Otro ejemplo con modificador
// #include "LHNU.inc"
// #declare LHNU_DefaultTexturaPrincipal        =
//      texture { LHNU_TexturaPrincipal }
//      texture { pigment {rgbt 0.5 } }
//
// object        {
//      LHNU_Hielera(0,0)
// }
//
// Otro ejemplo con macro de texturas
// #include "LHNU.inc"
// #include "textures.inc"
// object             {
//   LHNU_LoncheraHieleraNivelUniversitario
//              ( 0, 0, 0.1945, 0.150, 0.107, 0.018,
//                0.0143, 0.114, 0.0143, 0.0143, 0.028, 0.0143,
//                      PinkAlabaster, PinkAlabaster,
//                      PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare LHNU_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( LHNU_POV3_1 )
    #declare LHNU_POV3_1        = on;
  #end
#else
  #ifndef( LHNU_POV3_1 )
    #declare LHNU_POV3_1        = off;
  #end    
#end

#declare LHNU_TexturaPrincipal                  =
  texture                       {
    pigment     { Blue }
    normal      {
      granite
      scale     0.001
    }
  }
  texture                       {
    pigment     { Cyan transmit 0.50 }
  }

#ifndef ( LHNU_DefaultTexturaPrincipal )
  #declare LHNU_DefaultTexturaPrincipal         =
    texture     { LHNU_TexturaPrincipal }
#end

#declare LHNU_TexturaTapa                  =
  texture                       {
    pigment     { White }
    normal      {
      granite
      scale     0.001
    }
  }
  texture                       {
    pigment     { White transmit 0.10 }
  }

#ifndef ( LHNU_DefaultTexturaTapa )
  #declare LHNU_DefaultTexturaTapa         =
    texture     { LHNU_TexturaTapa }
#end

#if ( LHNU_POV3_1 )
  #declare LHNU_TexturaIntermedia                =
    texture                       {
      pigment     { White }
      normal      {
        waves  
      }
    }
#else
  #declare LHNU_TexturaIntermedia                =
    texture                       {
      pigment     { White }
      normal      {
        bumps  
        scale     0.1
      }
    }
#end  

#ifndef ( LHNU_DefaultTexturaIntermedia )
  #declare LHNU_DefaultTexturaIntermedia         =
    texture     { LHNU_TexturaIntermedia }
#end
  
#if ( LHNU_POV3_1 )  
  #declare LHNU_TexturaAgarradera                =
    texture                       {
      pigment     { White*0.95 }
      normal    {
        waves
        scale <1,0.005,1>
      }
    }
#else
  #declare LHNU_TexturaAgarradera                =
    texture                       {
      pigment     { gradient y 
        turbulence        0.001  
        sine_wave
        pigment_map       {
          [0.0 White*1.00]
          [1.0 White*0.95] 
        }
        scale     <1,0.01,1>
      }
    }
#end  

#ifndef ( LHNU_DefaultTexturaAgarradera )
  #declare LHNU_DefaultTexturaAgarradera         =
    texture     { LHNU_TexturaAgarradera }
#end

#declare LHNU_TexturaInterior                  =
  texture                       {
    pigment     { White }
    normal      {
      bumps
      scale     .1
    }
  }
  texture                        {
    pigment     { rgb 1.0 transmit 0.30 }
  }

#ifndef ( LHNU_DefaultTexturaInterior )
  #declare LHNU_DefaultTexturaInterior         =
    texture     { LHNU_TexturaInterior }
#end

#macro LHNU_Barrita( AltoBarrita, RadioBarrita )
  union         {
    cylinder    {
      AltoBarrita/2*y,
      -AltoBarrita/2*y,RadioBarrita
    }
    sphere      {
      AltoBarrita/2*y,RadioBarrita
    }
    sphere      {
      -AltoBarrita/2*y,RadioBarrita
    }
  }
#end

#macro LHNU_LoncheraHieleraNivelUniversitario
      ( FraccionTapa, FraccionGiroAgarradera,
        FrentePrincipal, ProfundidadPrincipal, AltoInferior, AltoIntermedio,
        AnchoAgarradera, AltoInterior,
        GruesoPrincipal, RadioDecorativo, AltoTapa, CizallaTapa,
        TexturaPrincipal, TexturaTapa, TexturaIntermedia,
        TexturaAgarradera, TexturaInterior )
  union                 {
    #local FraccionAgarradera   = 5.3/14.3;
    #local AnguloMaximo         = 123;
    #local AnguloMaximoTapa     = 110;
    #local BaseAgarradera       =
      union             {
        box             {
          < -FrentePrincipal/2+GruesoPrincipal/2+RadioDecorativo,
             0, -ProfundidadPrincipal/2 >,
          < +FrentePrincipal/2-GruesoPrincipal/2-RadioDecorativo,
             AltoIntermedio, +ProfundidadPrincipal/2 >
        }
        box             {
          < -FrentePrincipal/2,0,
            -ProfundidadPrincipal/2+GruesoPrincipal/2+RadioDecorativo >,
          < +FrentePrincipal/2, AltoIntermedio,
            +ProfundidadPrincipal/2-GruesoPrincipal/2-RadioDecorativo >
        }
        #local C                = 0;
        #while ( C < 4 )
          cylinder              {
            0                   , AltoIntermedio*y,
            RadioDecorativo+GruesoPrincipal/2
            translate
              < -FrentePrincipal/2, 0, -ProfundidadPrincipal/2 >+
              < +GruesoPrincipal/2+RadioDecorativo, 0,
                +GruesoPrincipal/2+RadioDecorativo >
            #switch ( C )
              #case ( 1 )
                scale   <+1,+1,-1>
              #break
              #case ( 3 )
                scale   <+1,+1,-1>
              #case ( 2 )
                scale   <-1,+1,+1>
              #break
            #end
          }
          #local C              = C+1;
        #end
      }
      #local Agarradera         =
        union                   {
          difference            {
            cylinder              {
              -FrentePrincipal/2*x        , FrentePrincipal/2*x   ,
              AnchoAgarradera/2
              translate   AnchoAgarradera/2*y
            }
            cylinder              {
              ( -FrentePrincipal/2+FraccionAgarradera*GruesoPrincipal )*x,
              ( +FrentePrincipal/2-FraccionAgarradera*GruesoPrincipal )*x,
              1.01*AnchoAgarradera/2
              translate   AnchoAgarradera/2*y
            }
          }
          difference            {
            object                  {
              BaseAgarradera
              scale         <1,AnchoAgarradera/AltoIntermedio,1.1>
            }
            object                  {
              BaseAgarradera
              scale
                < ( FrentePrincipal/2-FraccionAgarradera*GruesoPrincipal )/
                  ( FrentePrincipal/2 ), 1.002*AnchoAgarradera/AltoIntermedio,
                  ( ProfundidadPrincipal/2-
                        FraccionAgarradera*GruesoPrincipal )/
                  ( ProfundidadPrincipal/2 ) >
              translate     -0.001*AnchoAgarradera*y
            }
            plane               {
              -z                 , 0
            }
          }
          translate             -AnchoAgarradera/2*y
        }
    difference                  {
      object                    {
        BaseAgarradera
      }
      object                    {
        Agarradera
        scale           1.001
        translate       ( AltoIntermedio-AnchoAgarradera/2 )*y
      }
      object                    {
        Agarradera
        rotate          +AnguloMaximo*x
        scale           1.001
        translate       ( AltoIntermedio-AnchoAgarradera/2 )*y
      }
      superellipsoid    {
        <0.2,0.2>
        scale           <FrentePrincipal/2-GruesoPrincipal,
                     AltoInterior, ProfundidadPrincipal/2-GruesoPrincipal >
        translate       AltoIntermedio*y
        texture         {
          TexturaInterior
        }
      }
      box               {
        <-FrentePrincipal/4,AltoIntermedio/2,+ProfundidadPrincipal>,
        <+FrentePrincipal/4,AltoIntermedio*1.01,0>
      }
      texture                   {
        TexturaIntermedia
      }
    }
    // Agarradera
    union               {
      difference        {
        object            {
          Agarradera
        }
        union           {
          cylinder        {
            0           , -ProfundidadPrincipal*z,
            AnchoAgarradera/3
            translate   -0.5*FrentePrincipal/2*x
          }
          box                   {
            <-0.5*FrentePrincipal/2,-AnchoAgarradera/3,0>,
            <+0.5*FrentePrincipal/2,+AnchoAgarradera/3,-ProfundidadPrincipal>
          }
          cylinder        {
            0           , -ProfundidadPrincipal*z,
            AnchoAgarradera/3
            translate   +0.5*FrentePrincipal/2*x
          }
          translate     -ProfundidadPrincipal/2*z
        }
      }
      difference       {
        cylinder          {
          -1.0025*FrentePrincipal/2*x, +1.0025*FrentePrincipal/2*x,
          AnchoAgarradera/5
        }
        cylinder          {
          ( -FrentePrincipal/2+GruesoPrincipal*0.99 )*x,
          ( +FrentePrincipal/2-0.99*GruesoPrincipal )*x,
          AnchoAgarradera
        }
      }
      texture         {
        TexturaAgarradera
      }
      scale           <1.01,0.95,1.02>
      rotate            FraccionGiroAgarradera*AnguloMaximo*x
      translate       ( AltoIntermedio-AnchoAgarradera/2 )*y
    }
    // Base inferior
    difference          {
      union             {
        superellipsoid  {
          <0.2,0.2>
          scale           < 0.95*FrentePrincipal/2, AltoInferior,
                                0.95*ProfundidadPrincipal/2 >
        }
        superellipsoid  {
          <0.2,0.2>
          scale           < 0.98*FrentePrincipal/2, 0.25*AltoInferior,
                                0.98*ProfundidadPrincipal/2 >
        }
        #local C        = 0;
        #while ( C < 4 )
          sphere          {
            0             , FrentePrincipal/20
            scale         <1,0.3,1>
            translate     +0.3*FrentePrincipal/20*y
            translate     -AltoInferior*y
            translate     0.70*FrentePrincipal/2*x
                                  +0.70*ProfundidadPrincipal/2*z
            #switch ( C )
              #case ( 1 )
                scale           <-1,+1,+1>
              #break
              #case ( 2 )
                scale           <-1,+1,+1>
              #case ( 3 )
                scale           <+1,+1,-1>
              #break
            #end
          }
          #local C      = C+1;
        #end
        cylinder        {
          -AltoInferior*y       , -0.95*AltoInferior*y,
          FrentePrincipal/20
          texture       { TexturaInterior }
        }
      }
      #local C          = 0;
        #while ( C < 15 )
          object        {
            LHNU_Barrita( 0.5*AltoInferior, FrentePrincipal/200 )
            translate   -AltoInferior/2*y
            translate   -0.95*ProfundidadPrincipal/2*z
            translate   ( C+5 )/30*FrentePrincipal/2*x
          }
        #local C        = C+1;
      #end
      cylinder        {
        -1.1*AltoInferior*y       , -0.95*AltoInferior*y, FrentePrincipal/20
      }
      superellipsoid    {
        <0.2,0.2>
        scale           <FrentePrincipal/2-GruesoPrincipal,
                     AltoInterior, ProfundidadPrincipal/2-GruesoPrincipal >
        translate       AltoIntermedio*y
        texture         {
          TexturaInterior
        }
      }
      plane             {
        -y,0
      }
      texture           {
        TexturaPrincipal
      }
    }
    // Tapa
    union               {
      difference        {
        union           {
          difference          {
            intersection      {
              #local FactorCizalla    = CizallaTapa/AltoTapa;
              #local C        = 0;
              #while ( C < 4 )
                superellipsoid  {
                  <0.2,0.2>
                  scale
                        < 0.98*FrentePrincipal/2
                            -FraccionAgarradera*GruesoPrincipal,
                                AltoTapa,
                            0.98*ProfundidadPrincipal/2
                            -FraccionAgarradera*GruesoPrincipal >
                  #switch ( C )
                    #case ( 1 )
                      matrix        <1,0,0,+FactorCizalla,1,0,0,0,1,0,0,0>
                    #break
                    #case ( 2 )
                      matrix        <1,0,0,-FactorCizalla,1,0,0,0,1,0,0,0>
                    #break
                    #case ( 3 )
                      matrix        <1,0,0,0,1,+FactorCizalla,0,0,1,0,0,0>
                    #break
                    #case ( 0 )
                      matrix        <1,0,0,0,1,-FactorCizalla,0,0,1,0,0,0>
                    #break
                  #end
                }
                #local C                = C+1;
              #end
            }
            plane             {
              y,0
              texture         {
                TexturaIntermedia
              }
            }
          }
          #local FraccionGirador       = 0.95;
          difference        {
            superellipsoid  {
              <0.2,0.2>
              scale       < 0.98*FrentePrincipal/2,
                                AltoTapa,
                            0.98*ProfundidadPrincipal/2 >
              matrix        <1,0,0,0,1,-FactorCizalla,0,0,1,0,0,0>
            }
            plane           {
              x             , -FraccionGirador*FrentePrincipal/4
            }
            plane           {
              -x             , -FraccionGirador*FrentePrincipal/4
            }
            plane           {
              y            , 0
            }
            plane           {
              z             , 0
            }
          }
          difference        {
            cylinder          {
              -FraccionGirador*FrentePrincipal/4*x,
              +FraccionGirador*FrentePrincipal/4*x
              AltoIntermedio/2
            }
            plane           {
              -y             , 0
            }
            translate       +0.98*ProfundidadPrincipal/2*z-AltoIntermedio/2*z
          }
          superellipsoid    {
            <0.2,0.2>
            scale   <FrentePrincipal/2-GruesoPrincipal,AltoTapa/10,
                     ProfundidadPrincipal/2-GruesoPrincipal>
            texture         {
              TexturaInterior
            }
          }
        }
        superellipsoid    {
          <0.2,0.2>
          scale   <FrentePrincipal/2-1.5*GruesoPrincipal,0.75*AltoTapa,
                   ProfundidadPrincipal/2-1.5*GruesoPrincipal>
          texture         {
            TexturaInterior
          }
        }
        union           {
          cylinder        {
            0           , -ProfundidadPrincipal*z,
            AltoTapa/4
            translate   -0.5*FrentePrincipal/4*x
          }
          box                   {
            <-0.5*FrentePrincipal/4,-AltoTapa/4,0>,
            <+0.5*FrentePrincipal/4,+AltoTapa/4,-ProfundidadPrincipal>
          }
          cylinder        {
            0           , -ProfundidadPrincipal*z,
            AltoTapa/4
            translate   +0.5*FrentePrincipal/4*x
          }
          #local      AnguloCizalla   =
                                degrees( atan2( CizallaTapa, AltoTapa ) );
          translate     AltoTapa/2*y
          rotate        AnguloCizalla*x
          translate     -ProfundidadPrincipal/2*z+0.60*GruesoPrincipal*z
          translate     +FrentePrincipal/5*x
          texture       { TexturaIntermedia }
        }
        #local C        = 0;
        #while ( C < 5 )
          object                {
            LHNU_Barrita( FrentePrincipal/2, FrentePrincipal/100 )
            rotate      90*x
            rotate      -45*y
            translate   AltoTapa*y+( C-3 )*FrentePrincipal/20*x
            texture { TexturaIntermedia }
          }
          #local C      = C+1;
        #end
      }
      difference        {
        cylinder          {
          ( +ProfundidadPrincipal/2-1.25*GruesoPrincipal )*z,
          ( -ProfundidadPrincipal/2+1.25*GruesoPrincipal )*z,
          0.25*AltoTapa
          scale <5,1,1>
        }
        plane           {
          -y,0
        }
        cylinder        {
          AltoTapa*y,-AltoTapa*y,
          AltoTapa*0.1
        }
        translate       0.75*AltoTapa*y
        texture         {
          TexturaInterior
        }
      }
      texture           {
        TexturaTapa
      }
      translate       -0.98*ProfundidadPrincipal/2*z+AltoIntermedio/2*z
      rotate            FraccionTapa*AnguloMaximoTapa*x
      translate       +0.98*ProfundidadPrincipal/2*z-AltoIntermedio/2*z
      translate         1.01*AltoIntermedio*y
    }
    translate           +AltoInferior*y
    #declare LHNU_VolumenLiquido        =
        difference              {
          superellipsoid    {
            <0.2,0.2>
            scale           <FrentePrincipal/2-GruesoPrincipal,
                      AltoInterior, ProfundidadPrincipal/2-GruesoPrincipal >
          }
          plane             {
            -y,0
          }
          translate       AltoIntermedio*y+AltoInferior*y
        }
  }
#end

#macro LHNU_Hielera( FraccionTapa, FraccionGiroAgarradera )
  object                {
    #local L                            = LHNU_L;
    #local AltoInferior                 = 107*L;
    #local FrentePrincipal              = 194.5*L;
    #local ProfundidadPrincipal         = 150*L;
    #local AltoIntermedio               = 18*L;
    #local GruesoPrincipal              = 14.3*L;
    #local RadioDecorativo              = 14.3*L;
    #local AnchoAgarradera              = 14.3*L;
    #local AltoTapa                     = 28*L;
    #local CizallaTapa                  = 14.3*L;
    #local AltoInterior                 = 114*L;
    LHNU_LoncheraHieleraNivelUniversitario(
        FraccionTapa, FraccionGiroAgarradera,
        FrentePrincipal, ProfundidadPrincipal, AltoInferior, AltoIntermedio,
        AnchoAgarradera, AltoInterior,
        GruesoPrincipal, RadioDecorativo, AltoTapa, CizallaTapa,
        LHNU_DefaultTexturaPrincipal, LHNU_DefaultTexturaTapa,
        LHNU_DefaultTexturaIntermedia, LHNU_DefaultTexturaAgarradera,
        LHNU_DefaultTexturaInterior )
  }
#end

