// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 agosto 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// LHNU LoncheraHieleraNivelUniversitario
// El archivo dibuja una hielera algo pequena, pero funcional.
//
// El objeto por defecto se dibuja con la siguiente macro
// #macro LHNU_Hielera( FraccionTapa, FraccionGiroAgarradera )
//      FraccionTapa            : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 110 grados.
//      FraccionGiroAgarradera  : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 123 grados.
//
// Las dimensiones de la hielera son :
//      Alto                    = 150*L
//              (mayor a 250*L completamente abierto)
//      Frente                  = 196*L
//      Fondo en Z              = -84*L..+75*L
// La base se encuentra casi centrada en el origen sobre el plano XZ.
// Frente hacia Z-, y gravedad Y-.
//
// #macro LHNU_LoncheraHieleraNivelUniversitario
//      ( FraccionTapa, FraccionGiroAgarradera,
//        FrentePrincipal, ProfundidadPrincipal, AltoInferior, AltoIntermedio,
//        AnchoAgarradera, AltoInterior,
//        GruesoPrincipal, RadioDecorativo, AltoTapa, CizallaTapa,
//        TexturaPrincipal, TexturaTapa, TexturaIntermedia,
//        TexturaAgarradera, TexturaInterior )
//      FraccionTapa            : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 110 grados.
//      FraccionGiroAgarradera  : Fraccion entre 0.0 cerrado
//                      a 1.0 en maxima apertura de 123 grados.
//      FrentePrincipal         : Referencia para el frente X de la hielera.
//                      Default es 194.5*L.
//      ProfundidadPrincipal    : Referencia para la profundidad Z de hielera.
//                      Default es 150*L.
//      AltoInferior            : Alto de la zona azul inferior.
//                      Default es 107*L.
//      AltoIntermedio          : Referencia para el alto
//                      de la franja central.  Default es 18*L.
//      AnchoAgarradera         : Ancho de la agarradera.
//                      Default es 14.3*L.
//      AltoInterior            : Alto inferior del interior de la hielera.
//                      Default es 114*L.
//      GruesoPrincipal         : Grueso del borde de la hielera.
//                      Default es 14.3*L.
//      RadioDecorativo         : Valor para el radio de las esquinas.
//                      Default es 14.3*L.
//      AltoTapa                : Referencia para el alto de la tapa.
//                      Default es 28*L.
//      CizallaTapa             : Referencia para corrimiento oblicuo
//                      de la parte superior de la tapa.
//                      A menor valor, la tapa tendra mayor verticalidad.
//                      Default es 14.3*L.
//      TexturaPrincipal        : Textura azul a aplicar a la base inferior.
//                      Default es LHNU_DefaultTexturaPrincipal.
//      TexturaTapa             : Textura para la tapa superior.
//                      Default es LHNU_DefaultTexturaTapa.
//      TexturaIntermedia       : Textura para la franja blanca intermedia,
//                      y algunos relieves en la tapa.
//                      Default es LHNU_DefaultTexturaIntermedia.
//      TexturaAgarradera       : Textura para la agarradera.
//                      Default es LHNU_DefaultTexturaAgarradera.
//      TexturaInterior         : Textura para el interior y el tapon
//                      inferior.  Default es LHNU_DefaultTexturaInterior.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare LHNU_VolumenLiquido
//      Objeto sin textura para facilitar la ubicacion de liquidos en el
//      interior del objeto.  Por ejemplo agua de hielo derretido por
//      intersection.  Solo define la zona inferior de la hielera.
// #declare LHNU_TexturaPrincipal
//      Textura principal de la hielera a aplicar a la zona azul.
// #declare LHNU_TexturaTapa
//      Textura a aplicar a la tapa.
// #declare LHNU_TexturaIntermedia
//      Textura a aplicar a la franja blanca intermedia y algunos elementos
//      decorativos de la tapa.
// #declare LHNU_TexturaAgarradera
//      Textura a aplicar a la agarradera.
// #declare LHNU_TexturaInterior
//      Textura a aplicar al interior y al tapon inferior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LHNU_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare LHNU_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal de la hielera a aplicar a la zona azul.
// #declare LHNU_DefaultTexturaTapa             = texture { ... }
//      Textura a aplicar a la tapa.
// #declare LHNU_DefaultTexturaIntermedia       = texture { ... }
//      Textura a aplicar a la franja blanca intermedia y algunos elementos
//      decorativos de la tapa.
// #declare LHNU_DefaultTexturaAgarradera       = texture { ... }
//      Textura a aplicar a la agarradera.
// #declare LHNU_DefaultTexturaInterior         = texture { ... }
//      Textura a aplicar al interior y al tapon inferior.
//
// Para colocarlo simplemente
// #include "LHNU.inc"
// object        { LHNU_Hielera(0,0) }
//
// Otro ejemplo con modificador
// #include "LHNU.inc"
// #declare LHNU_DefaultTexturaPrincipal        =
//      texture { LHNU_TexturaPrincipal }
//      texture { pigment {rgbt 0.5 } }
//
// object        {
//      LHNU_Hielera(0,0)
// }
//
// Otro ejemplo con macro de texturas
// #include "LHNU.inc"
// #include "textures.inc"
// object             {
//   LHNU_LoncheraHieleraNivelUniversitario
//              ( 0, 0, 0.1945, 0.150, 0.107, 0.018,
//                0.0143, 0.114, 0.0143, 0.0143, 0.028, 0.0143,
//                      PinkAlabaster, PinkAlabaster,
//                      PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "LHNU.inc"

#local   FactorAcercamiento     = 5;

object  {
  LHNU_Hielera( 1.0, 1.0 ) 
  translate             -0.1*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z  
}


