// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 17 abril 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// LRSC LavadoraRopaSecadoCentrifugo
// El archivo dibuja una lavadora de uso domestico.
// Puede abrir la tapa, y simular el movimiento interion sin ropa.
// #macro LRSC_Lavadora( AnguloTapa, AnguloGiro, BanderaCanastilla )
//      AnguloTapa              : Angulo de apertura de la lavadora.
//              Use cero para tapa cerrada.
//      AnguloGiro              : Para animar el giro de las partes internas.
//      BanderaCanastilla       : Aplica a la canastilla 
//              removible que se coloca sobre la ropa.  
//              "on" canastilla visible, "off" no se dibuja.
//
// La dimensiones de la lavadora son :
//      Alto total              = 767*L
//      Frente                  = 513*L
//      Fondo                   = 451*L
// Se dibuja centrado sobre el plano XY.  La canastilla, y el rotor central
// se encuentran alineados con el origen directamente en el centro
// de la lavadora.
//
// La siguiente macro permite mayor flexibilidad.
// #macro LRSC_LavadoraRopaSecadoCentrifugo
//        ( AnguloTapa, AnguloGiro, BanderaCanastilla,
//                AltoFundamental, AnchoFundamental, ProfundidadFundamental,
//                AlturaPanel, DiametroIntroduccion,
//                TexturaPrincipal, TexturaLavado, TexturaOscura,
//                TexturaMetalizada, TexturaHelice, TexturaBoton1,
//                TexturaBoton2, TexturaPatas )
//      AnguloTapa              : Angulo de apertura de la lavadora.
//              Use cero para tapa cerrada.
//      AnguloGiro              : Para animar el giro de las partes internas.
//      BanderaCanastilla       : Aplica a la canastilla 
//              removible que se coloca sobre la ropa.  
//              "on" canastilla visible, "off" no se dibuja.
//      AltoFundamental         : Alto de la estructura principal.
//              Default es 630*L.
//      AnchoFundamental        : Valor de referencia para el frente.
//              Default es 500*L.
//      ProfundidadFundamental  : Valor de referencia para la profundidad Z.
//              Default es 440*L.
//      AlturaPanel             : Alto del panel de control.
//              Default es 129*L.
//      DiametroIntroduccion    : Diametro del circulo por el que
//              ingresa la ropa.  Default es 271*L.
//      TexturaPrincipal        : Textura principal del aparato.
//              Default es LRSC_DefaultTexturaPrincipal.
//      TexturaLavado           : Textura del interior de la zona de lavado.
//              Default es LRSC_DefaultTexturaLavado.
//      TexturaOscura           : Textura lisa del panel, que sirve de fondo
//              en algunos sectores.  Especialmente la parte trasera.
//              Default es LRSC_DefaultTexturaOscura.
//      TexturaMetalizada       : Textura a aplicar a zonas metalicas del
//              panel de control.
//              Default es LRSC_DefaultTexturaMetalizada.
//      TexturaHelice           : Textura a aplicar al rotor y canastilla.
//              Default es LRSC_DefaultTexturaHelice.
//      TexturaBoton1           : Textura a aplicar a las perillas redondas.
//              Default es LRSC_DefaultTexturaBoton1.
//      TexturaBoton2           : Textura a aplicar a los selectores de la
//              izquierda.  Default es LRSC_DefaultTexturaBoton2.
//      TexturaPatas            : Textura a aplicar a las patas.
//              Default es LRSC_DefaultTexturaPatas.
//
// La siguiente macro dibuja la canastilla en forma independiente;  los
// parametros estan vinculados a la lavadora.
// #macro LRSC_Canastilla
//              ( AltoFundamental, DiametroIntroduccion, TexturaHelice )
//      AltoFundamental         : Alto de la estructura principal.
//              Default es 630*L.
//      DiametroIntroduccion    : Diametro del circulo por el que
//              ingresa la ropa.  Default es 271*L.
//      TexturaHelice           : Textura a aplicar al rotor y canastilla.
//              Default es LRSC_DefaultTexturaHelice.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare LRSC_PosicionCanastilla
//      Ubicacion original de la canastilla sin rotacion.
//      Sirve para ubicarlo en posicion cuando utilice la macro
//      LRSE_Canastilla().
// #declare LRSC_TexturaPrincipal
//      Textura principal del aparato.
// #declare LRSC_TexturaLavado
//      Textura del interior de la zona de lavado.
// #declare LRSC_TexturaOscura
//      Textura lisa del panel, que sirve de fondo
//      en algunos sectores.  Especialmente la parte trasera.
// #declare LRSC_TexturaMetalizada
//      Textura a aplicar a zonas metalicas del panel de control.
// #declare LRSC_TexturaHelice
//      Textura a aplicar al rotor y canastilla.
// #declare LRSC_TexturaBoton1
//      Textura a aplicar a las perillas redondas.
// #declare LRSC_TexturaBoton2
//      Textura a aplicar a los selectores de la izquierda.
// #declare LRSC_TexturaPatas
//      Textura a aplicar a las patas.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LRSC_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version elimina el dibujo del rotor y el canastilla;
//      que utilizan isosurface.
// #declare LRSC_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal del aparato.
// #declare LRSC_DefaultTexturaLavado           = texture { ... }
//      Textura del interior de la zona de lavado.
// #declare LRSC_DefaultTexturaOscura           = texture { ... }
//      Textura lisa del panel, que sirve de fondo
//      en algunos sectores.  Especialmente la parte trasera.
// #declare LRSC_DefaultTexturaMetalizada       = texture { ... }
//      Textura a aplicar a zonas metalicas del panel de control.
// #declare LRSC_DefaultTexturaHelice           = texture { ... }
//      Textura a aplicar al rotor y canastilla.
// #declare LRSC_DefaultTexturaBoton1           = texture { ... }
//      Textura a aplicar a las perillas redondas.
// #declare LRSC_DefaultTexturaBoton2           = texture { ... }
//      Textura a aplicar a los selectores de la izquierda.
// #declare LRSC_DefaultTexturaPatas            = texture { ... }
//      Textura a aplicar a las patas.
// #declare LRSC_BotonGif                       = "LRSC_IM1.GIF"
//      Dibujo GIF de las etiquetas de los botones.
//      Cuide la posicion de los botones.
// #declare LRSC_AdvertenciaGif                 = "LRSC_IM2.GIF"
//      Dibujo GIF del mensaje de advertencia e instrucciones.
//      De la zona inferior de la tapa.
// #declare LRSC_AnguloBoton1                   = 0;
//      Permite rotar la perilla de la derecha.
// #declare LRSC_AnguloBoton2                   = 0;
//      Permite rotar la perilla del grupo central izquierda.
// #declare LRSC_AnguloBoton3                   = 0;
//      Permite rotar la perilla del grupo central derecha.
// #declare LRSC_AnguloBoton4                   = 0;
//      Permite rotar el selector izquierdo superior.
// #declare LRSC_AnguloBoton5                   = 0;
//      Permite rotar el selector izquierdo central.
// #declare LRSC_AnguloBoton6                   = 0;
//      Permite rotar el selector izquierdo inferior.
//
// Para colocarlo simplemente
// #include "LRSC.inc"
// object        { LRSC_Lavadora(0,0,on) }
//
// Otro ejemplo con modificador
// #include "LRSC.inc"
// #declare LRSC_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 LRSC_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      LRSC_Lavadora( 90, 0, on )
// }
//
// Para colocar la canastilla
// #include "LRSC.inc"
// union                {
//   object             {
//     LRSC_Lavadora( 90, 0, off )
//   }
//   object             {
//     LRSC_Canastilla( 0.630, 0.271, LRSC_DefaultTexturaHelice )
//     translate        LRSC_PosicionCanastilla
//   }
// }
//

#include "colors.inc"
#include "textures.inc" 

#declare LRSC_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( LRSC_POV3_1 )
    #declare LRSC_POV3_1        = on;
  #end
#else
  #ifndef( LRSC_POV3_1 )
    #declare LRSC_POV3_1        = off;
  #end    
#end

#if ( !LRSC_POV3_1 )
  #include "functions.inc"
#end

#ifndef ( LRSC_BotonGif )
  #declare LRSC_BotonGif        = "LRSC_IM1.GIF"
#end

#ifndef ( LRSC_AdvertenciaGif )
  #declare LRSC_AdvertenciaGif  = "LRSC_IM2.GIF"
#end

#ifndef ( LRSC_AnguloBoton1 )
  #declare LRSC_AnguloBoton1    = 0;
#end

#ifndef ( LRSC_AnguloBoton2 )
  #declare LRSC_AnguloBoton2    = 0;
#end

#ifndef ( LRSC_AnguloBoton3 )
  #declare LRSC_AnguloBoton3    = 0;
#end

#ifndef ( LRSC_AnguloBoton4 )
  #declare LRSC_AnguloBoton4    = 0;
#end

#ifndef ( LRSC_AnguloBoton5 )
  #declare LRSC_AnguloBoton5    = 0;
#end

#ifndef ( LRSC_AnguloBoton6 )
  #declare LRSC_AnguloBoton6    = 0;
#end

#declare LRSC_TexturaPrincipal                  = texture       {
  pigment               {
    White
  }
  normal                {
    bumps     
    scale               0.5
  }
  finish                {
    specular            0.5
    roughness           0.1
    metallic
  }
}

#ifndef ( LRSC_DefaultTexturaPrincipal )
  #declare LRSC_DefaultTexturaPrincipal         = texture       {
    LRSC_TexturaPrincipal
  }
#end

#declare LRSC_TexturaLavado                     = texture       {
  PinkAlabaster
  scale         0.1
  normal                {
    bumps
  }
}

#ifndef ( LRSC_DefaultTexturaLavado )
  #declare LRSC_DefaultTexturaLavado            = texture       {
    LRSC_TexturaLavado
  }
#end

#declare LRSC_TexturaOscura                     = texture       {
  pigment               {
    Gray20*0.5+Silver*0.5
  }
  normal                {
    granite
    scale       1.0
  }
}

#ifndef ( LRSC_DefaultTexturaOscura )
  #declare LRSC_DefaultTexturaOscura            = texture       {
    LRSC_TexturaOscura
  }
#end

#declare LRSC_TexturaMetalizada                 = texture       { 
  pigment               {
    Silver
  }
  normal                {
    bumps
    scale       0.05
  }
  finish                {
    phong       0.2
    phong_size  1.0
    metallic       
    irid        {0.25}
  }
}

#ifndef ( LRSC_DefaultTexturaMetalizada )
  #declare LRSC_DefaultTexturaMetalizada        = texture       {
    LRSC_TexturaMetalizada
  }
#end

#declare LRSC_TexturaHelice                     = texture       {
  pigment               {
    White*0.9+Yellow*0.1
  }
  normal                 {
    bumps
  }
  finish                {
    specular    0.05
    metallic
  }
}

#ifndef ( LRSC_DefaultTexturaHelice )
  #declare LRSC_DefaultTexturaHelice            = texture       {
    LRSC_TexturaHelice    
  }
#end

#declare LRSC_TexturaBoton1                     = texture       { 
  pigment               {
    Silver*0.8+Black*0.2
  }
  normal                {
    bumps
    scale       0.01
  }
  finish                {
    phong       0.2
    phong_size  0.1
    metallic       
  }
}

#ifndef ( LRSC_DefaultTexturaBoton1 )
  #declare LRSC_DefaultTexturaBoton1            = texture       {
    LRSC_TexturaBoton1
  }
#end

#declare LRSC_TexturaBoton2                     = texture       {
  pigment               {
    White
  }
  finish                {
    metallic
  }
}

#ifndef ( LRSC_DefaultTexturaBoton2 )
  #declare LRSC_DefaultTexturaBoton2            = texture       {
    LRSC_TexturaBoton2
  }
#end

#declare LRSC_TexturaPatas                      = texture       {
  pigment               {
    Gray10
  }
  finish                {
    metallic
  }
}

#ifndef ( LRSC_DefaultTexturaPatas )
  #declare LRSC_DefaultTexturaPatas             = texture       {
    LRSC_TexturaPatas
  }
#end

#macro LRSC_ImplementationSplineLineal( MyArreglo, Radio )
  union                 {
    #local TotalPuntos  = dimension_size( MyArreglo, 1 );
    #local C            = 0;
    #while ( C < TotalPuntos )
      sphere            { MyArreglo[C], Radio }
      #if ( C > 0)
        cylinder        { MyArreglo[C-1], MyArreglo[C], Radio }
      #end
      #local C          = C+1;
    #end
  }
#end  

#macro LRSC_Canastilla 
        ( AltoFundamental, DiametroIntroduccion, TexturaHelice )
  union     {
    #local DiametroInterior     = 355.5*DiametroIntroduccion/271;
    difference      {
      isosurface {
        function { f_hex_y(x,y,z, 1) } 
          //P0= not used
        threshold 0.1
        contained_by { box { -40*<1,1,0>,40 } }
        max_gradient 1  
        rotate          -90*x
        scale           1.3*<0.01,0.0002,0.01>/5
      }
      cylinder        {
        -AltoFundamental*y             , AltoFundamental*0.02*y         ,
        DiametroInterior*0.05
      }    
      cylinder      {
        -AltoFundamental*y      , AltoFundamental*y         ,
        DiametroInterior*0.30
        inverse          
      }
    }      
    difference      {
      union         {
        cylinder        {
          0             , AltoFundamental*0.02*y         ,
          DiametroInterior*0.05
        }
        cylinder        {
          0             , AltoFundamental*0.025*y         ,
          DiametroInterior*0.04
        }
      }
      cylinder        {
        -AltoFundamental*y    , AltoFundamental*0.02*y         ,
        DiametroInterior*0.04
      }
    }    
    difference      {
      cylinder      {
        0      , AltoFundamental*0.02*y         ,
        DiametroInterior*0.32         
      }
      cylinder      {
        -AltoFundamental*y      , AltoFundamental*y         ,
        DiametroInterior*0.26
      }
      torus         {
        DiametroInterior*0.26       ,
        DiametroInterior*0.02
        translate   AltoFundamental*0.02*y
      }
    }
    texture         {
      TexturaHelice
    }   
  }             
#end

#macro LRSC_LavadoraRopaSecadoCentrifugo
        ( AnguloTapa, AnguloGiro, BanderaCanastilla,
                AltoFundamental, AnchoFundamental, ProfundidadFundamental,
                AlturaPanel, DiametroIntroduccion,
                TexturaPrincipal, TexturaLavado, TexturaOscura,
                TexturaMetalizada, TexturaHelice, TexturaBoton1,
                TexturaBoton2, TexturaPatas )
  union                 {
    #local FraccionBaseSuperior       = 25/630;
    #local DiametroInterior           =
              0.500*DiametroIntroduccion+
              0.500*min( AnchoFundamental, ProfundidadFundamental );
    #local AltoTapa             = FraccionBaseSuperior/2*AltoFundamental;
    #local AnchoTapa            = 290/271*DiametroIntroduccion;
    #local ProfundidadTapa      = 220/271*DiametroIntroduccion;
    #local ExcesoTapa           = 38/271*DiametroIntroduccion;
    #local AnchoExcesoTapa      = 186/271*DiametroIntroduccion;
    #local ProfundidadPanel     = 86/440*ProfundidadFundamental;
    #local AltoZonaInferior     = 8/630*AltoFundamental;
    #local FraccionSupPanel     = 54/86;
    
    #local ArregloTapa          = array[7]
      {
        <-AnchoTapa/2,+0>,
        <-AnchoTapa/2,-ProfundidadTapa>,
        <-AnchoExcesoTapa/2,-ProfundidadTapa-ExcesoTapa>,
        <+AnchoExcesoTapa/2,-ProfundidadTapa-ExcesoTapa>,
        <+AnchoTapa/2,-ProfundidadTapa>,
        <+AnchoTapa/2,0>,
        <-AnchoTapa/2,0>
      }
    #local TamanoArregloTapa    = dimension_size( ArregloTapa, 1 );

    #local ArregloPanel         = array[5]
      {
        <0,0>,
        <1,0>,
        <1,FraccionSupPanel>,
        <0,1>,
        <0,0>
      }
    #local TamanoArregloPanel   = dimension_size( ArregloPanel, 1 );

    #local FormaPanel           = prism         {
      -0.5              , 0.5           ,
      TamanoArregloPanel
      #local C                  = 0;
      #while ( C < TamanoArregloPanel )
        ArregloPanel[C]
        #local C                = C+1;
      #end
      rotate                    90*z
      scale                     < 0.9875*AnchoFundamental,
                        AlturaPanel, -ProfundidadPanel >
    }
      
    #local FormaTapa            = union         {
      object            {
        LRSC_ImplementationSplineLineal( ArregloTapa, AltoTapa/4 )
        rotate          90*x
        scale           <1,2,1>
      }
      
      prism             {
        -AltoTapa/2     , AltoTapa/2    ,
        TamanoArregloTapa
        #local C        = 0;
        #while ( C < TamanoArregloTapa )
          ArregloTapa[C]
          #local C      = C+1;
        #end
      }
    }
    union               {
      difference        {
        superellipsoid    {
          <0.03,0.03>
          scale           0.5
          translate       +0.5*y
          scale           < AnchoFundamental,
                                  AltoFundamental*( 1-FraccionBaseSuperior ),
                                  ProfundidadFundamental  >
        }
        difference      {
          superellipsoid  {
            <1,0.1>
            rotate        90*x
            scale         0.5
            scale         < DiametroInterior,
                                  2*AltoFundamental*365/630,
                                  DiametroInterior >
            translate     AltoFundamental*y
          }
          torus         {
            DiametroInterior/2          , DiametroInterior/10
            scale       <1,3,1>
            translate   AltoFundamental*y
          }
          texture         {
            TexturaLavado
            rotate              AnguloGiro*y
          }
        }
      }
      difference        {
        superellipsoid    {
          <0.1,0.1>
          scale           0.5
          translate       +0.5*y
          scale           < AnchoFundamental*1.025,
                                AltoFundamental*FraccionBaseSuperior,
                                ProfundidadFundamental*1.025  >
          translate       AltoFundamental*( 1-FraccionBaseSuperior)*y
        }
        superellipsoid    {
          <0.1,0.1>
          scale           0.5
          scale           < AnchoFundamental*0.95,
                                AltoFundamental*FraccionBaseSuperior/5,
                                ProfundidadFundamental*0.95 >
          translate       AltoFundamental*y
        }
        difference      {
          cylinder      {
            0           , 2*AltoFundamental*y   ,
            DiametroIntroduccion/2
          }
          plane         {
            -z          , -5*DiametroIntroduccion/12
          }
        }
        object              {
          FormaTapa
          scale         <1,2,1>
          scale         <1.05,1,1.05>
          translate       1.05*ProfundidadTapa/2*z
          translate         AltoFundamental*y
        }
      }      
      difference          {
        object          {
          FormaTapa
        }
        object          {
          FormaTapa
          scale         <0.95,1,0.95>
          translate     -0.125*ProfundidadTapa/2*z-0.1*AltoTapa*y
          pigment                 {
            image_map             {
              gif LRSC_AdvertenciaGif
            }
            rotate      -90*x
            translate   -0.51*x-0.05*z
            scale       < AnchoTapa, 1, ProfundidadTapa >
          }
          normal              {
            granite
            turbulence  2
            scale     0.01*ProfundidadTapa
          }
        }
        rotate          AnguloTapa*x
        translate         ProfundidadTapa/2*z
        translate         AltoFundamental*y-AltoTapa/2*y
      }
      texture           {
        TexturaPrincipal
      }
    }
    union               {
      object            {
        FormaPanel
        scale           <1.0,0.7,0.5>
      }
      object            {
        FormaPanel
        scale           <0.95,0.875,0.8>
      }
      #local Pivote             = ProfundidadPanel*( 1-FraccionSupPanel );
      #local Pivote             =
                        sqrt( AlturaPanel*AlturaPanel+Pivote*Pivote );
      #local AnguloPanel        = 90-degrees( asin( AlturaPanel/Pivote ) );
      union             {
        difference      {
          object            {
            FormaPanel
            scale           <0.925,0.7,0.85>
            translate       -0.05*ProfundidadTapa*z
                        +0.05*AlturaPanel*y
            pigment                 {
              image_map             {
                gif LRSC_BotonGif
              }
              translate   -0.51*x+0.1*y
              scale       < AnchoFundamental*0.95, AlturaPanel*0.7, 1 >
            }
            normal              {
              bumps
              scale     0.1*ProfundidadTapa
            }
          }
          cylinder      {
            +0.05*ProfundidadPanel*z           ,
            -0.1*ProfundidadPanel*z       ,
            0.12*AlturaPanel
            translate   0.42*AlturaPanel*y+0.31*AnchoFundamental*x
            rotate      AnguloPanel*x
            translate   -ProfundidadPanel*z
          }
          cylinder      {
            +0.05*ProfundidadPanel*z           ,
            -0.1*ProfundidadPanel*z       ,
            0.12*AlturaPanel
            translate   0.25*AlturaPanel*y-0.07*AnchoFundamental*x
            rotate      AnguloPanel*x
            translate   -ProfundidadPanel*z
          }
          cylinder      {
            +0.05*ProfundidadPanel*z           ,
            -0.1*ProfundidadPanel*z       ,
            0.115*AlturaPanel
            translate   0.25*AlturaPanel*y+0.05*AnchoFundamental*x
            rotate      AnguloPanel*x
            translate   -ProfundidadPanel*z
          }
        }
        union           {
          cylinder      {
            +0.05*z,
            -0.025*z       ,
            0.10
          }
          box           {
            <0.01,0.09,0>,
            <-0.01,-0.09,-0.05>
            rotate      30*z
            rotate      LRSC_AnguloBoton1*z
          }
          scale         <AlturaPanel,AlturaPanel,ProfundidadPanel>
          translate   0.42*AlturaPanel*y+0.31*AnchoFundamental*x
          rotate      AnguloPanel*x
          translate   -ProfundidadPanel*z
          texture       {
            TexturaBoton1
          }
        }
        union           {
          cylinder      {
            +0.05*z,
            -0.025*z       ,
            0.10
          }
          box           {
            <0.01,0.09,0>,
            <-0.01,-0.09,-0.05>
            rotate      110*z
            rotate      LRSC_AnguloBoton2*z
          }
          scale         <AlturaPanel,AlturaPanel,ProfundidadPanel>
          translate   0.25*AlturaPanel*y-0.07*AnchoFundamental*x
          rotate      AnguloPanel*x
          translate   -ProfundidadPanel*z
          texture       {
            TexturaBoton1
          }
        }
        union           {
          cylinder      {
            +0.05*z,
            -0.025*z       ,
            0.10
          }
          box           {
            <0.01,0.09,0>,
            <-0.01,-0.09,-0.05>
            rotate      110*z
            rotate      LRSC_AnguloBoton3*z
          }
          scale         <AlturaPanel,AlturaPanel,ProfundidadPanel>
          translate   0.25*AlturaPanel*y+0.05*AnchoFundamental*x
          rotate      AnguloPanel*x
          translate   -ProfundidadPanel*z
          texture       {
            TexturaBoton1
          }
        }
        union           {
          cylinder      {
            +0.070*z           ,
            -0.070*z       ,
            0.2
          }
          box         {
            <-0.01,0,-0.070>,
            <0.01,-0.3,0.070>
            rotate      10*z
            rotate      LRSC_AnguloBoton4*z
          }
          scale         <AlturaPanel,AlturaPanel,ProfundidadPanel>
          rotate      90*x
          translate   0.54*AlturaPanel*y-0.305*AnchoFundamental*x
          rotate      AnguloPanel*x
          translate   0.21*AlturaPanel*z
          translate   -ProfundidadPanel*z
          texture       {
            TexturaBoton2
          }
        }
        union           {
          cylinder      {
            +0.070*z           ,
            -0.070*z       ,
            0.2

          }
          box         {
            <-0.01,0,-0.070>,
            <0.01,-0.3,0.070>
            rotate      0*z
            rotate      LRSC_AnguloBoton5*z
          }
          scale         <AlturaPanel,AlturaPanel,ProfundidadPanel>
          rotate      90*x
          translate   0.38*AlturaPanel*y-0.305*AnchoFundamental*x
          rotate      AnguloPanel*x
          translate   0.215*AlturaPanel*z
          translate   -ProfundidadPanel*z
          texture       {
            TexturaBoton2
          }
        }
        union           {
          cylinder      {
            +0.070*z           ,
            -0.070*z       ,
            0.2

          }
          box         {
            <-0.01,0,-0.070>,
            <0.01,-0.3,0.070>
            rotate      10*z
            rotate      LRSC_AnguloBoton6*z
          }
          scale         <AlturaPanel,AlturaPanel,ProfundidadPanel>
          rotate      90*x
          translate   0.18*AlturaPanel*y-0.305*AnchoFundamental*x
          rotate      AnguloPanel*x
          translate   0.21*AlturaPanel*z
          translate   -ProfundidadPanel*z
          texture       {
            TexturaBoton2
          }
        }
      }
      union             {
        object            {
          FormaPanel
          scale           <0.025, 1.0, 1.0 >
          translate       -0.95*AnchoFundamental/2*x
        }
        object            {
          FormaPanel
          scale           <0.025, 1.0, 1.0 >
          translate       +0.95*AnchoFundamental/2*x
        }
        object            {
          FormaPanel
          scale           <1.0,0.1,FraccionSupPanel>
          translate       0.875*AlturaPanel*y
        }
        translate       +0.01*AlturaPanel*z
        texture         {
          TexturaMetalizada
        }
      }
      translate         -0.01*AlturaPanel*z
      translate         +ProfundidadFundamental/2*z
      translate AltoFundamental*y
      texture           {
        TexturaOscura
      }
    }
    // Giro interno
    #if ( !LRSC_POV3_1 )
      union               {
        #local RadioMayor        = DiametroInterior;
        isosurface {
          function  { f_helical_torus(x,y,z, 
                        RadioMayor, 3, 1.5, 0.5, 0.03, 0.6, 0.6, 0.2, 0.2, 0) }
                        //P0= Major radius
                        //P1= Nr of winding loops
                        //P2= Twistness winding
                        //P3= Flatness of winding?
                        //P4= Threshold
                        //P5= Negative minor radius?
                        //P6= Another fatness of winding control
                        //P7= Groove period
                        //P8= Groove amplitude
                        //P9= Groove phase
          contained_by { box { -2*<DiametroInterior,
                0.56428*ProfundidadFundamental,DiametroInterior>, 
                2*<DiametroInterior,
                0.56428*ProfundidadFundamental,DiametroInterior> } }
          max_gradient 13
          scale   0.1
        }
        cylinder          {
          0               , 0.01*AltoFundamental*y         ,
          DiametroIntroduccion/3
          translate       -0.1*AltoFundamental*y
        } 
        cylinder          {
          -0.1*AltoFundamental*y    , 0.15*AltoFundamental*y        ,
          0.05*DiametroIntroduccion
        }     
        texture         {
          TexturaHelice
        }   
        scale             <1.3,1.7,1.3>
        translate       ( 0.1+365/630 )*
                        ( 1-FraccionBaseSuperior )*AltoFundamental*y  
        rotate            AnguloGiro*y                  
      }     
      #if ( BanderaCanastilla )
        object              {     
          LRSC_Canastilla( AltoFundamental, DiametroIntroduccion, TexturaHelice )
          translate       0.24*AltoFundamental*y
          translate       ( 0.1+365/630 )*
                          ( 1-FraccionBaseSuperior )*AltoFundamental*y
          rotate            AnguloGiro*y
        } 
      #end
    #end
    difference          {
      superellipsoid    {
        <0.1,0.1>
        scale           <0.5,1,0.5>
        scale     < AnchoFundamental*0.95,
                            AltoZonaInferior,
                            ProfundidadFundamental*0.95  >
      }
      box               {
        -1,1
        scale           <0.5,1,0.5>
        scale     < AnchoFundamental*0.70,
                            AltoZonaInferior*1.1,
                            ProfundidadFundamental  >
      }
      box               {
        -1,1
        scale           <0.5,1,0.5>
        scale     < AnchoFundamental,
                            AltoZonaInferior*1.0,
                            ProfundidadFundamental*0.70  >
      }
      texture           {
        TexturaPatas
      }
    }
    #declare LRSC_PosicionCanastilla        =
                0.24*AltoFundamental*y+( 0.1+365/630 )*
                          ( 1-FraccionBaseSuperior )*AltoFundamental*y
                          +AltoZonaInferior*y;
    translate           AltoZonaInferior*y
  }
#end


#macro LRSC_Lavadora( AnguloTapa, AnguloGiro, BanderaCanastilla )
  #local L              = LRSC_L;
  #local AltoFundamental        = 630*L;
  #local AnchoFundamental       = 500*L;
  #local ProfundidadFundamental = 440*L;
  #local AlturaPanel            = 129*L;
  #local DiametroIntroduccion   = 271*L;
  object                {
    LRSC_LavadoraRopaSecadoCentrifugo
        ( AnguloTapa, AnguloGiro, BanderaCanastilla,
                AltoFundamental, AnchoFundamental, ProfundidadFundamental,
                AlturaPanel, DiametroIntroduccion,
                LRSC_DefaultTexturaPrincipal,
                LRSC_DefaultTexturaLavado,
                LRSC_DefaultTexturaOscura,
                LRSC_DefaultTexturaMetalizada,
                LRSC_DefaultTexturaHelice,
                LRSC_DefaultTexturaBoton1,
                LRSC_DefaultTexturaBoton2,
                LRSC_DefaultTexturaPatas )
  }
#end

