// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 17 abril 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// LRSC LavadoraRopaSecadoCentrifugo
// El archivo dibuja una lavadora de uso domestico.
// Puede abrir la tapa, y simular el movimiento interion sin ropa.
// #macro LRSC_Lavadora( AnguloTapa, AnguloGiro, BanderaCanastilla )
//      AnguloTapa              : Angulo de apertura de la lavadora.
//              Use cero para tapa cerrada.
//      AnguloGiro              : Para animar el giro de las partes internas.
//      BanderaCanastilla       : Aplica a la canastilla 
//              removible que se coloca sobre la ropa.  
//              "on" canastilla visible, "off" no se dibuja.
//
// La dimensiones de la lavadora son :
//      Alto total              = 767*L
//      Frente                  = 513*L
//      Fondo                   = 451*L
// Se dibuja centrado sobre el plano XY.  La canastilla, y el rotor central
// se encuentran alineados con el origen directamente en el centro
// de la lavadora.
//
// La siguiente macro permite mayor flexibilidad.
// #macro LRSC_LavadoraRopaSecadoCentrifugo
//        ( AnguloTapa, AnguloGiro, BanderaCanastilla,
//                AltoFundamental, AnchoFundamental, ProfundidadFundamental,
//                AlturaPanel, DiametroIntroduccion,
//                TexturaPrincipal, TexturaLavado, TexturaOscura,
//                TexturaMetalizada, TexturaHelice, TexturaBoton1,
//                TexturaBoton2, TexturaPatas )
//      AnguloTapa              : Angulo de apertura de la lavadora.
//              Use cero para tapa cerrada.
//      AnguloGiro              : Para animar el giro de las partes internas.
//      BanderaCanastilla       : Aplica a la canastilla 
//              removible que se coloca sobre la ropa.  
//              "on" canastilla visible, "off" no se dibuja.
//      AltoFundamental         : Alto de la estructura principal.
//              Default es 630*L.
//      AnchoFundamental        : Valor de referencia para el frente.
//              Default es 500*L.
//      ProfundidadFundamental  : Valor de referencia para la profundidad Z.
//              Default es 440*L.
//      AlturaPanel             : Alto del panel de control.
//              Default es 129*L.
//      DiametroIntroduccion    : Diametro del circulo por el que
//              ingresa la ropa.  Default es 271*L.
//      TexturaPrincipal        : Textura principal del aparato.
//              Default es LRSC_DefaultTexturaPrincipal.
//      TexturaLavado           : Textura del interior de la zona de lavado.
//              Default es LRSC_DefaultTexturaLavado.
//      TexturaOscura           : Textura lisa del panel, que sirve de fondo
//              en algunos sectores.  Especialmente la parte trasera.
//              Default es LRSC_DefaultTexturaOscura.
//      TexturaMetalizada       : Textura a aplicar a zonas metalicas del
//              panel de control.
//              Default es LRSC_DefaultTexturaMetalizada.
//      TexturaHelice           : Textura a aplicar al rotor y canastilla.
//              Default es LRSC_DefaultTexturaHelice.
//      TexturaBoton1           : Textura a aplicar a las perillas redondas.
//              Default es LRSC_DefaultTexturaBoton1.
//      TexturaBoton2           : Textura a aplicar a los selectores de la
//              izquierda.  Default es LRSC_DefaultTexturaBoton2.
//      TexturaPatas            : Textura a aplicar a las patas.
//              Default es LRSC_DefaultTexturaPatas.
//
// La siguiente macro dibuja la canastilla en forma independiente;  los
// parametros estan vinculados a la lavadora.
// #macro LRSC_Canastilla
//              ( AltoFundamental, DiametroIntroduccion, TexturaHelice )
//      AltoFundamental         : Alto de la estructura principal.
//              Default es 630*L.
//      DiametroIntroduccion    : Diametro del circulo por el que
//              ingresa la ropa.  Default es 271*L.
//      TexturaHelice           : Textura a aplicar al rotor y canastilla.
//              Default es LRSC_DefaultTexturaHelice.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare LRSC_PosicionCanastilla
//      Ubicacion original de la canastilla sin rotacion.
//      Sirve para ubicarlo en posicion cuando utilice la macro
//      LRSE_Canastilla().
// #declare LRSC_TexturaPrincipal
//      Textura principal del aparato.
// #declare LRSC_TexturaLavado
//      Textura del interior de la zona de lavado.
// #declare LRSC_TexturaOscura
//      Textura lisa del panel, que sirve de fondo
//      en algunos sectores.  Especialmente la parte trasera.
// #declare LRSC_TexturaMetalizada
//      Textura a aplicar a zonas metalicas del panel de control.
// #declare LRSC_TexturaHelice
//      Textura a aplicar al rotor y canastilla.
// #declare LRSC_TexturaBoton1
//      Textura a aplicar a las perillas redondas.
// #declare LRSC_TexturaBoton2
//      Textura a aplicar a los selectores de la izquierda.
// #declare LRSC_TexturaPatas
//      Textura a aplicar a las patas.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LRSC_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version elimina el dibujo del rotor y el canastilla;
//      que utilizan isosurface.
// #declare LRSC_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal del aparato.
// #declare LRSC_DefaultTexturaLavado           = texture { ... }
//      Textura del interior de la zona de lavado.
// #declare LRSC_DefaultTexturaOscura           = texture { ... }
//      Textura lisa del panel, que sirve de fondo
//      en algunos sectores.  Especialmente la parte trasera.
// #declare LRSC_DefaultTexturaMetalizada       = texture { ... }
//      Textura a aplicar a zonas metalicas del panel de control.
// #declare LRSC_DefaultTexturaHelice           = texture { ... }
//      Textura a aplicar al rotor y canastilla.
// #declare LRSC_DefaultTexturaBoton1           = texture { ... }
//      Textura a aplicar a las perillas redondas.
// #declare LRSC_DefaultTexturaBoton2           = texture { ... }
//      Textura a aplicar a los selectores de la izquierda.
// #declare LRSC_DefaultTexturaPatas            = texture { ... }
//      Textura a aplicar a las patas.
// #declare LRSC_BotonGif                       = "LRSC_IM1.GIF"
//      Dibujo GIF de las etiquetas de los botones.
//      Cuide la posicion de los botones.
// #declare LRSC_AdvertenciaGif                 = "LRSC_IM2.GIF"
//      Dibujo GIF del mensaje de advertencia e instrucciones.
//      De la zona inferior de la tapa.
// #declare LRSC_AnguloBoton1                   = 0;
//      Permite rotar la perilla de la derecha.
// #declare LRSC_AnguloBoton2                   = 0;
//      Permite rotar la perilla del grupo central izquierda.
// #declare LRSC_AnguloBoton3                   = 0;
//      Permite rotar la perilla del grupo central derecha.
// #declare LRSC_AnguloBoton4                   = 0;
//      Permite rotar el selector izquierdo superior.
// #declare LRSC_AnguloBoton5                   = 0;
//      Permite rotar el selector izquierdo central.
// #declare LRSC_AnguloBoton6                   = 0;
//      Permite rotar el selector izquierdo inferior.
//
// Para colocarlo simplemente
// #include "LRSC.inc"
// object        { LRSC_Lavadora(0,0,on) }
//
// Otro ejemplo con modificador
// #include "LRSC.inc"
// #declare LRSC_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 LRSC_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      LRSC_Lavadora( 90, 0, on )
// }
//
// Para colocar la canastilla
// #include "LRSC.inc"
// union                {
//   object             {
//     LRSC_Lavadora( 90, 0, off )
//   }
//   object             {
//     LRSC_Canastilla( 0.630, 0.271, LRSC_DefaultTexturaHelice )
//     translate        LRSC_PosicionCanastilla
//   }
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50

}

#include "LRSC.INC"

object          {
  LRSC_Lavadora( 10, 0, on )
  translate     -0.60*y  
}
