// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 enero 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// MCAI MicrofonoCompatibleAlgunosInstrumentos
// El archivo dibuja un microfono para computadora sencillo
// que puede modificarse con facilidad       
// #macro MCAI_Microfono( Angulo1, Angulo2, Desplazado )
//      Angulo1         : inclinacion en grados respecto de la vertical hacia adelante.
//      Angulo2         : rotacion del microfono respecto a eje Y.
//      Desplazado      : valor real para acercar o alejar el microfono, 
//                        manteniendo fija la base.
//
// Las dimensiones del microfono
// El microfono descansa en el plano XZ.
// Se dibuja de forma que la forma cilindrica guia quede casi centrada sobre el origen XZ.
// El microfono sobresale hacia Y+, partiendo desde el lado izquierdo X-.
//      Minimo Base     : <-46,  0,-42>*L aprox
//      Maximo Base     : < 39, 43, 42>*L aprox
//      Alto            : 195*L { parametros (0,0,0) }
//
// La siguiente macro permite modificar varias caracteristicas facilmente.
// #macro MCAI_MicrofonoCompatibleAlgunosInstrumentos
//              ( Angulo1, Angulo2, Desplazado,
//                DiametroBase, AltoBase, GruesoDecorativo,
//                LargoBarra1, LargoBarra2, AnguloBarra, DiametroBarra,
//                LargoMIC, DiametroMIC,
//                TexturaSoporte, TexturaBarra, TexturaCabeza )
//      Angulo1          : inclinacion en grados respecto de la vertical hacia adelante.
//      Angulo2          : rotacion del microfono respecto a eje Y.
//      Desplazado       : valor real para acercar o alejar el microfono, 
//                         manteniendo fija la base.
//      DiametroBase     : valor referencia para el diametro de base.  Default es 81*L.
//      AltoBase         : valor del alto de la base.  Default es 10.6*L.
//      GruesoDecorativo : grueso para algunas decoraciones.  Default es 2*L.
//      LargoBarra1      : valor referencia para el largo del segundo tronco cilindrico 
//                         que sostiene el microfono.  Default es 82*L.
//      LargoBarra2      : largo del primer tronco cilindrico del microfono.  
//                         Default es 100*L.
//      AnguloBarra      : angulo de quiebre en el tronco cilindrico del microfono.
//                         Default es 23.50.
//      DiametroBarra    : diametro del tronco del microfono.  Default es 4.3*L.
//      LargoMIC         : largo de la cabeza del microfono.  Default es 30*L.
//      DiametroMIC      : diametro principal de la cabeza del microfono.  Default es 11*L.
//      TexturaSoporte   : textura a aplicar al soporte.  
//                         Default es MCAI_TexturaSoporteDefault.
//      TexturaBarra     : textura a aplicar a la barra cilindrica angular.
//                         Default es MCAI_TexturaBarraDefault.     
//      TexturaCabeza    : textura a aplicar ala cabeza del microfono.
//                         Default es MCAI_TexturaCabezaDefault.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare MCAI_GuiaCable
//      Generado con las macros de este archivo.  Ubica el punto de salida de
//      un cable de conduccion de senal, no suministrado en esta version.
// #declare MCAI_TexturaSoporte
//      Textura a aplicar a la base soporte.
// #declare MCAI_TexturaBarra
//      Textura a aplicar a las barras cilindricas.
// #declare MCAI_TexturaCabeza
//      Textura a aplicar a la cabeza que recibe el sonido. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare MCAI_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare MCAI_TexturaSoporteDefault          = texture { ... }
//      Textura a aplicar a la base soporte.
// #declare MCAI_TexturaBarraDefault            = texture { ... }
//      Textura a aplicar a las barras cilindricas.
// #declare MCAI_TexturaCabezaDefault           = texture { ... }
//      Textura a aplicar a la cabeza que recibe el sonido. 
// #declare MCAI_BanderaMarcaPovRay             = true;
//      Valor "true" escribe la marca, "false" no la escribe.
// #declare MCAI_MarcaPovRay                    = "POV-Ray"  
//      Permite cambiar la marca del microfono.
// #declare MCAI_HCorregirMarcaPovRay           = 0;
//      Para desplazar horizontalmente el nombre de marca.
//      Valores positivos desplazan hacia derecha o Z+.
// #declare MCAI_ColorMarcaPovRay               = Red; 
//      Permite cambiar el color de despliegue de las letras de marca.
//
// Para colocarlo simplemente
// #include "MCAI.inc"
// object        { MCAI_Microfono(20,20,-0.001) }
//
// Otro ejemplo con modificador
// #include "MCAI.inc"
// #declare MCAI_TexturaSoporteDefault        = texture       {
//   average
//   texture_map        {
//     [ 0.5 MCAI_TexturaSoporte        ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      MCAI_Microfono(0,0,0)
// }
//
// Otro ejemplo con macro de parametros
// #include "MCAI.inc"
// object             {
//   MCAI_MicrofonoCompatibleAlgunosInstrumentos( 0, 0, 0,
//       0.081, 0.0106, 0.002, 0.082, 0.1, 23.5, 0.0043, 0.03, 0.011,
//       MCAI_TexturaSoporteDefault, MCAI_TexturaBarraDefault,
//       MCAI_TexturaCabezaDefault )
// }
//   

#include "colors.inc"

#declare MCAI_BanderaMarcaPovRay        = true;
#declare MCAI_MarcaPovRay               = "POV-Ray"
#declare MCAI_HCorregirMarcaPovRay      = 0;
#declare MCAI_ColorMarcaPovRay          = Red;
// MCAI_GuiaCable

#if ( version < 3.2 )
  #ifndef( MCAI_POV3_1 )
    #declare MCAI_POV3_1        = on;
  #end
#else
  #ifndef( MCAI_POV3_1 )
    #declare MCAI_POV3_1        = off;
  #end
#end

#declare MCAI_L                 = 0.001;

#declare MCAI_TexturaSoporte                    =
  texture               {
    pigment     {
      color <0.96,0.92,0.88>
    }
    normal      {
      bumps
      scale     0.2
    }
    finish       {
      phong      0.01
      phong_size 0.01
    }
//    pigment { color <0.96,0.80,0.69> }
  }

#ifndef ( MCAI_TexturaSoporteDefault )
  #declare MCAI_TexturaSoporteDefault           =
        texture { MCAI_TexturaSoporte }
#end

#declare MCAI_TexturaBarra                      =
  texture               {
    pigment     {
      color <0.90,0.98,0.98>
    }
    normal      {
      bumps
      scale     0.2
    }
    finish       {
      phong      0.01
      phong_size 0.01
    }
  }

#ifndef ( MCAI_TexturaBarraDefault )
  #declare MCAI_TexturaBarraDefault             =
        texture { MCAI_TexturaBarra }
#end

#declare MCAI_TexturaCabeza                     =
  texture               {
    pigment     {
      color <0.96,0.92,0.88>*0.50
    }
    normal      {
      onion
      turbulence        1
      scale     0.0001
    }
    finish       {
      phong      0.01
      phong_size 0.01
    }
  }

#ifndef ( MCAI_TexturaCabezaDefault )
  #declare MCAI_TexturaCabezaDefault            =
        texture { MCAI_TexturaCabeza }
#end

#if ( version < 3.2 )
  #ifndef( PCPD_POV3_1 )
    #declare PCPD_POV3_1        = on;
  #end
#else
  #ifndef( PCPD_POV3_1 )
    #declare PCPD_POV3_1        = off;
  #end
#end

#declare PCPD_L                 = 0.001;



#macro MCAI_MicrofonoCompatibleAlgunosInstrumentos
  ( Angulo1, Angulo2, Desplazado,
    DiametroBase, AltoBase, GruesoDecorativo,
    LargoBarra1, LargoBarra2, AnguloBarra, DiametroBarra,
    LargoMIC, DiametroMIC,
    TexturaSoporte, TexturaBarra, TexturaCabeza )
  union                         {
    // Soporte Basico
    #if ( MCAI_BanderaMarcaPovRay )
      text                    {
        ttf "timrom.ttf", MCAI_MarcaPovRay 1, 0
        translate -2*x-y//+MCAI_HCorregirMarcaPovRay*x
        scale   DiametroBase/15
        rotate  -90*y
        rotate  +90*z
        translate AltoBase*y   
        translate MCAI_HCorregirMarcaPovRay*z
        pigment { MCAI_ColorMarcaPovRay }
      }
    #end
    union                       {
      difference                {
        intersection            {
          #local RadioBase      = DiametroBase/2;
          #local Pivote         = AltoBase-GruesoDecorativo;
          #local RadioVirtual   = 0.5*( RadioBase*RadioBase/Pivote
                        +AltoBase-GruesoDecorativo );
          cylinder              {
            0, RadioVirtual*y,
            RadioBase
          }  //  cylinder
          sphere                {
            -( RadioVirtual-AltoBase )*y,
            RadioVirtual
          }  // sphere
        }  //  intersection
        cylinder                {
          -RadioVirtual*y, RadioVirtual*y, DiametroBase
          translate     0.80*( 0.80*DiametroBase*x-1.30*DiametroBase*z )
        }  // cylinder
        cylinder                {
          -RadioVirtual*y, RadioVirtual*y, DiametroBase
          translate     0.80*( 0.80*DiametroBase*x+1.30*DiametroBase*z )
        }  // cylinder
        plane                   { -x, -0.30*RadioBase }
      }  //  difference
      intersection              {
        #local RadioInterior    = DiametroBase/2-GruesoDecorativo;
        #local AlturaInterior   = AltoBase-GruesoDecorativo;
        #local Pivote           = AlturaInterior-GruesoDecorativo;
        #local RadioVirtual     = 0.5*( RadioInterior*RadioInterior/Pivote
                        +AlturaInterior-GruesoDecorativo );
        cylinder                {
          0, RadioVirtual*y,
          RadioInterior
        }  // cylinder
        sphere                  {
          -( RadioVirtual-AlturaInterior )*y,
          RadioVirtual
        }  // sphere
      }  // intersection
      texture                   {
        TexturaSoporte
      }
    }  // union Soporte Basico
    //  zona superior
    union                       {
      #local GruesoSuper        = GruesoDecorativo;
      #local DiametroSuper      = 27.7/81*DiametroBase;
      #local RadioSuper         = DiametroSuper/2;
      #local AltoSuper          = 28.6/81*DiametroBase;
      #local DesplazadoSuper    = 32.0/81*DiametroBase;
      #local GuiaBarra          = 10/81*DiametroBase;
      // Soporte de Barrita MIC
      difference                {
        union                   {
          difference            {
            sphere              {
              0, RadioSuper
              scale             0.98*<1,1,2>
            }
            plane               {
              z, -GuiaBarra*0.96        }
          }
          difference            {
            sphere              {
              0, RadioSuper
              scale             0.98*<1,1,2>
            }
            plane               {
              z, -GuiaBarra*0.98
            }
            scale <0.90,0.90,1>
          }
        }
        plane                   { -z, 0 }
        cylinder                {
          -DiametroSuper*y, +DiametroSuper*y, 1.1*DiametroBarra/2
          translate     -( GuiaBarra-DiametroBarra/2 )*z
        }
      }  // difference
      // Barritas y Cabeza MIC
      union                     {
        // Barrita Superior y Cabeza MIC
        union                   {
          // MIC
          union                 {
            #local AltoSuperiorMIC      = LargoMIC/6;
            #local AltoInferiorMIC      = LargoMIC-AltoSuperiorMIC;
            difference          {
              sphere            {
                0, DiametroMIC/2
                scale           <1,1.25,1>
              }
              plane             {
                y, 0
              }
              plane             {
                -y, -AltoSuperiorMIC
              }
            }
            difference          {
              sphere            {
                0, DiametroMIC/2
                scale           <1,6,1>
              }
              plane             {
                -y, 0
              }
              plane             {
                y, -AltoInferiorMIC
              }
            }
            translate           LargoBarra1*y
            texture             {
              TexturaCabeza
            }
          }  // union MIC
          cylinder              {
            0, LargoBarra1*y, DiametroBarra/2
          }  // cylinder BarritaSuperior
          sphere                {
            0, DiametroBarra/2
          }
          rotate                -AnguloBarra*z
        }
        cylinder                {
          0, -LargoBarra2*y, DiametroBarra/2
        }
        translate               +5*LargoBarra2*y/6+Desplazado*y
        rotate                  Angulo1*y
        translate               -( GuiaBarra-DiametroBarra/2 )*z
        texture                 {
          TexturaBarra
        }
      }  // Barritas y Cabeza MIC
      rotate                    -Angulo2*z
      translate                 AltoSuper*y-DesplazadoSuper*x
      texture                   {
        TexturaSoporte
      }
    }
    union                       {
      superellipsoid            {
        < 1.0, 0.2 >
        scale      < RadioSuper, RadioSuper, GruesoSuper/2 >
      }
      difference                {
        cylinder                  {
          -GruesoSuper/2*z, +GruesoSuper/2*z, RadioSuper
          scale           <1.25,5,1.25>
          translate       -4*RadioSuper*y
          rotate          15*z
        }
        plane                   { y, -AltoSuper }
      }
      translate                 AltoSuper*y-DesplazadoSuper*x
      texture                   {
        TexturaSoporte
      }
    }
    #declare MCAI_GuiaCable     = ( -LargoBarra2/6+Desplazado )*y;
    #declare MCAI_GuiaCable     = vaxis_rotate( MCAI_GuiaCable, z, -Angulo2 )
        +AltoSuper*y-DesplazadoSuper*x-( GuiaBarra-DiametroBarra/2 )*z;
  }
#end

#macro MCAI_Microfono( Angulo1, Angulo2, Desplazado )
  object                        {
    #local L                    = MCAI_L;
    #local DiametroBase         = 81*L;
    #local AltoBase             = 10.6*L;
    #local GruesoDecorativo     = 2*L;
    #local LargoBarra1          = 82*L;
    #local LargoBarra2          = 100*L;
    #local AnguloBarra          = 23.50;
    #local DiametroBarra        = 4.3*L;
    #local LargoMIC             = 30*L;
    #local DiametroMIC          = 11*L;
    MCAI_MicrofonoCompatibleAlgunosInstrumentos( Angulo1, Angulo2, Desplazado,
      DiametroBase, AltoBase, GruesoDecorativo,
      LargoBarra1, LargoBarra2, AnguloBarra, DiametroBarra,
      LargoMIC, DiametroMIC,
      MCAI_TexturaSoporteDefault, MCAI_TexturaBarraDefault,
      MCAI_TexturaCabezaDefault )
  }
#end
