// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 enero 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// MCAI MicrofonoCompatibleAlgunosInstrumentos
// El archivo dibuja un microfono para computadora sencillo
// que puede modificarse con facilidad       
// #macro MCAI_Microfono( Angulo1, Angulo2, Desplazado )
//      Angulo1         : inclinacion en grados respecto de la vertical hacia adelante.
//      Angulo2         : rotacion del microfono respecto a eje Y.
//      Desplazado      : valor real para acercar o alejar el microfono, 
//                        manteniendo fija la base.
//
// Las dimensiones del microfono
// El microfono descansa en el plano XZ.
// Se dibuja de forma que la forma cilindrica guia quede casi centrada sobre el origen XZ.
// El microfono sobresale hacia Y+, partiendo desde el lado izquierdo X-.
//      Minimo Base     : <-46,  0,-42>*L aprox
//      Maximo Base     : < 39, 43, 42>*L aprox
//      Alto            : 195*L { parametros (0,0,0) }
//
// La siguiente macro permite modificar varias caracteristicas facilmente.
// #macro MCAI_MicrofonoCompatibleAlgunosInstrumentos
//              ( Angulo1, Angulo2, Desplazado,
//                DiametroBase, AltoBase, GruesoDecorativo,
//                LargoBarra1, LargoBarra2, AnguloBarra, DiametroBarra,
//                LargoMIC, DiametroMIC,
//                TexturaSoporte, TexturaBarra, TexturaCabeza )
//      Angulo1          : inclinacion en grados respecto de la vertical hacia adelante.
//      Angulo2          : rotacion del microfono respecto a eje Y.
//      Desplazado       : valor real para acercar o alejar el microfono, 
//                         manteniendo fija la base.
//      DiametroBase     : valor referencia para el diametro de base.  Default es 81*L.
//      AltoBase         : valor del alto de la base.  Default es 10.6*L.
//      GruesoDecorativo : grueso para algunas decoraciones.  Default es 2*L.
//      LargoBarra1      : valor referencia para el largo del segundo tronco cilindrico 
//                         que sostiene el microfono.  Default es 82*L.
//      LargoBarra2      : largo del primer tronco cilindrico del microfono.  
//                         Default es 100*L.
//      AnguloBarra      : angulo de quiebre en el tronco cilindrico del microfono.
//                         Default es 23.50.
//      DiametroBarra    : diametro del tronco del microfono.  Default es 4.3*L.
//      LargoMIC         : largo de la cabeza del microfono.  Default es 30*L.
//      DiametroMIC      : diametro principal de la cabeza del microfono.  Default es 11*L.
//      TexturaSoporte   : textura a aplicar al soporte.  
//                         Default es MCAI_TexturaSoporteDefault.
//      TexturaBarra     : textura a aplicar a la barra cilindrica angular.
//                         Default es MCAI_TexturaBarraDefault.     
//      TexturaCabeza    : textura a aplicar ala cabeza del microfono.
//                         Default es MCAI_TexturaCabezaDefault.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare MCAI_GuiaCable
//      Generado con las macros de este archivo.  Ubica el punto de salida de
//      un cable de conduccion de senal, no suministrado en esta version.
// #declare MCAI_TexturaSoporte
//      Textura a aplicar a la base soporte.
// #declare MCAI_TexturaBarra
//      Textura a aplicar a las barras cilindricas.
// #declare MCAI_TexturaCabeza
//      Textura a aplicar a la cabeza que recibe el sonido. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare MCAI_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare MCAI_TexturaSoporteDefault          = texture { ... }
//      Textura a aplicar a la base soporte.
// #declare MCAI_TexturaBarraDefault            = texture { ... }
//      Textura a aplicar a las barras cilindricas.
// #declare MCAI_TexturaCabezaDefault           = texture { ... }
//      Textura a aplicar a la cabeza que recibe el sonido. 
// #declare MCAI_BanderaMarcaPovRay             = true;
//      Valor "true" escribe la marca, "false" no la escribe.
// #declare MCAI_MarcaPovRay                    = "POV-Ray"  
//      Permite cambiar la marca del microfono.
// #declare MCAI_HCorregirMarcaPovRay           = 0;
//      Para desplazar horizontalmente el nombre de marca.
//      Valores positivos desplazan hacia derecha o Z+.
// #declare MCAI_ColorMarcaPovRay               = Red; 
//      Permite cambiar el color de despliegue de las letras de marca.
//
// Para colocarlo simplemente
// #include "MCAI.inc"
// object        { MCAI_Microfono(20,20,-0.001) }
//
// Otro ejemplo con modificador
// #include "MCAI.inc"
// #declare MCAI_TexturaSoporteDefault        = texture       {
//   average
//   texture_map        {
//     [ 0.5 MCAI_TexturaSoporte        ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      MCAI_Microfono(0,0,0)
// }
//
// Otro ejemplo con macro de parametros
// #include "MCAI.inc"
// object             {
//   MCAI_MicrofonoCompatibleAlgunosInstrumentos( 0, 0, 0,
//       0.081, 0.0106, 0.002, 0.082, 0.1, 23.5, 0.0043, 0.03, 0.011,
//       MCAI_TexturaSoporteDefault, MCAI_TexturaBarraDefault,
//       MCAI_TexturaCabezaDefault )
// }
//   

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "MCAI.inc"

#declare FactorAcercamiento     = 6;

object                  {
  MCAI_Microfono( 0, 0, 0 )
  translate             -0.1*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z       
}


