// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 marzo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// MEPV MicroondasElectricoPlatoVidrio
// El archivo dibuja un aparato microondas corriente
// incluye plato de vidrio y soporte de plato giratorios.
// #macro MEPV_HornoMicroondas( AnguloPuerta, AnguloGiratorio )
//      AnguloPuerta            : Angulo para abrir la puerta del microondas,
//                      cero se considera cerrado.  Utilice valores positivos.
//      AnguloGiratorio         : Rotacion poco visible.
//                      Produce una rotacion Y del plato y su
//                      soporte.  En realidad el soporte de plato,
//                      solo rotara la mitad del angulo, para simular
//                      el efecto de las rueditas.
//
// Las caracteristicas serian
//      Altura total microondas : 215*L
//      Altura sin base         : 197*L
//      Frente microondas       : 372*L
//      Profundidad microondas  : 290*L aprox +14.5*L hasta -275*Z
//      Centro superior plato   : <-33,42.5,-134>*L
// El aparato se encuentra sobre el plano XY, el frente hacia Z-.
// Centrado en el eje X.
//
// Tambien puede generarse el objeto con la siguiente macro
// #macro MEPV_MicroondasElectricoPlatoVidrio
//         ( FrenteBase, AltoBase, FondoBase, AlturaSoporte, RadioDecorativo,
//           VisibleAroCentral, VisiblePlato, AnguloPuerta, AnguloGiratorio,
//           TexturaPrincipal, TexturaVentanilla,
//           TexturaSoporte, TexturaGiratoria, TexturaPlato )
//      FrenteBase              : Para modificar el tamano del frente.
//                      Valor default es 372*L.
//      AltoBase                : Para modificar el alto del aparato sin
//                      soporte inferior.  Valor default es 197*L.
//      FondoBase               : Relacionado con el tamano del fondo.
//                      Valor default es 244*L.
//      AlturaSoporte           : Altura de las patas y soporte del aparato.
//                      Valor default es 18*L.
//      RadioDecorativo         : Radio base para intersecciones curvas.
//                      Valor default es 5.4*L.
//      VisibleAroCentral       : on dibuja el aro soporte giratorio,
//                                off no lo dibuja.  Default es on.
//      VisiblePlato            : on dibuja el plato giratorio.
//                                off no lo dibuja.  Default es on.
//      AnguloPuerta            : Angulo para abrir la puerta del microondas,
//                      cero se considera cerrado.  Utilice valores positivos.
//      AnguloGiratorio         : Rotacion poco visible.
//                      Produce una rotacion Y del plato y su
//                      soporte.  En realidad el soporte de plato,
//                      solo rotara la mitad del angulo, para simular
//                      el efecto de las rueditas.
//      TexturaPrincipal        : Textura principal a aplicar al aparato.
//                      Es probable que surjan inconsistencias con las
//                      imagenes superpuestas.
//                      Default es MEPV_DefaultTexturaPrincipal.
//      TexturaVentanilla       : Textura a aplicar a la ventanilla visor.
//                      Default es MEPV_DefaultTexturaVentanilla.
//      TexturaSoporte          : Textura a aplicar a la base soporte.
//                      Default es MEPV_DefaultTexturaSoporte.
//      TexturaGiratoria        : Textura para el aro giratorio.
//                      Default es MEPV_DefaultTexturaGiratoria.
//      TexturaPlato            : Textura para el plato.
//                      Defualt es MEPV_DefaultTexturaPlato.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare MEPV_TexturaPrincipal       = Textura principal a aplicar
//      al aparato.
// #declare MEPV_TexturaVentanilla      = Textura a aplicar a la ventana
//      visor de los alimentos.
// #declare MEPV_TexturaSoporte         = Textura a aplicar a la base
//      soporte.
// #declare MEPV_TexturaGiratoria       = Textura para el aro giratorio.
// #declare MEPV_TexturaPlato           = Textura para el plato giratorio.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare MEPV_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare MEPV_DefaultTexturaPrincipal      = texture { ... }
//      Textura principal a aplicar al aparato.
// #declare MEPV_DefaultTexturaVentanilla      = texture { ... }
//      Textura a aplicar a la ventana visor de los alimentos.
// #declare MEPV_DefaultTexturaSoporte         = texture { ... }
//      Textura a aplicar a la base soporte.
// #declare MEPV_DefaultTexturaGiratoria       = texture { ... }
//      Textura a aplicar al aro giratorio.
// #declare MEPV_DefaultTexturaPlato           = texture { ... }
//      Textura a aplicar al plato giratorio.
// #declare MEPV_VisibleImagen1                = on;
//      Vuelve visible o no la imagen de los botones de presion.
// #declare MEPV_VisibleImagen2                = on;
//      Vuelve visible o no la etiqueta posterior.
// #declare MEPV_NombreImagen1                 = "MEPV_IM1.GIF"
//      Nombre de la imagen que corresponde a los botones.
//      La imagen actual es algo borrosa
//      tomada con una camara promocional de la pelicula "Hulk",
//      sin duda puede mejorarse bastante.
// #declare MEPV_NombreImagen2                 = "MEPV_IM2.GIF"
//      Nombre de la imagen que corresponde a la etiqueta posterior.
//      La imagen actual es algo borrosa
//      tomada con una camara promocional de la pelicula "Hulk",
//      sin duda puede mejorarse bastante.
// #declare MEPV_ColorTornillo                 = pigment {Gray30}
//      Color como pigment de los tornillos.
// #declare MEPV_ColorTornilloDiferencia       = pigment {Gray70}
//      Color como pigment de las ranuras;
//      necesario para dar relieve a los tornillos.
//
// Para colocarlo simplemente
// #include "MEPV.inc"
// object        { MEPV_HornoMicroondas( 0, 0 ) }
//
// Otro ejemplo con modificador
// #include "MEPV.inc"
// #declare MEPV_DefaultTexturaPrincipal        = texture       {
//   PinkAlabaster
// }
// #declare MEPV_VisibleImagen1                 = off;
// #declare MEPV_DefaultTexturaVentanilla       = texture       {
//   average
//   texture_map        {
//     [ 0.5 MEPV_TexturaVentanilla     ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        { MEPV_HornoMicroondas( 0, 0 ) }
//

#include "colors.inc"   
#include "glass.inc"

#declare MEPV_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( MEPV_POV3_1 )
    #declare MEPV_POV3_1        = on;
  #end
#else
  #ifndef( MEPV_POV3_1 )
    #declare MEPV_POV3_1        = off;
  #end
#end

#ifndef ( MEPV_VisibleImagen1 )
  #declare MEPV_VisibleImagen1  = on;
#end

#ifndef ( MEPV_VisibleImagen2 )
  #declare MEPV_VisibleImagen2  = on;
#end

#ifndef ( MEPV_NombreImagen1 )
  #declare MEPV_NombreImagen1   = "MEPV_IM1.GIF"
#end

#ifndef ( MEPV_NombreImagen2 )
  #declare MEPV_NombreImagen2   = "MEPV_IM2.GIF"
#end

#ifndef ( MEPV_ColorTornillo )
  #declare MEPV_ColorTornillo   =       pigment {
    color Gray70
  }
#end

#ifndef ( MEPV_ColorTornilloDiferencia )
  #declare MEPV_ColorTornilloDiferencia         =       pigment {
    color Gray30
  }
#end

#declare MEPV_TexturaPrincipal  = texture       {
  pigment                       {
    White
  }
  normal              {
    bumps
  }
}

#ifndef ( MEPV_DefaultTexturaPrincipal )
  #declare MEPV_DefaultTexturaPrincipal         = texture       {
    MEPV_TexturaPrincipal
  }
#end

#declare MEPV_TexturaGiratoria  = texture       {
  pigment                       {
    color       White*0.9+Yellow*0.1
  }
}

#ifndef ( MEPV_DefaultTexturaGiratoria )
  #declare MEPV_DefaultTexturaGiratoria         = texture       {
    MEPV_TexturaGiratoria
  }
#end

#declare MEPV_TexturaPlato      = texture       {
       T_Glass1
       normal           {
         granite
         scale          .01
       }   
}

#ifndef ( MEPV_DefaultTexturaPlato    )
  #declare MEPV_DefaultTexturaPlato             = texture       {
    MEPV_TexturaPlato
  }
#end

#declare MEPV_TexturaSoporte    = texture       {
  pigment                       {
    Silver
  }
}

#ifndef ( MEPV_DefaultTexturaSoporte )
  #declare MEPV_DefaultTexturaSoporte      = texture       {
    MEPV_TexturaSoporte
  }
#end

#declare MEPV_TexturaVentanilla         = 
texture       {  
  T_Old_Glass
}  
texture         {
  pigment       {
    gradient    y
    scale       .001 
    turbulence  0.1
    pigment_map {
      [ 0.5 color Gray30 ]
      [ 0.5 rgbt  0.80   ]
    }
  }
}

#ifndef ( MEPV_DefaultTexturaVentanilla )
  #declare MEPV_DefaultTexturaVentanilla   = texture       {
    MEPV_TexturaVentanilla
  }
#end

#macro MEPV_Tornillo ( FrenteBase, AltoBase, FondoBase )
  difference                  {
    sphere                    {
      0                       , AltoBase/40
      scale                   <0.2,0.8,0.8>
      translate               -AltoBase/160*x
    }
    cylinder                  {
      -AltoBase/40*y          , AltoBase/40*y,
      AltoBase/400
      rotate                  10*x
      pigment         {
        MEPV_ColorTornilloDiferencia
      }
    }
    cylinder                  {
      -AltoBase/40*y          , AltoBase/40*y,
      AltoBase/400
      rotate                  100*x
      pigment         {
        MEPV_ColorTornilloDiferencia
      }
    }
    pigment                   { MEPV_ColorTornillo }
  }
#end

#macro MEPV_PlatoGiratorio ( Radio, Alto, TexturaPlato )
  lathe                 {
    quadratic_spline
    6,
    <0,-0.1>,
    <0,0>,
    <0,0.5>,
    <1,1>,
    <0.5,0.5>,
    <0,0.2>
    scale               < Radio, Alto, Radio >
    texture             {
      TexturaPlato
    }
  }
#end

#macro MEPV_AroCentral( Radio, Alto, TexturaGiratoria )
  union                 {
    difference          {
      cylinder          {
        -Alto/8*y       , +Alto/8*y     ,
        Radio*1.05
      }
      cylinder          {
        -Alto*y         , +Alto*y       ,
        Radio*0.95
      }
    }
    #local C            = 0;
    #while ( C < 3 )
      cylinder          {
        1.05*Radio*x    , 1.10*Radio*x  ,
        Alto/2
        rotate          C*120*y
      }
      #local C          = C+1;
    #end
    texture             {
      TexturaGiratoria
    }
  }
#end

#macro MEPV_MicroondasElectricoPlatoVidrio
           ( FrenteBase, AltoBase, FondoBase, AlturaSoporte, RadioDecorativo,
             VisibleAroCentral, VisiblePlato, AnguloPuerta, AnguloGiratorio,
             TexturaPrincipal, TexturaVentanilla,
             TexturaSoporte, TexturaGiratoria, TexturaPlato )
  union                         {
    union                         {
      #if ( VisibleAroCentral )
        #local AltoInterior         = 22/197*AltoBase;
        object                    {
          MEPV_AroCentral( FondoBase/4, AltoInterior/2, TexturaGiratoria )
          rotate                AnguloGiratorio*y/2
          translate               AltoInterior*y
                          -1.5*AltoInterior*x-FondoBase/2*z
                          -1/20*FondoBase*z
        }
      #end
      #if ( VisiblePlato )
        object                  {
          MEPV_PlatoGiratorio( FondoBase/3*1.3, AltoInterior/2, TexturaPlato )
          rotate                AnguloGiratorio*y
          translate             AltoInterior*y
                          -1.5*AltoInterior*x-FondoBase/2*z
                          -1/20*FondoBase*z
        }
      #end
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        translate               1.2*AltoBase/2*y-FondoBase/2*z+FrenteBase/2*x
      }
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        rotate                  -90*y
        translate               0.95*AltoBase*y+FrenteBase/2*0.90*x
                                +0.01*FondoBase*z
      }
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        rotate                  -90*y
        translate               0.95*AltoBase*y-FrenteBase/2*0.90*x
                                +0.01*FondoBase*z
      }
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        rotate                  -90*y
        translate               0.95*AltoBase*y
                                +0.01*FondoBase*z
      }
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        rotate                  -90*y
        translate               0.05*AltoBase*y
                                +0.01*FondoBase*z
      }
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        rotate                  -90*y
        translate               0.05*AltoBase*y-FrenteBase/2*0.90*x
                                +0.01*FondoBase*z
      }
      object                      {
        MEPV_Tornillo( FrenteBase, AltoBase, FondoBase )
        rotate                  -90*y
        translate               0.05*AltoBase*y+FrenteBase/2*0.90*x
                                +0.01*FondoBase*z
      }
      #local AltoInterior         = 22/197*AltoBase;
      difference                  {
        box                       {
          < -FrenteBase/2, 0, 0 >,
          < +FrenteBase/2, AltoBase-RadioDecorativo, -FondoBase >
        }
        #local C                = 0;
        #while ( C < 10 )
          #local D              = 0;
          #while ( D < 12 )
            sphere                {
              0                   , FrenteBase/300
              translate           0.8*AltoBase*y+0.45*FrenteBase*x
                                  -C*0.015*FrenteBase*x
                                  -D*0.03*AltoBase*y
              texture             {
                TexturaSoporte
              }
            }
            #local D            = D+1;
          #end
          #local C              = C+1;
        #end
        box                       {
          < -FrenteBase/2+AltoInterior, AltoInterior, -2*FondoBase >,
          < +FrenteBase/2-4*AltoInterior, AltoBase-4/3*AltoInterior,
                  -1/10*FondoBase >
        }
        difference                {
          torus                   {
            FondoBase/4,  FondoBase/16
          }
          cylinder                {
            -FondoBase*y          , -AltoInterior/4*y     ,
            FondoBase
          }
          translate               AltoInterior*y
                          -1.5*AltoInterior*x-FondoBase/2*z-1/20*FondoBase*z
        }
        superellipsoid            {
          < 0.1, 0.1 >
          scale   < AltoInterior/6, AltoBase/3.8, FondoBase/3.8 >
          translate
                  < -FrenteBase/2+AltoInterior, AltoBase/2, -FondoBase/2 >
        }
        superellipsoid            {
          < 0.1, 0.1 >
          scale   < AltoInterior/6, AltoBase/3.8, FondoBase/3.8 >
          translate
                  < +FrenteBase/2-4*AltoInterior, AltoBase/2, -FondoBase/2 >
        }
        superellipsoid            {
          < 0.3, 0.9 >
          scale   < FondoBase/2.2, AltoBase/3, AltoInterior/3 >
          translate       < -1.5*AltoInterior, AltoBase/2, -1/10*FondoBase >
        }
        superellipsoid            {
          < 0.1, 0.1 >
          scale   < FondoBase/3, AltoBase/4, AltoInterior/2.5 >
          translate       < -1.5*AltoInterior, AltoBase/2, -1/10*FondoBase >
        }
        // decoraciones laterales
        sphere                    {
          0                       , AltoBase/40
          translate               1.2*AltoBase/2*y
                                        -FondoBase/2*z+FrenteBase/2*x
        }
        #local C                  = 0;
        #while ( C < 3 )
          #local D                = 0;
          #while ( D < 12 )
            difference                {
              superellipsoid          {
                <0.8,0.8>
                scale                 AltoBase/10
                scale                 <1/6,0.9,1/6>
                translate               AltoBase/2*y
                                  -FondoBase/2*z-FrenteBase/2*x
              }
              plane                   {
                +z             , 0
                rotate         +45*y
                translate               AltoBase/2*y
                                        -FondoBase/2*z-FrenteBase/2*x
              }
              translate               C*AltoBase*y/4.5-0.8*AltoBase/5*y
                                          -D*FondoBase/30*z
            }
            #local D              = D+1;
          #end
          #local C                = C+1;
        #end
      }
      // Puertecilla
      union                       {
        box                     {
          < -FrenteBase/3*1.2, -AltoBase/3*1.1, -1/11*FondoBase >,
          < +FrenteBase/4*1.2, +AltoBase/3, -1/11*FondoBase*1.01 >
          texture               {
            TexturaVentanilla
          }
        }
        difference                {
          difference              {
            superellipsoid          {
              < 0.1, 0.3 >
              scale         < FrenteBase/2, AltoBase/2, FondoBase/10 >*0.90
            }
            plane                 {
              -z, 1/20*FondoBase
            }
          }
          box                     {
            <-FrenteBase/4,-AltoBase/4,-FondoBase>,
            <+FrenteBase/4, AltoBase/4,+FondoBase>
            translate     -FrenteBase/10*x
          }
        }
        difference                {
          union                   {
            superellipsoid          {
              < 0.1, 0.3 >
              scale         < FrenteBase/2, AltoBase/2, FondoBase/10 >
            }
            difference            {
              superellipsoid      {
                <0.2,0.2>
                scale     < FrenteBase/10, 3*AltoBase/10, FondoBase/20 >
                translate -FondoBase/10*z
                translate             +FrenteBase/2*x-4*FrenteBase/15*x
              }
              superellipsoid      {
                <0.2,0.2>
                scale     < FrenteBase/10, 3*AltoBase/10, FondoBase/20 >*0.90
                translate -FondoBase/10*z
                translate             +FrenteBase/2*x-4*FrenteBase/15*x
              }
            }
          }
          prism                   {
            quadratic_spline
            -20*AltoBase, 20*AltoBase,
            8
            <0,-1>,
            <0,0>,
            <0,0.8>,
            <0.5,0.9>,
            <0.95,1>,
            <0.95,0.2>,
            <0.5,0>,
            <0,0>
            scale                 < 2*FrenteBase/3, 1, 2*AltoBase/3 >
            translate             +FrenteBase/10*x-FrenteBase/2*x
            rotate                -90*x
            translate             -1*AltoBase/3*y
          }
          superellipsoid          {
            < 0.1, 0.3 >
            scale         < FrenteBase/2, AltoBase/2, -FondoBase/10 >*0.98
          }
          plane                   {
            -z    , 1/100*FondoBase
          }
          difference                {
            superellipsoid          {
              < 0.1, 0.3 >
              scale         < FrenteBase/5, AltoBase/2, FondoBase/10 >*1.05
            }
            plane                   {
              -z    , 0
            }
            plane                   {
              +x    , +1/20*FrenteBase*0.95
            }
            plane                   {
              +x    , 0
              rotate                -4*z
              translate             +1/20*FrenteBase*x*0.95-AltoBase/3*y
            }
            plane                   {
              +x    , 0
              rotate                -8*z
              translate             +1/20*FrenteBase*x*0.95
            }
            translate             +FrenteBase/2*x-FrenteBase/5*x
          }
        }
        translate                 +FrenteBase/2*x*0.98
        rotate                    AnguloPuerta*y
        translate                 -FrenteBase/2*x*0.98
        translate                 -FondoBase*z+AltoBase/2*y
      }
      union                       {
        difference                {
          superellipsoid          {
            < 0.1, 0.3 >
            scale         < FrenteBase/5, AltoBase/2, -FondoBase/10 >
          }
          plane                   {
            -z    , 1/100*FondoBase
          }
          plane                   {
            +x    , +1/20*FrenteBase
          }
          scale           0.95
        }
        difference                {
          superellipsoid          {
            < 0.1, 0.3 >
            scale         < FrenteBase/5, AltoBase/2, -FondoBase/10 >
          }
          plane                   {
            -z    , 1/100*FondoBase
          }
          plane                   {
            +x    , +1/20*FrenteBase
          }
          plane                   {
            +x    , 0
            rotate                -4*z
            translate             +1/20*FrenteBase*x-AltoBase/3*y
          }
          plane                   {
            +x    , 0
            rotate                -8*z
            translate             +1/20*FrenteBase*x
          }
        }
        texture                   {
          TexturaPrincipal
        }
        #if ( MEPV_VisibleImagen1 )
          texture                   {
            pigment         {
              image_map            {
                gif   MEPV_NombreImagen1
                once
              }
              scale                 < FrenteBase/10, AltoBase*0.6, 1 >
              translate             +0.08*FrenteBase*x-AltoBase*0.3*y
            }
          }
        #end
        translate                 -FondoBase*z+AltoBase/2*y
                                  +FrenteBase/2*x-FrenteBase/5*x
      }
      box                         {
        < -FrenteBase/2+RadioDecorativo, AltoBase-2*RadioDecorativo, 0 >,
        < +FrenteBase/2-RadioDecorativo, AltoBase, -FondoBase >
      }
      cylinder                    {
        0         , -FondoBase*z, RadioDecorativo
        translate
          < -FrenteBase/2+RadioDecorativo, AltoBase-RadioDecorativo, 0 >
      }
      cylinder                    {
        0         , -FondoBase*z, RadioDecorativo
        translate
          < +FrenteBase/2-RadioDecorativo, AltoBase-RadioDecorativo, 0 >
      }
      difference                {
        superellipsoid          {
          < 0.2, 0.9 >
          scale           < FrenteBase/2, AltoBase/2, FondoBase/2*0.4 >*3/5
          translate       AltoBase/2*y
        }
        superellipsoid          {
          < 0.2, 0.9 >
          #if ( MEPV_VisibleImagen2 )
            texture                   {
              pigment         {
                image_map            {
                  gif   MEPV_NombreImagen2
                  once
                }
              }
              translate           <-0.5,-0.5,0>
              scale               <-1,1,1>*1.5
            }
          #end
          scale           < FrenteBase/2, AltoBase/2, FondoBase/8*0.1 >*2/5
          translate       AltoBase/2*y
          translate       FondoBase/2*0.2*3/5*z
        }
        plane                   {
          -z                    , -FondoBase/2*0.2*3/5
        }
        plane                   {
          z                     , 0
        }
      }
      translate                   AlturaSoporte*y
      texture                     {
        TexturaPrincipal
      }
    }
    // Patitas
    union                       {
      sphere                    {
        AlturaSoporte/2*y       , AlturaSoporte/2
        translate               -FondoBase/2*z+
                                ( -FrenteBase/2*x-FondoBase/2*z )*3/5
      }
      sphere                    {
        AlturaSoporte/2*y       , AlturaSoporte/2
        translate               -FondoBase/2*z+
                                ( -FrenteBase/2*x+FondoBase/2*z )*3/5
      }
      sphere                    {
        AlturaSoporte/2*y       , AlturaSoporte/2
        translate               -FondoBase/2*z+
                                ( +FrenteBase/2*x+FondoBase/2*z )*3/5
      }
      sphere                    {
        AlturaSoporte/2*y       , AlturaSoporte/2
        translate               -FondoBase/2*z+
                                ( +FrenteBase/2*x-FondoBase/2*z )*3/5
      }
      difference                {
        superellipsoid            {
          < 0.2, 0.2 >
          scale           < FrenteBase/2, AlturaSoporte*0.7, FondoBase/2 >*7/8
          translate       AlturaSoporte*y-FondoBase/2*z
        }
        plane                   {
          -y                     , -AlturaSoporte
        }
      }
      texture                   {
        TexturaSoporte
      }
    }
  }
#end


#macro MEPV_HornoMicroondas( AnguloPuerta, AnguloGiratorio )
  #local L                      = MEPV_L;
  #local FrenteBase             = 372*L;
  #local AltoBase               = 197*L;
  #local FondoBase              = 244*L;
  #local AlturaSoporte          = 18*L;
  #local RadioDecorativo        = 5.4*L;
  object                        {
    MEPV_MicroondasElectricoPlatoVidrio
        ( FrenteBase, AltoBase, FondoBase, AlturaSoporte, RadioDecorativo,
                on, on, AnguloPuerta, AnguloGiratorio,
                MEPV_DefaultTexturaPrincipal, MEPV_DefaultTexturaVentanilla,
                MEPV_DefaultTexturaSoporte, MEPV_DefaultTexturaGiratoria,
                MEPV_DefaultTexturaPlato )
  }
#end
