// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 marzo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// MEPV MicroondasElectricoPlatoVidrio
// El archivo dibuja un aparato microondas corriente
// incluye plato de vidrio y soporte de plato giratorios.
// #macro MEPV_HornoMicroondas( AnguloPuerta, AnguloGiratorio )
//      AnguloPuerta            : Angulo para abrir la puerta del microondas,
//                      cero se considera cerrado.  Utilice valores positivos.
//      AnguloGiratorio         : Rotacion poco visible.
//                      Produce una rotacion Y del plato y su
//                      soporte.  En realidad el soporte de plato,
//                      solo rotara la mitad del angulo, para simular
//                      el efecto de las rueditas.
//
// Las caracteristicas serian
//      Altura total microondas : 215*L
//      Altura sin base         : 197*L
//      Frente microondas       : 372*L
//      Profundidad microondas  : 290*L aprox +14.5*L hasta -275*Z
//      Centro superior plato   : <-33,42.5,-134>*L
// El aparato se encuentra sobre el plano XY, el frente hacia Z-.
// Centrado en el eje X.
//
// Tambien puede generarse el objeto con la siguiente macro
// #macro MEPV_MicroondasElectricoPlatoVidrio
//         ( FrenteBase, AltoBase, FondoBase, AlturaSoporte, RadioDecorativo,
//           VisibleAroCentral, VisiblePlato, AnguloPuerta, AnguloGiratorio,
//           TexturaPrincipal, TexturaVentanilla,
//           TexturaSoporte, TexturaGiratoria, TexturaPlato )
//      FrenteBase              : Para modificar el tamano del frente.
//                      Valor default es 372*L.
//      AltoBase                : Para modificar el alto del aparato sin
//                      soporte inferior.  Valor default es 197*L.
//      FondoBase               : Relacionado con el tamano del fondo.
//                      Valor default es 244*L.
//      AlturaSoporte           : Altura de las patas y soporte del aparato.
//                      Valor default es 18*L.
//      RadioDecorativo         : Radio base para intersecciones curvas.
//                      Valor default es 5.4*L.
//      VisibleAroCentral       : on dibuja el aro soporte giratorio,
//                                off no lo dibuja.  Default es on.
//      VisiblePlato            : on dibuja el plato giratorio.
//                                off no lo dibuja.  Default es on.
//      AnguloPuerta            : Angulo para abrir la puerta del microondas,
//                      cero se considera cerrado.  Utilice valores positivos.
//      AnguloGiratorio         : Rotacion poco visible.
//                      Produce una rotacion Y del plato y su
//                      soporte.  En realidad el soporte de plato,
//                      solo rotara la mitad del angulo, para simular
//                      el efecto de las rueditas.
//      TexturaPrincipal        : Textura principal a aplicar al aparato.
//                      Es probable que surjan inconsistencias con las
//                      imagenes superpuestas.
//                      Default es MEPV_DefaultTexturaPrincipal.
//      TexturaVentanilla       : Textura a aplicar a la ventanilla visor.
//                      Default es MEPV_DefaultTexturaVentanilla.
//      TexturaSoporte          : Textura a aplicar a la base soporte.
//                      Default es MEPV_DefaultTexturaSoporte.
//      TexturaGiratoria        : Textura para el aro giratorio.
//                      Default es MEPV_DefaultTexturaGiratoria.
//      TexturaPlato            : Textura para el plato.
//                      Defualt es MEPV_DefaultTexturaPlato.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare MEPV_TexturaPrincipal       = Textura principal a aplicar
//      al aparato.
// #declare MEPV_TexturaVentanilla      = Textura a aplicar a la ventana
//      visor de los alimentos.
// #declare MEPV_TexturaSoporte         = Textura a aplicar a la base
//      soporte.
// #declare MEPV_TexturaGiratoria       = Textura para el aro giratorio.
// #declare MEPV_TexturaPlato           = Textura para el plato giratorio.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare MEPV_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare MEPV_DefaultTexturaPrincipal      = texture { ... }
//      Textura principal a aplicar al aparato.
// #declare MEPV_DefaultTexturaVentanilla      = texture { ... }
//      Textura a aplicar a la ventana visor de los alimentos.
// #declare MEPV_DefaultTexturaSoporte         = texture { ... }
//      Textura a aplicar a la base soporte.
// #declare MEPV_DefaultTexturaGiratoria       = texture { ... }
//      Textura a aplicar al aro giratorio.
// #declare MEPV_DefaultTexturaPlato           = texture { ... }
//      Textura a aplicar al plato giratorio.
// #declare MEPV_VisibleImagen1                = on;
//      Vuelve visible o no la imagen de los botones de presion.
// #declare MEPV_VisibleImagen2                = on;
//      Vuelve visible o no la etiqueta posterior.
// #declare MEPV_NombreImagen1                 = "MEPV_IM1.GIF"
//      Nombre de la imagen que corresponde a los botones.
//      La imagen actual es algo borrosa
//      tomada con una camara promocional de la pelicula "Hulk",
//      sin duda puede mejorarse bastante.
// #declare MEPV_NombreImagen2                 = "MEPV_IM2.GIF"
//      Nombre de la imagen que corresponde a la etiqueta posterior.
//      La imagen actual es algo borrosa
//      tomada con una camara promocional de la pelicula "Hulk",
//      sin duda puede mejorarse bastante.
// #declare MEPV_ColorTornillo                 = pigment {Gray30}
//      Color como pigment de los tornillos.
// #declare MEPV_ColorTornilloDiferencia       = pigment {Gray70}
//      Color como pigment de las ranuras;
//      necesario para dar relieve a los tornillos.
//
// Para colocarlo simplemente
// #include "MEPV.inc"
// object        { MEPV_HornoMicroondas( 0, 0 ) }
//
// Otro ejemplo con modificador
// #include "MEPV.inc"
// #declare MEPV_DefaultTexturaPrincipal        = texture       {
//   PinkAlabaster
// }
// #declare MEPV_VisibleImagen1                 = off;
// #declare MEPV_DefaultTexturaVentanilla       = texture       {
//   average
//   texture_map        {
//     [ 0.5 MEPV_TexturaVentanilla     ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        { MEPV_HornoMicroondas( 0, 0 ) }
//

#include "colors.inc"

#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
#local   OjoAbsoluto            = 256*L;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 050   , -3000 >*L
         White
}
light_source    {
         <-050  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "MEPV.INC"

#local   FactorAcercamiento     = 3;

object          {
  MEPV_HornoMicroondas( 0, 30 )    
  translate             -100*L*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*z
}
