// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 febrero 2013
//
// ADVERTENCIA : Utilizamos la textura T_Stone26 del paquete
//      stones.inc, parte de POVRay ( autor de textura : Dan Farmer 1995 )
//      La modificamos internamene a nuestra conveniencia.
//
// PUIC PiedraUsoIslaCoco
// El archivo dibuja piedras.  Ofrece diez modelos
// con un poco de aleatoriedad.
// Fueron modeladas por diferencia blob y fractal.
// Los blobs se disenaron en el programa BlobSculptor para DOS.
//
// Considere que las piedras tienen un diametro aproximado
// algo inferior a una unidad PovRay.
// Se dibujan semicentradas en el origen.
//
// La siguiente macro genera las piedras
// #macro PUIC_PiedraUsoIslaCoco( Estilo, FactorA, TexturaPiedra )
//      Estilo          : Permite elegir a piedra modelo.
//              Utilice uno de los siguinte diez selectores.
//                      PUIC_Piedra1            = 1
//                      PUIC_Piedra2            = 2
//                      PUIC_Piedra3            = 3
//                      PUIC_Piedra4            = 4
//                      PUIC_Piedra5            = 5
//                      PUIC_Piedra6            = 6
//                      PUIC_Piedra7            = 7
//                      PUIC_Piedra8            = 8
//                      PUIC_Piedra9            = 9
//                      PUIC_Piedra10           = 10
//      FactorA         : Valor entre -0.5 a 1.5.  Recomendado 1.0.
//              Que introduce variaciones en algunas piedras.
//              Unicamente aplica en las piedras PUIC_Piedra2, 3, 5, 6, 8, 10;
//              modificando la segunda constate del fractal Julia.
//      TexturaPiedra   : Textura a aplicar a la piedra.
//              El archivo ofrece las alternativas.
//                      PUIC_Textura1 (oscura y bandeada)
//                      PUIC_Textura2 (clara y granular)
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "PUIC.inc"
// object        { PUIC_PiedraUsoIslaCoco( PUIC_Piedra1,1,PUIC_Textura1 ) }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "PUIC.inc"

#local FactorAcercamiento       = 0.4;
#local FactorA                  = 1.0;
#local Separacion               = 1.1;

union           {
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra1 , FactorA, PUIC_Textura1 )
    translate   ( -   x+y )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra2 , FactorA, PUIC_Textura1 )
    translate   (      +y )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra3 , FactorA, PUIC_Textura1 )
    translate   ( +   x+y )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra4 , FactorA, PUIC_Textura1 )
    translate   ( -1.5*x  )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra5 , FactorA, PUIC_Textura1 )
    translate   ( -0.5*x  )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra6 , FactorA, PUIC_Textura2 )
    translate   ( +0.5*x  )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra7 , FactorA, PUIC_Textura2 )
    translate   ( +1.5*x   )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra8 , FactorA, PUIC_Textura2 )
    translate   ( -   x-y )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra9 , FactorA, PUIC_Textura2 )
    translate   (      -y )*Separacion  
  }  
  object          {
    PUIC_PiedraUsoIslaCoco( PUIC_Piedra10, FactorA, PUIC_Textura2 )
    translate   ( +   x-y )*Separacion  
  }  
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}  

  


