// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 febrero 2013
//
// ADVERTENCIA : Utilizamos la textura T_Stone26 del paquete
//      stones.inc, parte de POVRay ( autor de textura : Dan Farmer 1995 )
//      La modificamos internamene a nuestra conveniencia.
//
// PUIC PiedraUsoIslaCoco
// El archivo dibuja piedras.  Ofrece diez modelos
// con un poco de aleatoriedad.
// Fueron modeladas por diferencia blob y fractal.
// Los blobs se disenaron en el programa BlobSculptor para DOS.
//
// Considere que las piedras tienen un diametro aproximado
// algo inferior a una unidad PovRay.
// Se dibujan semicentradas en el origen.
//
// La siguiente macro genera las piedras
// #macro PUIC_PiedraUsoIslaCoco( Estilo, FactorA, TexturaPiedra )
//      Estilo          : Permite elegir a piedra modelo.
//              Utilice uno de los siguinte diez selectores.
//                      PUIC_Piedra1            = 1
//                      PUIC_Piedra2            = 2
//                      PUIC_Piedra3            = 3
//                      PUIC_Piedra4            = 4
//                      PUIC_Piedra5            = 5
//                      PUIC_Piedra6            = 6
//                      PUIC_Piedra7            = 7
//                      PUIC_Piedra8            = 8
//                      PUIC_Piedra9            = 9
//                      PUIC_Piedra10           = 10
//      FactorA         : Valor entre -0.5 a 1.5.  Recomendado 1.0.
//              Que introduce variaciones en algunas piedras.
//              Unicamente aplica en las piedras PUIC_Piedra2, 3, 5, 6, 8, 10;
//              modificando la segunda constate del fractal Julia.
//      TexturaPiedra   : Textura a aplicar a la piedra.
//              El archivo ofrece las alternativas.
//                      PUIC_Textura1 (oscura y bandeada)
//                      PUIC_Textura2 (clara y granular)
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "PUIC.inc"
// object        { PUIC_PiedraUsoIslaCoco( PUIC_Piedra1,1,PUIC_Textura1 ) }
//

#include "stones.inc"
// T_Stone16
// T_Stone26 se copia y modifica aqui
#if ( version < 3.2 )
  #ifndef( PUIC_POV3_1 )
    #declare PUIC_POV3_1        = on;
  #end
#else
  #ifndef( PUIC_POV3_1 )
    #declare PUIC_POV3_1        = off;
  #end    
#end

#declare PUIC_Piedra1           = 1;
#declare PUIC_Piedra2           = 2;
#declare PUIC_Piedra3           = 3;
#declare PUIC_Piedra4           = 4;
#declare PUIC_Piedra5           = 5;
#declare PUIC_Piedra6           = 6;
#declare PUIC_Piedra7           = 7;
#declare PUIC_Piedra8           = 8;
#declare PUIC_Piedra9           = 9;
#declare PUIC_Piedra10          = 10;

     
#declare PUIC_Normal1           =
  normal        {
    granite
  }
  
#if ( PUIC_POV3_1 )
  #declare PUIC_Finish1         =
    finish        {
      brilliance  0.1
      ambient     0.5
    }
#else
  #declare PUIC_Finish1         =
    finish        {
      crand       0.1
      brilliance  0.01
    }
#end
       
#declare PUIC_Textura1          = 
texture       {
  T_Stone16
  normal        {
    PUIC_Normal1
  }  
  finish        {
    PUIC_Finish1
  }
}  
// Lo que sigue es casi T_Stone26 con variaciones personales 
texture {
    pigment {
        granite
        rotate y*90
        color_map { 
            [0.02 color rgbt <0.25, 0.45, 0.60, 0.5> ]
            [0.06 color rgbt <0.20, 0.40, 0.55, 0.5> ]
            [0.10 color rgbt <0.15, 0.20, 0.25, 0.5> ]
            [1.00 color rgbt <0.40, 0.60, 0.75, 0.5> ]
        }
        frequency 6
        rotate <0, 10, 0>
        turbulence <0.05, 0.05, 0.05>
        octaves 6
        omega 0.7
        lambda 2
    }
  normal        {
    PUIC_Normal1
  }
  finish        {
    PUIC_Finish1
  }
}
texture {
    pigment {
        gradient x
        color_map {
            [0.00 color Clear ]
            [0.10 color rgbt <1.00, 1.00, 1.00, 0.75> ]
            [0.15 color rgbt <0.15, 0.25, 0.40, 0.50> ]
            [0.20 color rgbt <0.00, 0.05, 0.10, 0.25> ]
            [0.25 color rgbt <0.15, 0.25, 0.40, 0.25> ]
            [0.30 color rgbt <0.35, 0.55, 0.40, 0.50> ]
            [0.35 color rgbt <0.25, 0.25, 0.20, 0.75> ]
            [0.35 color Clear ]
        }
        frequency 3
        rotate <1, 10, 45>
        rotate x*60
        turbulence <0.30, 0.30, 0.30>
        octaves 6
        omega 0.7
        lambda 2.2
    }
  normal        {
    PUIC_Normal1
  }
  finish        {
    PUIC_Finish1
  }
}
texture {
    pigment {
        agate
        color_map {
            [0.00 color Clear ]
            [0.10 color rgbt <1.00, 1.00, 1.00, 0.75> ]
            [0.15 color rgbt <0.35, 0.55, 0.40, 0.50> ]
            [0.20 color rgbt <0.25, 0.25, 0.20, 0.25> ]
            [0.25 color rgbt <0.30, 0.60, 0.45, 0.25> ]
            [0.30 color rgbt <0.35, 0.55, 0.40, 0.50> ]
            [0.35 color rgbt <0.25, 0.25, 0.20, 0.75> ]
            [0.35 color Clear ]
        }
        frequency 3
        rotate <2, 10, 75>
        rotate x*120
        turbulence <0.05, 0.05, 0.05>
        octaves 6
        omega 0.7
        lambda 2
    }
  normal        {
    PUIC_Normal1
  }  
  finish        {
    PUIC_Finish1
  }
}      

#declare PUIC_Textura2          = 
texture       {
  T_Grnt16
  normal        {
    PUIC_Normal1
  }  
  finish        {
    PUIC_Finish1
  }
}  
// Lo que sigue es casi T_Stone26 con variaciones personales 
texture {
    pigment {
        granite
        rotate y*90
        color_map { 
            [0.02 color rgbt <0.25, 0.45, 0.60, 0.5> ]
            [0.06 color rgbt <0.20, 0.40, 0.55, 0.5> ]
            [0.10 color rgbt <0.15, 0.20, 0.25, 0.5> ]
            [1.00 color rgbt <0.40, 0.60, 0.75, 0.5> ]
        }
        frequency 6
        rotate <0, 10, 0>
        turbulence <0.05, 0.05, 0.05>
        octaves 6
        omega 0.7
        lambda 2
    }
  normal        {
    PUIC_Normal1
  }
  finish        {
    PUIC_Finish1
  }
}
texture {
    pigment {
        gradient x
        color_map {
            [0.00 color Clear ]
            [0.10 color rgbt <1.00, 1.00, 1.00, 0.75> ]
            [0.15 color rgbt <0.15, 0.25, 0.40, 0.50> ]
            [0.20 color rgbt <0.00, 0.05, 0.10, 0.25> ]
            [0.25 color rgbt <0.15, 0.25, 0.40, 0.25> ]
            [0.30 color rgbt <0.35, 0.55, 0.40, 0.50> ]
            [0.35 color rgbt <0.25, 0.25, 0.20, 0.75> ]
            [0.35 color Clear ]
        }
        frequency 3
        rotate <1, 10, 45>
        rotate x*60
        turbulence 3*<0.30, 0.30, 0.30>
        octaves 6
        omega 0.7
        lambda 2.2
    }
  normal        {
    PUIC_Normal1
  }
  finish        {
    PUIC_Finish1
  }
}
texture {
    pigment {
        agate
        color_map {
            [0.00 color Clear ]
            [0.10 color rgbt <1.00, 1.00, 1.00, 0.75> ]
            [0.15 color rgbt <0.35, 0.55, 0.40, 0.50> ]
            [0.20 color rgbt <0.25, 0.25, 0.20, 0.25> ]
            [0.25 color rgbt <0.30, 0.60, 0.45, 0.25> ]
            [0.30 color rgbt <0.35, 0.55, 0.40, 0.50> ]
            [0.35 color rgbt <0.25, 0.25, 0.20, 0.75> ]
            [0.35 color Clear ]
        }
        frequency 3
        rotate <2, 10, 75>
        rotate x*120
        turbulence <0.05, 0.05, 0.05>
        octaves 6
        omega 0.7
        lambda 2
    }
  normal        {
    PUIC_Normal1
  }  
  finish        {
    PUIC_Finish1
  }
}      
    
    
#macro PUIC_PiedraUsoIslaCoco( Estilo, FactorA, TexturaPiedra )
#switch ( Estilo )
#case ( PUIC_Piedra1 )
union           {
blob {
   threshold 0.6
   component 1.000000, 2.116604, <0.008439, 0.000000, -0.008439>
   component 1.000000, 2.224612, <0.968322, 0.000000, 0.020603>
   component 1.000000, 2.212729, <0.309039, 0.000000, 0.762296>
   component 1.000000, 2.482265, <0.592324, 0.695337, 0.020603>
   component 1.000000, 2.482265, <0.540818, 1.416428, 0.020603>
   component 1.000000, 2.482265, <0.077260, 2.343544, 0.020603>
   component 1.000000, 2.169759, <1.751220, -0.638680, -1.009527>
   component 1.000000, 2.278144, <0.515065, 0.432654, -1.998451>
   component 1.000000, 2.148829, <-0.849857, 1.416428, -2.163271>

}

blob {
   threshold 0.6
   component 1.000000, 2.024282, <2.446557, 1.776973, -0.432654>
   component 1.000000, 2.024282, <1.364921, 1.622454, 0.721090>
   component 1.000000, 2.024282, <1.364921, 0.679885, -0.103013>
   component 1.000000, 2.024282, <0.592324, 2.343544, 0.185423>
   component 1.000000, 2.024282, <1.668809, 0.144218, -1.009527>

}    
  texture               {
    TexturaPiedra
  }
  scale         0.18
  translate     -0.18*y-0.1*x+0.1*z
}    
#break
#case ( PUIC_Piedra2 )
difference           {
blob {
   threshold 0.6
   component 1.000000, 1.870990, <0.008439, 0.000000, -0.092827>
   component 1.000000, 1.870990, <0.952870, 0.000000, -0.128766>
   component 1.000000, 1.870990, <1.570947, 0.000000, -0.128766>
   component 1.000000, 1.870990, <2.652583, 0.000000, 0.437805>
   component 1.000000, 1.870990, <0.849857, 0.952870, -0.092827>
   component 1.000000, 1.870990, <1.364921, 1.931492, -0.092827>
   component 1.000000, 1.870990, <1.364921, 2.657733, 0.638680>
   component 1.000000, 2.321744, <0.695337, -0.803501, -1.622454>
   component 1.000000, 2.321744, <-0.128766, 0.473859, -1.107389>
}
         julia_fractal {
            <-0.033,-0.6*FactorA,-0.93,-0.025>
            quaternion 
            cube
            max_iteration 4
            precision 50
            translate <0,0.2,0> 
            scale 2.5
            rotate <0,-5,0>
            translate   1   
         }

  texture               {
    TexturaPiedra
  }
  rotate        -90*y  
  translate     -1*z      
  scale         0.225
  translate     -0.25*y        
}    
#break
#case ( PUIC_Piedra3 )
difference           {
blob {
   threshold 0.6
   component 1.000000, 1.892481, <-0.020603, 0.000000, 0.679885>
   component 1.000000, 1.892481, <0.350244, 0.000000, -0.556270>
   component 1.000000, 1.892481, <-0.515065, 0.000000, -0.473859>
   component 1.000000, 2.111701, <0.016482, 0.774657, 0.020603>
   component 1.000000, 2.292975, <0.020603, -0.708729, 1.297963>
   component 1.000000, 1.892481, <-0.556270, -0.708729, -0.103013>
   component 1.000000, 1.892481, <0.885911, -0.708729, -0.020603>
   component 1.000000, 1.892481, <0.020603, -0.708729, -1.174347>
   component 1.000000, 1.892481, <0.968322, -0.708729, -1.627604>
   component 1.000000, 1.892481, <-1.174347, -0.708729, -1.462783>
   component 1.000000, 1.518211, <-0.020603, 1.895438, -0.061808>

}       

         julia_fractal {
            <-0.033,-0.6*FactorA,-0.93,-0.025>
            quaternion 
            sqr
            max_iteration 4
            precision 50
            translate <0,0.2,0> 
            scale 2.5
            rotate <0,-5,0>
            translate   -1
         }
         
  texture       {
    TexturaPiedra
  } 
  scale         0.2      
}
#break
#case ( PUIC_Piedra4 )
difference           {
  union                 {
blob {
   threshold 0.6
   component 1.000000, 1.743005, <-0.059072, 0.000000, 0.008439>
   component 1.000000, 1.743005, <1.215552, 0.000000, -0.103013>
   component 1.000000, 1.743005, <-1.380373, 0.000000, 0.103013>
   component 1.000000, 1.743005, <-0.185423, 0.473859, 1.339168>
   component 1.000000, 1.743005, <-0.061808, 0.000000, -1.256758>
   component 1.000000, 1.743005, <1.050732, 0.432654, -0.638680>
   component 1.000000, 1.743005, <0.432654, 0.000000, 0.679885>
   component 1.000000, 1.743005, <-0.968321, 0.000000, 0.927116>
   component 1.000000, 1.998064, <-1.009527, -0.515065, -0.679885>
    }
  }
  texture       {
    TexturaPiedra
  }  
  scale 0.23
  translate     +0.08*x+0.20*z  
}
#break
#case ( PUIC_Piedra5 )
difference           {
  union                 {
blob {
   threshold 0.6
   component 1.000000, 1.543431, <-0.016482, 0.000000, -0.082410>
   component 1.000000, 1.543431, <1.104298, 0.000000, -0.115374>
   component 1.000000, 1.543431, <2.225079, 0.000000, -0.181303>
   component 1.000000, 1.543431, <1.071334, 0.000000, 0.741693>
   component 1.000000, 1.543431, <0.972442, 0.000000, -0.906514>
   component 1.000000, 1.543431, <0.642801, 0.741693, 0.280195>
   component 1.000000, 1.543431, <1.269119, 0.774657, -0.906514>
}
blob {
   threshold 0.6
   component 1.000000, 1.988238, <-0.115374, 0.000000, 0.082410>
   component 1.000000, 1.988238, <0.313159, -0.576872, 0.939478>
   component 1.000000, 1.669266, <0.477980, 1.335047, 0.000000>
   component 1.000000, 1.669266, <-0.642801, 1.269119, 0.840585>
}
blob {
   threshold 0.6
   component 1.000000, 2.333999, <1.269119, 0.000000, 0.741693>
   component 1.000000, 2.024282, <0.445016, 1.071334, 0.016482>
}
  
  }
         julia_fractal {
            <-0.1,0.6*FactorA,-0.93,-0.012>
            hypercomplex
            sqr
            max_iteration 4
            precision 50
            translate <0,0.2,0> 
            scale 2.5
            rotate <0,-5,0>
            translate   -1.2 
            translate   2*y  
         }
  texture       {
    TexturaPiedra
  }  
  scale         0.30
  translate     -0.125*y-0.05*x
}
#break
#case ( PUIC_Piedra6 )
difference           {
  union                 {
blob {
   threshold 0.6
   component 1.000000, 1.457523, <0.008439, 0.000000, -0.008439>
   component 1.000000, 1.457523, <-0.840585, 0.000000, -0.148339>
   component 1.000000, 1.457523, <-0.774657, 0.000000, 0.741693>
   component 1.000000, 1.457523, <-1.050732, -0.762296, 0.939478>
   component 1.000000, 1.457523, <-1.269119, 0.597475, 0.741693>
   component 1.000000, 1.457523, <-0.082410, 0.350244, 1.174347>
   component 1.000000, 1.457523, <0.515065, -0.473859, 1.174347>
   component 1.000000, 1.457523, <-1.503989, -0.350244, -0.638680>
   component 1.000000, 1.457523, <-1.503989, 0.844706, -0.226628>
   component 1.000000, 2.444039, <0.000000, 1.421578, 0.226628>
   component 1.000000, 1.454872, <-0.741693, 1.174347, 0.906514>
}
blob {
   threshold 0.6
   component 1.000000, 1.744465, <-0.642801, 1.215552, -0.609837>
   component 1.000000, 1.744465, <0.115374, 1.215552, -0.807621>
   component 1.000000, 1.744465, <0.885911, 0.391449, -0.280195>
}
         }
         
         julia_fractal {
            <-0.1,0.6*FactorA,-1,-0.012>
            quaternion
            sqr
            max_iteration 4
            precision 50
            translate <0,0.2,0> 
            scale 2.5
            rotate <0,-5,0>
            translate   -1.2 
            translate   2*y 
            rotate      45
         }
  texture       {
    TexturaPiedra
  }  
  scale         0.25
  translate     +0.075*x-0.1*y-0.1*z
}
#break
#case ( PUIC_Piedra7 )
blob {
   threshold 0.6
   component 1.000000, 1.737559, <0.708729, -0.642801, -0.642801>
   component 1.000000, 1.737559, <-0.807621, -0.642801, -0.609837>
   component 1.000000, 1.737559, <-0.774657, -0.642801, 0.840585>
   component 1.000000, 2.080653, <0.642801, -0.642801, 0.873550>
   component 1.000000, 1.737559, <0.774657, 0.774657, 0.873550>
   component 1.000000, 1.737559, <0.741693, 0.741693, -0.642801>
   component 1.000000, 1.737559, <-0.708729, 0.873550, -0.609837>
   component 1.000000, 1.737559, <-0.609837, 0.939478, 0.840585>
  texture       {
    TexturaPiedra
  }
  scale         0.25
  translate     -0.05*z  
}
#break
#case ( PUIC_Piedra8 )
difference           {
blob {
   threshold 0.6
   component 1.000000, 1.743368, <0.042194, 0.000000, -0.075949>
   component 1.000000, 1.743368, <-0.721090, -0.597475, -0.020603>
   component 1.000000, 1.743368, <0.803501, -0.391449, 0.103013>
   component 1.000000, 1.743368, <1.710014, 0.000000, 0.267834>
   component 1.000000, 1.743368, <-1.710014, 0.515065, -0.061808>
   component 1.000000, 1.743368, <-2.492913, 0.000000, -0.103013>
   component 1.000000, 1.743368, <0.144218, 0.000000, 0.803501>
   component 1.000000, 1.743368, <-0.473859, 0.721090, 1.174347>
}         
         julia_fractal {
            <-0.1,0.3*FactorA,-1,-0.012>
            quaternion
            sqr
            max_iteration 4
            precision 50
            translate <0,0.2,0> 
            scale 2.5
            rotate <0,-5,0>
            translate   -1.2 
            translate   2*y 
            rotate      45 
         }
  texture       {
    TexturaPiedra
  }
  scale         0.25
  translate     -0.05*z  
  scale 0.75
  translate     0.15*x
}
#break
#case ( PUIC_Piedra9 )
blob {
   threshold 0.6
   component 1.000000, 1.835186, <0.025316, 0.000000, -0.042194>
   component 1.000000, 1.835186, <-0.883439, 0.000000, -0.250527>
   component 1.000000, 2.655184, <0.883439, 0.376899, -0.065928>
  texture       {
    TexturaPiedra
  }
  scale         0.25
  translate     -0.05*x
}
#break
#case ( PUIC_Piedra10 )
difference           {
  union                 { 
blob {
   threshold 0.6
   component 1.000000, 1.564575, <0.042194, 0.000000, -0.092827>
   component 1.000000, 1.564575, <0.643831, 0.000000, 1.107389>
   component 1.000000, 1.564575, <0.798350, 0.000000, -1.416428>
   component 1.000000, 1.564575, <0.968321, 1.091937, -0.077260>
   component 1.000000, 1.564575, <0.061808, 1.215552, -0.077260>
}
blob {
   threshold 0.6
   component 1.000000, 1.553311, <0.226628, 2.039656, 0.025753>
   component 1.000000, 1.553311, <1.091937, 2.122066, 0.025753>
   component 1.000000, 1.553311, <0.283286, 1.133142, -0.592324>
   component 1.000000, 1.553311, <0.927116, 0.721090, 0.952870>
   component 1.000000, 2.046947, <1.931492, 1.091937, 0.128766>
}
  }
         julia_fractal {
            <-0.033,-0.9*FactorA,-0.93,0.025>
            quaternion 
            sqr
            max_iteration 4
            precision 50
            translate <0,0.2,0> 
            scale 2.5
            rotate <0,-5,0>
            translate   -1 
         }
  texture       {
    TexturaPiedra
  }   
  scale 0.2  
  scale         1.5
  translate     -0.25*y-0.2*x-0.1*z
}
#break
#end
#end

