// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 18 junio 2012
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// SCCM_Au1.inc           archivo original
// SCCM_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// SCCM_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// SCCM_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// SCCM_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// SCCM_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SCCM SimpleCucharonCocinaManual
// Dibuja un cucharon simple de cocina, para uso domestico.
// Incluye macros de textura y permite modificaciones leves.
// La macro principal carece de parametros.
// #macro SCCM_CucharonGrande()
//
// El cucharon se encuentra contenido en un volumen aproximado
//      Minimo          : < -35  , -210  ,  25   >*L
//      Maximo          : <  35  ,   12  , -12.5 >*L
// El cucharon se dibuja con el agujero para colgar
// centrado en el origen del plano XY.
// La boca con abertura hacia Z-, colgando con gravedad Y-.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro SCCM_CucharonGrandeDetalle
//                ( LargoBoca, AnchoBoca, FondoCucharon,
//                  LargoMango, FraccionAngulo, AnguloMango, AnguloCucharon,
//                  AnchoManguito, GruesoManguito, FraccionAgarradera,
//                  TexturaPrincipal, TexturaManguillo, TexturaAgarradera )
//      LargoBoca       : Referencia para el largo Y de la boca.
//                        Default es 61*L.
//      AnchoBoca       : Referencia para el ancho X de la boca.
//                        Default es 69*L.
//      FondoCucharon   : Referencia para el hondo Z del cucharon.
//                        Default es 29*L.
//      LargoMango      : Referencia para el largo del mango.
//                        Default es 159*L.
//      FraccionAngulo  : Valor fraccionario para establecer el punto
//                        en donde la agarradera del mango,
//                        forma un quiebre.
//                        Entre mas pequeno se acerca a la boca.
//                        Default es 0.20.
//      AnguloMango     : Angulo de giro del angulo en el mango.
//                        Podria ser util para aumentar el realismo
//                        de la animacion.
//                        Default es 15.
//      AnguloCucharon  : Angulo de giro del cucharon respecto
//                        al plano XY.
//                        Default es 15.
//      AnchoManguito   : Referencia para el ancho del manguillo.
//                        Default es 8*L.
//      GruesoManguito  : Referencia para el grueso del manguillo.
//                        Default es 4*L.
//      FraccionAgarradera              : Referencia fraccionario,
//                        para asignar la parte del mango, que
//                        corresponde a la agarradera gruesa.
//                        Default es 0.515.
//      TexturaPrincipal                : Textura a aplicar al
//                        cucharon.
//                        Default es Default_TexturaPrincipal.
//      TexturaManguillo                : Textura a aplicar al
//                        manguillo delgado de union entre la
//                        agarradera y la boca del cucharon.
//                        Default es Default_TexturaManguillo.
//      TexturaAgarradera               : Textura a aplicar a la agarradera.
//                        Default es Default_TexturaAgarradera.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// SCCM_TexturaPrincipal
//      Textura a aplicar a la boca del cucharon.
// SCCM_TexturaManguillo
//      Textura a aplicar al manguillo delgado de union entre la
//      agarradera y la boca del cucharon.
// SCCM_TexturaAgarradera
//      Textura a aplicar a la agarradera.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SCCM_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare SCCM_DefaultTexturaPrincipal                =
//              texture { SCCM_TexturaPrincipal }
//      Textura a aplicar a la boca del cucharon.
// #declare SCCM_DefaultTexturaManguillo                =
//              texture { SCCM_TexturaManguillo }
//      Textura a aplicar al manguillo delgado de union entre la
//      agarradera y la boca del cucharon.
// #declare SCCM_DefaultTexturaAgarradera               =
//              texture { SCCM_TexturaAgarradera }
//      Textura a aplicar a la agarradera.
//
// Para colocarlo simplemente
// #include "SCCM.inc"
// object        { CEUP_CucharonGrande() }
//
// Otro ejemplo con modificador
// #include "SCCM.inc"
// #declare SCCM_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 SCCM_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      SCCM_CucharonGrande()
// }
//
// Otro ejemplo con macro de texturas
// #include "SCCM.inc"
// #include "textures.inc"
// object                {
//   SCCM_CucharonGrandeDetalle
//        ( 0.061, 0.067, 0.029, 0.159, 0.20, 15, 15, 0.008, 0.004, 0.515,
//          PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//


#include "SCCM_AU1.inc"
#include "colors.inc"
#include "woods.inc"

#declare SCCM_L                 = 0.001; 

#declare SCCM_Archivo           = ""

#declare SCCM_BanderaLectura    = off;

#declare SCCM_TexturaPrincipal                  = texture       {
  pigment               {
    Gray30*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.01
    scale               1
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( SCCM_DefaultTexturaPrincipal )
  #declare SCCM_DefaultTexturaPrincipal         = texture       {
    SCCM_TexturaPrincipal
  }
#end

#declare SCCM_TexturaManguillo                  = texture       {
  pigment               {
    Gray30*0.80+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.01
    scale               1
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( SCCM_DefaultTexturaManguillo )
  #declare SCCM_DefaultTexturaManguillo         = texture       {
    SCCM_TexturaManguillo
  }
#end

#declare SCCM_TexturaAgarraderaAux1              = texture       {
  pigment               {
    GreenCopper
  }
  normal                {
    bumps
    turbulence          0.01
    scale               1
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#declare SCCM_TexturaAgarraderaAux2             = texture       {
  pigment               {
    GreenCopper
  }
  normal                {
    gradient    y
    sine_wave
    scale               .01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}
        
#if ( SCCM_POV3_1 )        
#declare SCCM_TexturaAgarraderaAux2             = texture       {
  pigment               {
    GreenCopper
  }
  normal                {
    gradient    y
    sine_wave
    scale               .01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}
#else
  #declare SCCM_TexturaAgarraderaAux2             = texture       {
    pigment               {
      gradient  y
      sine_wave
      scale             .01
      pigment_map       {
        [0.0 GreenCopper*0.5]
        [1.0 GreenCopper*1.0]
      }
    }
    normal                {
      gradient    y
      sine_wave
      scale               .01
    }
    finish                {
      specular            0.2
      roughness           0.01
      metallic
    }
  }
#end

#declare SCCM_TexturaAgarradera                 = texture       {
  gradient      y
  texture_map           {
    [ 0.15 SCCM_TexturaAgarraderaAux1 ]
    [ 0.15 SCCM_TexturaAgarraderaAux2 ]
    [ 0.40 SCCM_TexturaAgarraderaAux2 ]
    [ 0.40 SCCM_TexturaAgarraderaAux1 ]
  }
  scale                 2
  translate             -y
}
#ifndef ( SCCM_DefaultTexturaAgarradera )
  #declare SCCM_DefaultTexturaAgarradera        = texture       {
    SCCM_TexturaAgarradera
  }
#end

#declare SCCM_RedCucharonGrande = array [5][3][4]
  { { {
< 0.000, 0.000, 0.000>,< 0.000,-0.555, 0.050>,<on ,on ,2>,<-1,-0.75,0.025>
      },{
< 0.200, 0.056, 0.000>,< 0.200,-0.500, 0.050>,<on ,on ,2>,<-1,-0.75,0.025>
      },{
< 0.313, 0.130, 0.000>,< 0.333,-0.425, 0.050>,<off,off,1>,<-1,-0.75,0.100>
      }
    },
    { {
< 0.000, 0.278, 0.400>,< 0.000,-0.278, 0.450>,<on ,on ,2>,<-1,-0.75,0.025>
      },{
< 0.200, 0.278, 0.300>,< 0.200,-0.278, 0.300>,<on ,on ,2>,<-1,-0.75,0.010>
      },{
< 0.420, 0.278, 0.000>,< 0.400,-0.278, 0.050>,<off,off,1>,<-1,-0.75,0.025>
      }
    },
    { {
< 0.000, 0.555, 0.500>,< 0.000, 0.000, 0.500>,<on ,on ,2>,<-1,-0.75,0.025>
      },{
< 0.200, 0.555, 0.400>,< 0.200, 0.000, 0.400>,<on ,on ,2>,<-1,-0.75,0.025>
      },{
< 0.500, 0.555, 0.000>,< 0.500, 0.000, 0.050>,<off,off,1>,<-1,+0.75,0.005>
      }
    },
    { {
< 0.000, 0.777, 0.400>,< 0.000, 0.222, 0.400>,<on ,on ,2>,<-1,-0.75,0.002>
      },{
< 0.200, 0.777, 0.300>,< 0.200, 0.222, 0.300>,<on ,on ,2>,<-1,-0.75,0.010>
      },{
< 0.420, 0.777, 0.000>,< 0.420, 0.222, 0.050>,<off,off,1>,<-1,+0.75,0.005>
      }
    },
    { {
< 0.000, 1.000, 0.000>,< 0.000, 0.444, 0.050>,<off,off,3>,<-1,-0.75,0.025>
      },{
< 0.200, 0.954, 0.000>,< 0.200, 0.400, 0.050>,<off,off,3>,<-1,-0.75,0.010>
      },{
< 0.333, 0.888, 0.000>,< 0.333, 0.333, 0.050>,<off,off,1>,<-1,+0.75,0.005>
      }
    }
  }

#macro SCCM_CucharonGrandeDetalle
                ( LargoBoca, AnchoBoca, FondoCucharon,
                  LargoMango, FraccionAngulo, AnguloMango, AnguloCucharon,
                  AnchoManguito, GruesoManguito, FraccionAgarradera,
                  TexturaPrincipal, TexturaManguillo, TexturaAgarradera )
  union                 {
    #local MyRed1     =
      object              {
        SCCM_Red( SCCM_RedCucharonGrande, SCCM_Archivo, 
                        SCCM_BanderaLectura, 0 )
        translate     -0.001*x
      }
    #local MyRed2       =
      union             {
        object            {
          MyRed1
        }
        object            {
          MyRed1
          scale               <-1,1,1>
        }
        scale             < LargoBoca, AnchoBoca, FondoCucharon*2 >
      }
    union               {
      union               {
        object              {
          MyRed2
        }
        object              {
          MyRed2
          scale     1.02
          translate -0.01*AnchoBoca*y
        }
        scale             <1,-1,1>
        rotate          +( AnguloMango+AnguloCucharon )*x
        translate        -GruesoManguito/2*z
        translate         -FraccionAngulo*LargoMango*y
        texture         {
          TexturaPrincipal
        }
      }
      box               {
        <-AnchoManguito/2,0,-GruesoManguito/2>,
        <+AnchoManguito/2,
          -FraccionAngulo*LargoMango-FondoCucharon/6,+GruesoManguito/2>
      }
      cylinder          {
        0               ,
        ( -FraccionAngulo*LargoMango-FondoCucharon/6 )*y,
        GruesoManguito/2
        translate       -AnchoManguito/2*x
      }
      cylinder          {
        0               ,
        ( -FraccionAngulo*LargoMango-FondoCucharon/6 )*y,
        GruesoManguito/2
        translate       +AnchoManguito/2*x
      }
      cylinder          {
        -AnchoManguito/2*x      , +AnchoManguito/2*x    ,
        GruesoManguito/2
      }
      sphere            {
        -AnchoManguito/2*x,
        GruesoManguito/2
      }
      sphere            {
        +AnchoManguito/2*x,
        GruesoManguito/2
      }
      rotate            -AnguloMango*x
      translate         -( 1-FraccionAngulo )*LargoMango*y
    }
    union               {
      box                 {
        <-AnchoManguito/2,-FraccionAgarradera/2*LargoMango,-GruesoManguito/2>,
        <+AnchoManguito/2,-( 1-FraccionAngulo )*LargoMango,+GruesoManguito/2>
      }
      cylinder            {
        -FraccionAgarradera*LargoMango/2*y,
        -( 1-FraccionAngulo )*LargoMango*y,
        GruesoManguito/2
        translate       -AnchoManguito/2*x
      }
      cylinder            {
        -FraccionAgarradera*LargoMango/2*y,
        -( 1-FraccionAngulo )*LargoMango*y,
        GruesoManguito/2
        translate       +AnchoManguito/2*x
      }
      difference        {
        superellipsoid  {
          <0.6,0.5>
          texture       {
            TexturaAgarradera
          }
          translate     -y
          scale         < 1.5*AnchoManguito,FraccionAgarradera/2*LargoMango,
                        14/8*GruesoManguito >
        }
        cylinder        {
          -0.90*FraccionAgarradera*LargoMango*y,
          -0.91*FraccionAgarradera*LargoMango*y,
          3*AnchoManguito
        }
        cylinder        {
          -3*AnchoManguito*z,
          +3*AnchoManguito*z,
          AnchoManguito/2+GruesoManguito/2
          translate     -1.5*AnchoManguito*y
        }
        plane           {
          y            ,0
          translate     -0.95*FraccionAgarradera*LargoMango*y
        }
        texture         {
          TexturaAgarradera
        }
      }
    }
    translate           +1.5*AnchoManguito*y
    texture             {
      TexturaManguillo
    }
  }
#end

#macro SCCM_CucharonGrande()
  #local L                      = SCCM_L;
  #local FondoCucharon          = 29*L;
  #local LargoBoca              = 61*L;
  #local AnchoBoca              = 69*L;
  #local LargoMango             = 159*L;
  #local FraccionAngulo         = 0.20;
  #local AnguloMango            = 15;
  #local AnguloCucharon         = 15;
  #local AnchoManguito          = 8*L;
  #local GruesoManguito         = 4*L;
  #local FraccionAgarradera     = 0.515;
  object                {
    SCCM_CucharonGrandeDetalle
        ( LargoBoca, AnchoBoca, FondoCucharon, LargoMango,
          FraccionAngulo, AnguloMango, AnguloCucharon,
          AnchoManguito, GruesoManguito,
          FraccionAgarradera,
          SCCM_DefaultTexturaPrincipal,
          SCCM_DefaultTexturaManguillo,
          SCCM_DefaultTexturaAgarradera )
  }
#end

