// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 18 junio 2012
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// SCCM_Au1.inc           archivo original
// SCCM_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// SCCM_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// SCCM_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// SCCM_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// SCCM_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SCCM SimpleCucharonCocinaManual
// Dibuja un cucharon simple de cocina, para uso domestico.
// Incluye macros de textura y permite modificaciones leves.
// La macro principal carece de parametros.
// #macro SCCM_CucharonGrande()
//
// El cucharon se encuentra contenido en un volumen aproximado
//      Minimo          : < -35  , -210  ,  25   >*L
//      Maximo          : <  35  ,   12  , -12.5 >*L
// El cucharon se dibuja con el agujero para colgar
// centrado en el origen del plano XY.
// La boca con abertura hacia Z-, colgando con gravedad Y-.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro SCCM_CucharonGrandeDetalle
//                ( LargoBoca, AnchoBoca, FondoCucharon,
//                  LargoMango, FraccionAngulo, AnguloMango, AnguloCucharon,
//                  AnchoManguito, GruesoManguito, FraccionAgarradera,
//                  TexturaPrincipal, TexturaManguillo, TexturaAgarradera )
//      LargoBoca       : Referencia para el largo Y de la boca.
//                        Default es 61*L.
//      AnchoBoca       : Referencia para el ancho X de la boca.
//                        Default es 69*L.
//      FondoCucharon   : Referencia para el hondo Z del cucharon.
//                        Default es 29*L.
//      LargoMango      : Referencia para el largo del mango.
//                        Default es 159*L.
//      FraccionAngulo  : Valor fraccionario para establecer el punto
//                        en donde la agarradera del mango,
//                        forma un quiebre.
//                        Entre mas pequeno se acerca a la boca.
//                        Default es 0.20.
//      AnguloMango     : Angulo de giro del angulo en el mango.
//                        Podria ser util para aumentar el realismo
//                        de la animacion.
//                        Default es 15.
//      AnguloCucharon  : Angulo de giro del cucharon respecto
//                        al plano XY.
//                        Default es 15.
//      AnchoManguito   : Referencia para el ancho del manguillo.
//                        Default es 8*L.
//      GruesoManguito  : Referencia para el grueso del manguillo.
//                        Default es 4*L.
//      FraccionAgarradera              : Referencia fraccionario,
//                        para asignar la parte del mango, que
//                        corresponde a la agarradera gruesa.
//                        Default es 0.515.
//      TexturaPrincipal                : Textura a aplicar al
//                        cucharon.
//                        Default es Default_TexturaPrincipal.
//      TexturaManguillo                : Textura a aplicar al
//                        manguillo delgado de union entre la
//                        agarradera y la boca del cucharon.
//                        Default es Default_TexturaManguillo.
//      TexturaAgarradera               : Textura a aplicar a la agarradera.
//                        Default es Default_TexturaAgarradera.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// SCCM_TexturaPrincipal
//      Textura a aplicar a la boca del cucharon.
// SCCM_TexturaManguillo
//      Textura a aplicar al manguillo delgado de union entre la
//      agarradera y la boca del cucharon.
// SCCM_TexturaAgarradera
//      Textura a aplicar a la agarradera.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SCCM_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare SCCM_DefaultTexturaPrincipal                =
//              texture { SCCM_TexturaPrincipal }
//      Textura a aplicar a la boca del cucharon.
// #declare SCCM_DefaultTexturaManguillo                =
//              texture { SCCM_TexturaManguillo }
//      Textura a aplicar al manguillo delgado de union entre la
//      agarradera y la boca del cucharon.
// #declare SCCM_DefaultTexturaAgarradera               =
//              texture { SCCM_TexturaAgarradera }
//      Textura a aplicar a la agarradera.
//
// Para colocarlo simplemente
// #include "SCCM.inc"
// object        { CEUP_CucharonGrande() }
//
// Otro ejemplo con modificador
// #include "SCCM.inc"
// #declare SCCM_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 SCCM_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      SCCM_CucharonGrande()
// }
//
// Otro ejemplo con macro de texturas
// #include "SCCM.inc"
// #include "textures.inc"
// object                {
//   SCCM_CucharonGrandeDetalle
//        ( 0.061, 0.067, 0.029, 0.159, 0.20, 15, 15, 0.008, 0.004, 0.515,
//          PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare L                      = 0.001;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "SCCM.inc"

#local FactorAcercamiento       = 5;

object          {           
  SCCM_CucharonGrande()
  translate          +100*L*y   
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}
