// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 18 junio 2012
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// SEPM_Au1.inc           archivo original
// SEPM_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// SEPM_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// SEPM_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// SEPM_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// SEPM_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SEPM SimpleEspatulaPlanaManual
// Dibuja una simple espatula de cocina, para uso domestico.
// Incluye macros de textura y permite modificaciones leves.
// La macro principal carece de parametros.
// #macro SEPM_EspatulaPlana()
//
// La espatula se encuentra contenido en un volumen aproximado
//      Minimo          : < -38  , -215  ,  10   >*L
//      Maximo          : <  38  ,   18.5, -20   >*L
// La espatula se dibuja con el agujero para colgar
// centrado en el origen del plano XY.
// La boca con abertura hacia Z-, colgando con gravedad Y-.
// El mango alineado en el eje Y.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro SEPM_EspatulaPlanaDetalle
//        ( LargoPlano, AnchoPlano, FondoPlano,
//          LargoMango, FraccionAngulo, AnguloMango, AnguloEspatula,
//          AnchoManguito, GruesoManguito, FraccionAgarradera,
//          TexturaMetalizada, TexturaMetalizada2,
//          TexturaMadera1, TexturaMadera2 )
//      LargoPlano      : Referencia para el largo Y de la base plana.
//                        Default es 72*L.
//      AnchoPlano      : Referencia para el ancho X de la base plana.
//                        Default es 72*L.
//      FondoPlano      : Referencia para el hondo Z de la base plana.
//                        Default es 6*L.
//      LargoMango      : Referencia para el largo del mango.
//                        Default es 164*L.
//      FraccionAngulo  : Valor fraccionario para establecer el punto
//                        en donde la agarradera del mango,
//                        forma un quiebre.
//                        Entre mas pequeno se acerca a la boca.
//                        Default es 0.11.
//      AnguloMango     : Angulo de giro del angulo en el mango.
//                        Podria ser util para aumentar el realismo
//                        de la animacion.
//                        Default es 15.
//      AnguloEspatula  : Angulo de giro de la base plana respecto
//                        al plano XY.
//                        Default es 25.
//      AnchoManguito   : Referencia para el ancho del manguillo.
//                        Default es 8.5*L.
//      GruesoManguito  : Referencia para el grueso del manguillo.
//                        Default es 3.5*L.
//      FraccionAgarradera              : Referencia fraccionario,
//                        para asignar la parte del mango, que
//                        corresponde a la agarradera gruesa.
//                        Default es 0.515.
//      TexturaMetalizada               : Textura a aplicar a la base plana.
//                        Default es Default_TexturaMetalizada.
//      TexturaMetalizada2              : Textura a aplicar al manguillo
//                        metalico que soporta la base plana.
//                        Default es Default_TexturaMetalizada2.
//      TexturaMadera1  : Textura a aplicar al mango de madera.
//                        La decoracion superior.
//                        Default es Default_TexturaMadera1.
//      TexturaMadera2  : Textura a aplicar al mango de madera.
//                        La decoracion inferior.
//                        Default es Default_TexturaMadera2.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// SEPM_TexturaMetalizada
//      Textura a aplicar a la base plana.
// SEPM_TexturaMetalizada2
//      Textura a aplicar al manguillo metalico que soporta la base plana.
// SEPM_TexturaMadera1
//      Textura a aplicar al mango de madera.  Decoracion superior.
// SEPM_TexturaMadera2
//      Textura a aplicar al mango de madera.  Decoracion inferior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SEPM_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare SEPM_DefaultTexturaMetalizada               =
//              texture { SEPM_TexturaMetalizada }
//      Textura a aplicar a la base plana.
// #declare SEPM_DefaultTexturaMetalizada2              =
//              texture { SEPM_TexturaMetalizada2 }
//      Textura a aplicar al manguillo metalico que soporta la base plana.
// #declare SEPM_DefaultTexturaMadera1                  =
//              texture { SEPM_TexturaMadera1 }
//      Textura a aplicar al mango de madera.  Decoracion superior.
// #declare SEPM_DefaultTexturaMadera2                  =
//              texture { SEPM_TexturaMadera2 }
//      Textura a aplicar al mango de madera.  Decoracion inferior.
//
// Para colocarlo simplemente
// #include "SEPM.inc"
// object        { SEPM_EspatulaPlana() }
//
// Otro ejemplo con modificador
// #include "SEPM.inc"
// #declare SEPM_DefaultTexturaMetalizada       = texture       {
//   average
//   texture_map        {
//     [ 0.5 SEPM_TexturaMetalizada     ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      SEPM_EspatulaPlana()
// }
//
// Otro ejemplo con macro de texturas
// #include "SEPM.inc"
// #include "textures.inc"
// object                {
//   SEPM_EspatulaPlana
//        ( 0.072, 0.072, 0.006, 0.164, 0.11, 15, 25, 0.0085, 0.0035, 0.515,
//          PinkAlabaster, PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "SEPM_AU1.inc"
#include "colors.inc"
#include "woods.inc"

#declare SEPM_L                 = 0.001;

#declare SEPM_TexturaMetalizada                 = texture       {
  pigment               {
    Silver*0.70+GreenCopper*0.30
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.01
  }
  finish                {
    specular            0.2
    roughness           0.01
    metallic
  }
}

#ifndef ( SEPM_DefaultTexturaMetalizada )
  #declare SEPM_DefaultTexturaMetalizada        = texture       {
    SEPM_TexturaMetalizada
  }
#end

#declare SEPM_TexturaMetalizada2                = texture       {
  SEPM_TexturaMetalizada
  normal                {
    bumps
    scale       0.1
  }
}

#ifndef ( SEPM_DefaultTexturaMetalizada2 )
  #declare SEPM_DefaultTexturaMetalizada2       = texture       {
    SEPM_TexturaMetalizada2
  }
#end

#declare SEPM_TexturaMadera1                    = texture       {
  T_Wood16
  scale         0.005
}

#ifndef ( SEPM_DefaultTexturaMadera1 )
  #declare SEPM_DefaultTexturaMadera1           = texture       {
    SEPM_TexturaMadera1
  }
#end

#declare SEPM_TexturaMadera2                    = texture       {
  T_Wood18
  normal                {
    gradient            y
    sine_wave
    rotate              150
    scale               3
//    turbulence          0.2
  }
  scale         0.005
}

#ifndef ( SEPM_DefaultTexturaMadera2 )
  #declare SEPM_DefaultTexturaMadera2           = texture       {
    SEPM_TexturaMadera2
  }
#end

#declare SEPM_RedEspatulaPlana  = array [3][3][4]
  { { {
< 0.000, 0.000, 0.500>,< 0.000,-1.000,-0.500>,<on ,off,3>,<-1,+3.75,0.025>
      },{
< 0.250, 0.120, 0.450>,< 1.000,-1.000,-0.500>,<on ,off,3>,<-1,+3.75,0.025>
      },{
< 0.330, 0.200, 0.450>,< 1.000,-1.000,-0.500>,<off,off,1>,<-1,-0.75,0.100>
      }
    },
    { {
< 0.000, 0.120, 0.000>,< 0.000,-1.000,-1.000>,<on ,off,4>,<-1,+5.75,0.025>
      },{
< 0.260, 0.230, 0.000>,< 1.000,-1.000,-1.000>,<on ,off,3>,<-1,+5.75,0.010>
      },{
< 0.400, 0.320, 0.425>,< 1.000,-0.800,-0.500>,<off,off,1>,<-1,-0.75,0.025>
      }
    },
    { {
< 0.000, 1.000,-0.005>,< 0.000, 0.000,-1.000>,<off,off,3>,<-1,-0.75,0.025>
      },{
< 0.430, 0.910, 0.000>,< 0.200, 0.500,-0.500>,<off,off,3>,<-1,-0.75,0.010>
      },{
< 0.500, 0.860, 0.400>,< 1.000, 0.500,-0.600>,<off,off,1>,<-1,+0.75,0.005>
      },
    }
  }

#macro SEPM_EspatulaPlanaDetalle
        ( LargoPlano, AnchoPlano, FondoPlano,
          LargoMango, FraccionAngulo, AnguloMango, AnguloEspatula,
          AnchoManguito, GruesoManguito, FraccionAgarradera,
          TexturaMetalizada, TexturaMetalizada2,
          TexturaMadera1, TexturaMadera2 )
  union                 {
    #local MyRed1     =
      object              {
        SEPM_Red( SEPM_RedEspatulaPlana, "", off, 0 )
        translate     -0.001*x
      }
    #local MyRed2       =
      union             {
        object            {
          MyRed1
        }
        object            {
          MyRed1
          scale               <-1,1,1>
        }
        scale             < LargoPlano, AnchoPlano, FondoPlano*2 >
      }
    union               {
      object              {
        MyRed2
        scale           <1,-1,-1>
        translate       +FondoPlano*z
        rotate          +( AnguloMango+AnguloEspatula )*x
        texture         {
          TexturaMetalizada
        }
      }
      difference        {
        box               {
          +GruesoManguito*z
          -1.5*AnchoManguito*x
          +FraccionAngulo*LargoMango*y,
          +1.5*AnchoManguito*x
          -0.05*LargoPlano*y
        }
        box               {
          +2*GruesoManguito*z
          -0.475*AnchoManguito*x
          +2*FraccionAngulo*LargoMango*y,
          +0.025*GruesoManguito*z
          +0.49*AnchoManguito*x
          -LargoPlano*y
        }
        cylinder        {
          -3*GruesoManguito*z,
          +3*GruesoManguito*z,
          1
          scale         <AnchoManguito,FraccionAngulo*LargoMango,1> 
          translate     +1.5*AnchoManguito*x
                        +FraccionAngulo*LargoMango*y
        }
        cylinder        {
          -3*GruesoManguito*z,
          +3*GruesoManguito*z,
          1
          scale         <AnchoManguito,FraccionAngulo*LargoMango,1>
          translate     -1.5*AnchoManguito*x
                        +FraccionAngulo*LargoMango*y
        }
        cylinder        {
          +0.025*GruesoManguito*z,
          3*GruesoManguito*z,
          1
          scale         <AnchoManguito,0.45*FraccionAngulo*LargoMango,1>
        }
      }
      translate         -FraccionAngulo*LargoMango*y
      rotate            -AnguloMango*x
      translate         -( 1-FraccionAngulo )*LargoMango*y
    }
    difference          {
      union             {
        box               {
          < -0.5,  0.0,  1 >,
          < +0.5, -1  ,  0 >
        }
        box               {
          < -0.5,  0.0,  1 >,
          < +0.5,  2  ,  0 >
          rotate   degrees( atan2( 0.75,1  ) )*z
          translate       -y
        }
        box               {
          < -0.5,  0.0,  1 >,
          < +0.5,  2  ,  0 >
          rotate   -degrees( atan2( 0.75,1  ) )*z
          translate       -y
        }
      }
      cylinder          {
        -2              ,       2,
        0.90
        scale           <1,0.3,1>
      }
      union             {
        box               {
          < -0.5,  0.0,  1 >,
          < +0.5, -1  ,  0 >
        }
        box               {
          < -0.5,  0.0,  1 >,
          < +0.5,  2  ,  0 >
          rotate   degrees( atan2( 0.75,1  ) )*z
          translate       -y
        }
        box               {
          < -0.5,  0.0,  1 >,
          < +0.5,  2  ,  0 >
          rotate   -degrees( atan2( 0.75,1  ) )*z
          translate       -y
        }
        scale           <0.90,1.01,2>
        translate       +0.01*z
      }
      plane             {
        -y              , 0
        translate       -1.45*AnchoManguito/LargoMango*y
      }
      plane             {
        y               , 0
        translate       -y
      }
      scale           <AnchoManguito,
                (1-FraccionAngulo)*LargoMango,GruesoManguito>
    }
    difference          {
      cylinder          {
        0               , +GruesoManguito*z,
        AnchoManguito*1.45
      }
      cylinder          {
        0               , +GruesoManguito*z,
        AnchoManguito*1.425
        translate       +0.05*GruesoManguito*z
      }
      plane             {
        y               , 0
      }
      translate       -1.45*AnchoManguito*y
    }
    difference          {
      union             {
        sphere              {
          0                 , 1
          scale             < 0.90*1.45*AnchoManguito,
                            0.90*1.45*AnchoManguito, 2.5*GruesoManguito >
          translate         -1.45*AnchoManguito*y+0.5*GruesoManguito*z
          texture           {
            TexturaMadera1
          }
        }
        difference          {
          superellipsoid    {
            < 0.8, 1.0 >
            scale             < 0.90*1.45*AnchoManguito,
                              0.45*LargoMango, 2.5*GruesoManguito >
          }
          difference        {
            sphere          {
              0             , 0.135*LargoMango*1.1
              translate     -0.135*LargoMango*1.1*0.25*z
              scale         <1,2.0,1>
              translate     -0.400*LargoMango*y+1.5*1.45*AnchoManguito*x
            }
            plane           {
              -z            , 0
            }
          }
          plane             {
            -y              , 0
          }     
          scale                 <1,FraccionAgarradera/0.515,1>
          translate         -1.45*AnchoManguito*y+0.5*GruesoManguito*z
          texture           {
            TexturaMadera1
          }
        }
        intersection        {
          superellipsoid    {
            < 0.8, 1.0 >
            scale             < 0.90*1.45*AnchoManguito,
                              0.45*LargoMango, 2.5*GruesoManguito >
          }
          difference        {
            sphere          {
              0             , 0.135*LargoMango*1.1
              translate     -0.135*LargoMango*1.1*0.25*z
              scale         <1,2.0,1.0>
              translate     -0.400*LargoMango*y+1.5*1.45*AnchoManguito*x
            }
            plane           {
              -z            , 0
            }
          }   
          scale                 <1,FraccionAgarradera/0.515,1>
          translate         -1.025*1.45*AnchoManguito*y+0.5*GruesoManguito*z
          texture           {
            TexturaMadera2
          }
        }
      }
      cylinder          {
        -10*GruesoManguito*z, +10*GruesoManguito*z,
        AnchoManguito/2
        scale           <1,1.5,1>
        translate  -1.45*1.5*AnchoManguito*y        
      }      
    }
    translate           +1.45*1.5*AnchoManguito*y
    texture             {
      TexturaMetalizada2
    }
  }
#end

#macro SEPM_EspatulaPlana()
  #local L                      = SEPM_L;
  #local FondoPlano             = 6*L;
  #local LargoPlano             = 72*L;
  #local AnchoPlano             = 72*L;
  #local LargoMango             = 164*L;
  #local FraccionAngulo         = 0.11;
  #local AnguloMango            = 15;
  #local AnguloEspatula         = 25;
  #local AnchoManguito          = 8.5*L;
  #local GruesoManguito         = 3.5*L;
  #local FraccionAgarradera     = 0.515;
  object                {
    SEPM_EspatulaPlanaDetalle
        ( LargoPlano, AnchoPlano, FondoPlano,
          LargoMango, FraccionAngulo, AnguloMango, AnguloEspatula,
          AnchoManguito, GruesoManguito, FraccionAgarradera,
          SEPM_DefaultTexturaMetalizada,
          SEPM_DefaultTexturaMetalizada2,
          SEPM_DefaultTexturaMadera1,
          SEPM_DefaultTexturaMadera2 )
  }
#end
