// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 18 junio 2012
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// SEPM_Au1.inc           archivo original
// SEPM_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// SEPM_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// SEPM_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// SEPM_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// SEPM_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SEPM SimpleEspatulaPlanaManual
// Dibuja una simple espatula de cocina, para uso domestico.
// Incluye macros de textura y permite modificaciones leves.
// La macro principal carece de parametros.
// #macro SEPM_EspatulaPlana()
//
// La espatula se encuentra contenido en un volumen aproximado
//      Minimo          : < -38  , -215  ,  10   >*L
//      Maximo          : <  38  ,   18.5, -20   >*L
// La espatula se dibuja con el agujero para colgar
// centrado en el origen del plano XY.
// La boca con abertura hacia Z-, colgando con gravedad Y-.
// El mango alineado en el eje Y.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro SEPM_EspatulaPlanaDetalle
//        ( LargoPlano, AnchoPlano, FondoPlano,
//          LargoMango, FraccionAngulo, AnguloMango, AnguloEspatula,
//          AnchoManguito, GruesoManguito, FraccionAgarradera,
//          TexturaMetalizada, TexturaMetalizada2,
//          TexturaMadera1, TexturaMadera2 )
//      LargoPlano      : Referencia para el largo Y de la base plana.
//                        Default es 72*L.
//      AnchoPlano      : Referencia para el ancho X de la base plana.
//                        Default es 72*L.
//      FondoPlano      : Referencia para el hondo Z de la base plana.
//                        Default es 6*L.
//      LargoMango      : Referencia para el largo del mango.
//                        Default es 164*L.
//      FraccionAngulo  : Valor fraccionario para establecer el punto
//                        en donde la agarradera del mango,
//                        forma un quiebre.
//                        Entre mas pequeno se acerca a la boca.
//                        Default es 0.11.
//      AnguloMango     : Angulo de giro del angulo en el mango.
//                        Podria ser util para aumentar el realismo
//                        de la animacion.
//                        Default es 15.
//      AnguloEspatula  : Angulo de giro de la base plana respecto
//                        al plano XY.
//                        Default es 25.
//      AnchoManguito   : Referencia para el ancho del manguillo.
//                        Default es 8.5*L.
//      GruesoManguito  : Referencia para el grueso del manguillo.
//                        Default es 3.5*L.
//      FraccionAgarradera              : Referencia fraccionario,
//                        para asignar la parte del mango, que
//                        corresponde a la agarradera gruesa.
//                        Default es 0.515.
//      TexturaMetalizada               : Textura a aplicar a la base plana.
//                        Default es Default_TexturaMetalizada.
//      TexturaMetalizada2              : Textura a aplicar al manguillo
//                        metalico que soporta la base plana.
//                        Default es Default_TexturaMetalizada2.
//      TexturaMadera1  : Textura a aplicar al mango de madera.
//                        La decoracion superior.
//                        Default es Default_TexturaMadera1.
//      TexturaMadera2  : Textura a aplicar al mango de madera.
//                        La decoracion inferior.
//                        Default es Default_TexturaMadera2.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// SEPM_TexturaMetalizada
//      Textura a aplicar a la base plana.
// SEPM_TexturaMetalizada2
//      Textura a aplicar al manguillo metalico que soporta la base plana.
// SEPM_TexturaMadera1
//      Textura a aplicar al mango de madera.  Decoracion superior.
// SEPM_TexturaMadera2
//      Textura a aplicar al mango de madera.  Decoracion inferior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SEPM_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare SEPM_DefaultTexturaMetalizada               =
//              texture { SEPM_TexturaMetalizada }
//      Textura a aplicar a la base plana.
// #declare SEPM_DefaultTexturaMetalizada2              =
//              texture { SEPM_TexturaMetalizada2 }
//      Textura a aplicar al manguillo metalico que soporta la base plana.
// #declare SEPM_DefaultTexturaMadera1                  =
//              texture { SEPM_TexturaMadera1 }
//      Textura a aplicar al mango de madera.  Decoracion superior.
// #declare SEPM_DefaultTexturaMadera2                  =
//              texture { SEPM_TexturaMadera2 }
//      Textura a aplicar al mango de madera.  Decoracion inferior.
//
// Para colocarlo simplemente
// #include "SEPM.inc"
// object        { SEPM_EspatulaPlana() }
//
// Otro ejemplo con modificador
// #include "SEPM.inc"
// #declare SEPM_DefaultTexturaMetalizada       = texture       {
//   average
//   texture_map        {
//     [ 0.5 SEPM_TexturaMetalizada     ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      SEPM_EspatulaPlana()
// }
//
// Otro ejemplo con macro de texturas
// #include "SEPM.inc"
// #include "textures.inc"
// object                {
//   SEPM_EspatulaPlana
//        ( 0.072, 0.072, 0.006, 0.164, 0.11, 15, 25, 0.0085, 0.0035, 0.515,
//          PinkAlabaster, PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#local   L                      = 0.001;
#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}


#include "SEPM.inc"

#local FactorAcercamiento       = 5;

object          {
  SEPM_EspatulaPlana( )
  translate          +100*L*y   
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}
