// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SPRE SillaPlegableRecuerdoEmpresarial
// El archivo dibuja una silla plegable sencilla
// #macro SPRE_SillaPlegable( FraccionCruce, FraccionSentado )
//      FraccionCruce   : fraccion para abrir la silla
//                        0.0 silla compacta para guardar
//                        1.0 silla abierta para sentarse
//      FraccionSentado : fraccion que rota la silla completa
//                        0.0 asiento vertical para guardar
//                        1.0 asiento horizontal para sentarse
//
// Las dimensiones de la silla plegable
// La silla plegable se dibuja de forma que el origen
// se encuentre centrado en el forro superior del asiento
//      Radio asiento           = 105*L
// Cuando se cierra SPRE_SillaPlegable(0,0)
// sobresale hacia X+
//      Minimo  <   0,-390,-105>*L
//      Maximo  <+ 60,+105,+105>*L
// Cuando se abre SPRE_SillaPlegable(1,1)
// Desde el origen las patas hacia Y-, las patas se ven cruzadas desde Z-.
//      Minimo  <-120,-320,-105>*L
//      Maximo  <+120,   0,+105>*L
//
// La siguiente macro permite modificar las texturas facilmente.
// #macro SPRE_SillaPlegableRecuerdoEmpresarial
//        ( FraccionCruce, FraccionSentado,
//          TexturaPrincipal, TexturaCorcho, TexturaCirculo,
//          TexturaAsiento, TexturaTornillo )
//      FraccionCruce   : fraccion para abrir la silla
//                        0.0 silla compacta para guardar
//                        1.0 silla abierta para sentarse
//      FraccionSentado : fraccion que rota la silla completa
//                        0.0 asiento vertical para guardar
//                        1.0 asiento horizontal para sentarse
//      TexturaPrincipal        : Textura principal de las barras.
//      TexturaCorcho           : Textura de las patitas de hule.
//      TexturaCirculo          : Textura metalica del asiento.
//      TexturaAsiento          : Textura roja para sentarse.
//      TexturaTornillo         : Textura de tornillos.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare SPRE_TexturaPrincipal
//      Textura principal de las barras.
// #declare SPRE_TexturaCorcho
//      Textura a aplicar a las patitas de hule.
// #declare SPRE_TexturaCirculo
//      Textura metalica del asiento.
// #declare SPRE_TexturaAsiento
//      Textura roja para sentarse.
// #declare SPRE_TexturaTornillo
//      Textura a aplicar al tornillo.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SPRE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare SPRE_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal de las barras.
// #declare SPRE_DefaultTexturaCorcho           = texture { ... }
//      Textura a aplicar a las patitas de hule.
// #declare SPRE_DefaultTexturaCirculo          = texture { ... }
//      Textura metalica del asiento.
// #declare SPRE_DefaultTexturaAsiento          = texture { ... }
//      Textura roja para sentarse.
// #declare SPRE_DefaultTexturaTornillo         = texture { ... }
//      Textura a aplicar al tornillo.
//
// Para colocarlo simplemente
// #include "SPRE.inc"
// object        { SPRE_SillePlegable(1.0,1.0) }
//
// Otro ejemplo con modificador
// #include "SPRE.inc"
// #declare SPRE_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 SPRE_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      SPRE_SillaPlegable(0,0)
// }
//
// Otro ejemplo con macro de texturas
// #include "SPRE.inc"
// #include "textures.inc"
// object             {
//   SPRE_SillaPlegableRecuerdoEmpresarial
//                ( 1.0, 1.0, PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                      PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare SPRE_L                         = 0.001;

#declare SPRE_TexturaPrincipal          =
  texture       {
    pigment     { color Silver*0.9 }
  }

#ifndef ( SPRE_DefaultTexturaPrincipal )
  #declare SPRE_DefaultTexturaPrincipal = texture { SPRE_TexturaPrincipal }
#end

#declare SPRE_TexturaCorcho             =
  texture       {
    pigment     { color Silver*0.6 }
  }

#ifndef ( SPRE_DefaultTexturaCorcho )
  #declare SPRE_DefaultTexturaCorcho    = texture { SPRE_TexturaCorcho }
#end

#declare SPRE_TexturaCirculo            =
  texture       {
    pigment     { color Silver }
  }

#ifndef ( SPRE_DefaultTexturaCirculo )
  #declare SPRE_DefaultTexturaCirculo   = texture { SPRE_TexturaCirculo }
#end

#declare SPRE_TexturaAsiento            =
  texture       {
    pigment     { color Red }
  }

#ifndef ( SPRE_DefaultTexturaAsiento )
  #declare SPRE_DefaultTexturaAsiento   = texture { SPRE_TexturaAsiento }
#end

#declare SPRE_TexturaTornillo           =
  texture       {
    pigment     { color Silver*0.6 }
  }

#ifndef ( SPRE_DefaultTexturaTornillo )
  #declare SPRE_DefaultTexturaTornillo  = texture { SPRE_TexturaTornillo }
#end

#macro SPRE_Tornillo( Tamano )
  torus         {
    1           , 0.5
    scale       Tamano/3.0
  }
#end

#macro SPRE_SillaPlegableRecuerdoEmpresarial
        ( FraccionCruce, FraccionSentado,
          TexturaPrincipal, TexturaCorcho, TexturaCirculo, TexturaAsiento,
          TexturaTornillo )
  union                         {
    #local L                    = SPRE_L;
    // Caracteristicas de asiento
    #local DiametroCirculoInterior      = 182*L;
    #local DiametroCirculoMayor         = 209*L;
    #local GruesoAsientoRojo            = 14*L;
    // Caracteristicas de agarre
    #local AnguloDistorsion     = 0.5;
    #local LargoAgarreInferior  = 121.5*L;
    #local AnchoAgarreInferior  = 20*L;
    #local DiametroBarraAgarre  = 14*L;
    #local SeparacionAgarreInferior     = 130*L;
    #local GruesoFino           = 0.5*L;
    #local GruesoMedio          = 1.0*L;
    #local GruesoFirme          = 2.0*L;
    #local DiametroTornillo     = 7*L;
    // Caracteristicas de barras
    #local DiametroCirculoAgarre1       = 20*L;
    #local LargoPuntoGiroBarra1         = 109*L;
    #local LargoMedioBarra1             = 132*L;
    #local SegundoMedioBarra1           = 200*L;
    #local DiametroCorcho               = 15*L;
    #local FraccionSoporteInferior      = 155/200;
    #local SeparacionPatas              = 16*L;
    #local AnguloSegundoMedio           = 7;
    #local DiametroSoporteInferior      = 10*L;
    #local FraccionPlanaBarra1          = 30/109;
    #local AnguloMinimoCruce            =
         degrees( asin( ( DiametroBarraAgarre/2+DiametroSoporteInferior/2 )/
                              ( FraccionSoporteInferior*SegundoMedioBarra1*
                                cos( radians( AnguloSegundoMedio ) )+
                                LargoMedioBarra1-LargoPuntoGiroBarra1 ) ) );
    #local AnguloMaximoCruce            = 180-
                degrees( acos( ( LargoAgarreInferior-DiametroBarraAgarre )/
                        ( 2*( LargoPuntoGiroBarra1 ) ) ) );
    #local AnguloCruce                  =
                FraccionCruce*( AnguloMaximoCruce-AnguloMinimoCruce )
                +AnguloMinimoCruce;
    // Calculo del angulo de cruce secundario
    // es el angulo en que se abre la segunda pata
    // respecto de la primera como angulo positivo
    // respecto al punto de giro
    #local MedioSoporte                 =
                LargoAgarreInferior/2-DiametroBarraAgarre/2;
    #local PivoteReal                   =
                MedioSoporte*MedioSoporte
                +LargoPuntoGiroBarra1*LargoPuntoGiroBarra1
                -2*LargoPuntoGiroBarra1*MedioSoporte
                  *cos( radians( 180-AnguloCruce ) );
    #local PivoteReal                   = sqrt( PivoteReal );
    #local AnguloCruceSecundario        =
        2*degrees( asin( MedioSoporte*
                sin( radians( 180-AnguloCruce ) )/PivoteReal ) );
    #local AnguloAgarreSegundaPata      =
                2*AnguloCruce-AnguloCruceSecundario;
    // Caracteristicas patilla corcho
    #local DiametroPataCorcho           = 15*L;
    #local AltoPataCorcho               = 14*L;
    union                       {
      difference                { 
        cylinder                  {
          0                       , -GruesoFirme*x        ,
          DiametroCirculoInterior/2
        }
        cylinder                {
          +GruesoFirme*x          , -0.9*GruesoFirme*x    ,
          DiametroTornillo/2
        }
      }
      #local C                  = 0;
      #while ( C < 4 )
        object                  {
          SPRE_Tornillo( DiametroTornillo )
          rotate                90*z
          translate             +0.45*DiametroCirculoInterior*y
          rotate                C*90*x
          texture               {
            TexturaTornillo
          }
        }
        #local C                = C+1;
      #end
      torus                     {
        DiametroCirculoMayor/2-GruesoFirme/2,
        GruesoFirme
        rotate                  90*z
      }   
      difference                {
        superellipsoid          {
          <1,0.50>  
          rotate                90*y
          scale         <GruesoAsientoRojo,
              DiametroCirculoInterior/2,DiametroCirculoInterior/2>
        }
        plane           {
          -x             , 0
        }
        translate             -GruesoFirme*x
        texture                 {
          TexturaAsiento
        }
      }
      difference                {
        torus                   {
          ( DiametroCirculoInterior+DiametroCirculoMayor )/4,
          ( DiametroCirculoMayor-DiametroCirculoInterior )/4+GruesoFirme/2
          rotate                90*z
        }
        torus                   {
          ( DiametroCirculoInterior+DiametroCirculoMayor )/4,
          ( DiametroCirculoMayor-DiametroCirculoInterior )/4-GruesoFirme/2
          rotate                90*z
        }
        plane                   {
          -x                    , 0
        }
      }
      texture                   {
        TexturaCirculo
      }
    }
    #local C                    = 0;
    #while ( C < 2 )
      union                     {
        #local D                = 0;
        #while ( D < 2 )
          union                 {
            box                       {
              < 0, -LargoAgarreInferior/2+DiametroBarraAgarre/2,
                                -GruesoFino/2 >,
              < AnchoAgarreInferior,
                +LargoAgarreInferior/2-DiametroBarraAgarre/2, +GruesoFino/2 >
            }
            box                       {
              < 0, -LargoAgarreInferior/2,
                                -GruesoFino/2 >,
              < AnchoAgarreInferior-DiametroBarraAgarre/2,
                +LargoAgarreInferior/2, +GruesoFino/2 >
            }
            cylinder                    {
              -GruesoFino/2*z           , +GruesoFino/2*z       ,
              DiametroBarraAgarre/2
              translate < AnchoAgarreInferior-DiametroBarraAgarre/2,
                        LargoAgarreInferior/2-DiametroBarraAgarre/2, 0 >
            }
            cylinder                    {
              -GruesoFino/2*z           , +GruesoFino/2*z       ,
              DiametroBarraAgarre/2
              translate < AnchoAgarreInferior-DiametroBarraAgarre/2,
                        LargoAgarreInferior/2-DiametroBarraAgarre/2, 0 >*
                        <1,-1,1>
            }
            #if ( D = 0 )
              translate GruesoFino/2*z
              rotate    90*y
            #end
          }
          #local D              = D+1;
        #end
        // Par de tornillos
        #local D                  = 0;
        #while ( D < 2 )
          object                  {
            SPRE_Tornillo( DiametroTornillo )
            rotate                90*z
            translate           -AnchoAgarreInferior/2*z+GruesoFino*x
            translate           0.4*LargoAgarreInferior*y
            #if ( D = 0 )
              scale             <1,-1,1>
            #end
            texture             {
              TexturaTornillo
            }
          }
          #local D                = D+1;
        #end        
        #local PataFundamental  =
        union           {
          cylinder      {
            -GruesoFirme/2*z    , GruesoFirme/2*z       ,
            DiametroCirculoAgarre1/2
          }
          cylinder      {
            -1*GruesoFirme*z    , 3*GruesoFirme*z         ,
            DiametroTornillo/2
            texture     {
              TexturaTornillo
            }
          }
          object        {
            SPRE_Tornillo( DiametroTornillo )
            rotate      90*x
            translate   +DiametroBarraAgarre/2*z
                        -LargoPuntoGiroBarra1*y
            texture     {
              TexturaTornillo
            }
          }
          object        {
            SPRE_Tornillo( DiametroTornillo )
            rotate      90*x
            translate   -DiametroBarraAgarre/2*z
                        -LargoPuntoGiroBarra1*y
            texture     {
              TexturaTornillo
            }
          }
          box           {
            < -DiametroCirculoAgarre1/2, 0, -GruesoFirme/2 >,
            < +DiametroCirculoAgarre1/2,
              -FraccionPlanaBarra1*LargoPuntoGiroBarra1, +GruesoFirme/2 >
          }
          sphere        {
            0,          1
            scale       < 0.75*DiametroCirculoAgarre1/2,
                          2*DiametroBarraAgarre/2,
                          DiametroBarraAgarre/2 >
            translate   -FraccionPlanaBarra1*LargoPuntoGiroBarra1*y
          }
          cylinder      {
            -FraccionPlanaBarra1*LargoPuntoGiroBarra1*y,
            -LargoMedioBarra1*y, DiametroBarraAgarre/2
          }
          union         {
            sphere      {
              0         , DiametroBarraAgarre/2

            }
            cylinder    {
              0         , -SegundoMedioBarra1*y,
              DiametroBarraAgarre/2
              rotate    -AnguloSegundoMedio*x
            }
            cylinder    {
              SegundoMedioBarra1*FraccionSoporteInferior*
                <0,-cos(radians(AnguloSegundoMedio)),
                   sin(radians(AnguloSegundoMedio))>,
              SegundoMedioBarra1*FraccionSoporteInferior*
                <0,-cos(radians(AnguloSegundoMedio)),
                   sin(radians(AnguloSegundoMedio))>+
              3/4*SeparacionAgarreInferior*
              <+sin(radians(AnguloDistorsion)),0,-cos(radians(AnguloDistorsion))>,
              DiametroSoporteInferior/2
            }
            union               {
              cylinder          {
                0               , AltoPataCorcho*y      ,
                DiametroPataCorcho/2
              }
              sphere            {
                0       , DiametroPataCorcho/2
              }
              translate       -SegundoMedioBarra1*y
              rotate    -AnguloSegundoMedio*x
              texture           {
                TexturaCorcho
              }
            }
            translate   -LargoMedioBarra1*y
          }
        }
        object          {
          PataFundamental
          rotate        AnguloCruce*z
          translate     -( LargoAgarreInferior/2-DiametroBarraAgarre/2 )*y
                        +AnchoAgarreInferior*x-DiametroBarraAgarre/2*x
          translate     -GruesoFino/2*z-1.5*GruesoFirme*z
        }
        // Soporte Segunda Pata
        cylinder      {
          -3.5*GruesoFirme*z    , 1*GruesoFirme*z         ,
          DiametroTornillo/2
          translate     +( AnchoAgarreInferior-DiametroBarraAgarre/2 )*x
          texture       {
            TexturaTornillo
          }
        }
        difference      {
          #local AnchoEspecial  = SeparacionPatas-1.5*GruesoFirme;
          union         {
            box           {
              < -DiametroBarraAgarre/2, 0, -AnchoEspecial/2 >,
              < +DiametroBarraAgarre/2,
                -LargoAgarreInferior/2+DiametroBarraAgarre/2,
                +AnchoEspecial/2 >
            }
            cylinder            {
              -AnchoEspecial/2*z        , +AnchoEspecial/2*z    ,
              DiametroBarraAgarre/2
            }
            cylinder            {
              -AnchoEspecial/2*z        , +AnchoEspecial/2*z    ,
              DiametroBarraAgarre/2
              translate         -LargoAgarreInferior/2*y
                                +DiametroBarraAgarre/2*y
            }            
          }          
          prism                 {
            -1, 1, 6
            <-1,-1>,<-0.25,-0.50>,<0.25,0.50>,<1,1>,<-1.1,1.1>,<-1,-1>
            rotate              90*z
            translate           -y
            scale               <1.001,1.01,1.01>*< DiametroBarraAgarre/2,
               LargoAgarreInferior/4+DiametroBarraAgarre/2, AnchoEspecial/2 >
            translate           +GruesoFirme/2*z
            translate           +DiametroBarraAgarre/2*y
          }
          prism                 {
            -1, 1, 6
            <-1,-1>,<-0.25,-0.50>,<0.25,0.50>,<1,1>,<-1.1,1.1>,<-1,-1>
            rotate              90*z
            scale               <1,-1,-1>
            translate           -y
            scale               <1.001,1.01,1.01>*< DiametroBarraAgarre/2,
               LargoAgarreInferior/4+DiametroBarraAgarre/2, AnchoEspecial/2 >
            translate           -GruesoFirme/2*z
            translate           +DiametroBarraAgarre/2*y
          }
          rotate        AnguloAgarreSegundaPata*z
          translate     +( AnchoAgarreInferior-DiametroBarraAgarre/2 )*x
                        -GruesoFirme/2*z-1.5*GruesoFirme*z
                        -AnchoEspecial/2*z
        }
        // Segunda Pata
        object          {
          PataFundamental
          translate     +LargoPuntoGiroBarra1*y
          rotate        -AnguloCruceSecundario*z
          translate     -LargoPuntoGiroBarra1*y
          rotate        AnguloCruce*z
          translate     -( LargoAgarreInferior/2-DiametroBarraAgarre/2 )*y
                        +AnchoAgarreInferior*x-DiametroBarraAgarre/2*x
          translate     -GruesoFino/2*z-1.5*GruesoFirme*z
          translate     -SeparacionPatas*z
        }
        rotate                  -AnguloDistorsion*x
        translate               SeparacionAgarreInferior/2*z
        #if ( C = 0 )
          scale                 < 1, 1, -1 >
        #end
      }
      #local C                  = C+1;
    #end
    translate                   +GruesoFirme*x+GruesoAsientoRojo*x
    rotate              -FraccionSentado*90*z
    texture                     {
      TexturaPrincipal
    }
  }
#end

#macro SPRE_SillaPlegable( FraccionCruce, FraccionSentado )
  object                {
    SPRE_SillaPlegableRecuerdoEmpresarial
      ( FraccionCruce, FraccionSentado,
        SPRE_DefaultTexturaPrincipal,
        SPRE_DefaultTexturaCorcho,
        SPRE_DefaultTexturaCirculo,
        SPRE_DefaultTexturaAsiento,
        SPRE_DefaultTexturaTornillo
        )
  }
#end

