// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SPRE SillaPlegableRecuerdoEmpresarial
// El archivo dibuja una silla plegable sencilla
// #macro SPRE_SillaPlegable( FraccionCruce, FraccionSentado )
//      FraccionCruce   : fraccion para abrir la silla
//                        0.0 silla compacta para guardar
//                        1.0 silla abierta para sentarse
//      FraccionSentado : fraccion que rota la silla completa
//                        0.0 asiento vertical para guardar
//                        1.0 asiento horizontal para sentarse
//
// Las dimensiones de la silla plegable
// La silla plegable se dibuja de forma que el origen
// se encuentre centrado en el forro superior del asiento
//      Radio asiento           = 105*L
// Cuando se cierra SPRE_SillaPlegable(0,0)
// sobresale hacia X+
//      Minimo  <   0,-390,-105>*L
//      Maximo  <+ 60,+105,+105>*L
// Cuando se abre SPRE_SillaPlegable(1,1)
// Desde el origen las patas hacia Y-, las patas se ven cruzadas desde Z-.
//      Minimo  <-120,-320,-105>*L
//      Maximo  <+120,   0,+105>*L
//
// La siguiente macro permite modificar las texturas facilmente.
// #macro SPRE_SillaPlegableRecuerdoEmpresarial
//        ( FraccionCruce, FraccionSentado,
//          TexturaPrincipal, TexturaCorcho, TexturaCirculo,
//          TexturaAsiento, TexturaTornillo )
//      FraccionCruce   : fraccion para abrir la silla
//                        0.0 silla compacta para guardar
//                        1.0 silla abierta para sentarse
//      FraccionSentado : fraccion que rota la silla completa
//                        0.0 asiento vertical para guardar
//                        1.0 asiento horizontal para sentarse
//      TexturaPrincipal        : Textura principal de las barras.
//      TexturaCorcho           : Textura de las patitas de hule.
//      TexturaCirculo          : Textura metalica del asiento.
//      TexturaAsiento          : Textura roja para sentarse.
//      TexturaTornillo         : Textura de tornillos.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare SPRE_TexturaPrincipal
//      Textura principal de las barras.
// #declare SPRE_TexturaCorcho
//      Textura a aplicar a las patitas de hule.
// #declare SPRE_TexturaCirculo
//      Textura metalica del asiento.
// #declare SPRE_TexturaAsiento
//      Textura roja para sentarse.
// #declare SPRE_TexturaTornillo
//      Textura a aplicar al tornillo.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SPRE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare SPRE_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal de las barras.
// #declare SPRE_DefaultTexturaCorcho           = texture { ... }
//      Textura a aplicar a las patitas de hule.
// #declare SPRE_DefaultTexturaCirculo          = texture { ... }
//      Textura metalica del asiento.
// #declare SPRE_DefaultTexturaAsiento          = texture { ... }
//      Textura roja para sentarse.
// #declare SPRE_DefaultTexturaTornillo         = texture { ... }
//      Textura a aplicar al tornillo.
//
// Para colocarlo simplemente
// #include "SPRE.inc"
// object        { SPRE_SillePlegable(1.0,1.0) }
//
// Otro ejemplo con modificador
// #include "SPRE.inc"
// #declare SPRE_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 SPRE_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      SPRE_SillaPlegable(0,0)
// }
//
// Otro ejemplo con macro de texturas
// #include "SPRE.inc"
// #include "textures.inc"
// object             {
//   SPRE_SillaPlegableRecuerdoEmpresarial
//                ( 1.0, 1.0, PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                      PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare EjeMejorado            = true;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "SPRE.inc"

#local   FactorAcercamiento     = 2;

union            {
  object          {
    SPRE_SillaPlegable( 1.0, 1.0 )
    translate     -0.20*x+0.10*y
  }
  object          {
    SPRE_SillaPlegable( 0.0, 0.0 )
    rotate        -90*y
    translate     +0.20*x+0.10*y 
  }
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z  
}



