// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// TMEE TajadorMetalicoEconomicoEstudiantil
// El archivo dibuja un tajador corriente,
// lamentablemente es muy poco flexible.
// #macro TMEE_Tajador()
//
// La dimensiones del tajador son :
//      Alto total              = 18.6*L;
//      Fondo                   =  7.9*L;
//      Frente                  = 11.2*L;
// Se dibuja centrado en X sobre el plano XZ, y
// la zona posterior descansando sobre el plano XY.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite modificar las texturas facilmente.
// #macro TMEE_TajadorMetalicoEconomicoEstudiantil
//                ( TexturaPrincipal, TexturaPosterior, TexturaPlaca,
//                  TexturaFilo, TexturaTornillo, TexturaLetra )
//      TexturaPrincipal        : Textura principal del tajador.
//      TexturaPosterior        : Textura para la zona posterior.
//      TexturaPlaca            : Textura para la placa filosa.
//      TexturaFilo             : Textura para dar la apariencia de filo.
//      TexturaTornillo         : Textura a aplicar al tornillo.
//      TexturaLetra            : Textura a aplicar 
//                                al grabado de propaganda.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare TMEE_TexturaPrincipal
//      Textura principal del tajador.
// #declare TMEE_TexturaPosterior
//      Textura a aplicar a la zona posterior del tajador.
// #declare TMEE_TexturaPlaca
//      Textura a aplicar a la plaquita de dar filo.
// #declare TMEE_TexturaFilo
//      Textura a aplicar para dar la apariencia de filo.
// #declare TMEE_TexturaTornillo
//      Textura a aplicar al tornillo.
// #declare TMEE_TexturaLetra
//      Textura a aplicar al grabado de propaganda.
// #declare TMEE_ConoLapiz
//      Vector 3D para la base del cono interior
//      de la abertura ajustada de lapiz.
// #declare TMEE_PuntaLapiz
//      Vector 3D para la punta del cono interior ajustado del lapiz.
// #declare TMEE_RadioLapiz
//      Radio real interior ajustado del lapiz.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare TMEE_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal del tajador.
// #declare TMEE_DefaultTexturaPosterior        = texture { ... }
//      Textura de la zona posterior del tajador.
// #declare TMEE_DefaultTexturaPlaca            = texture { ... }
//      Textura de la placa cortante.
// #declare TMEE_DefaultTexturaFilo             = texture { ... }
//      Textura para dar la apariencia de filo.
// #declare TMEE_DefaultTexturaTornillo         = texture { ... }
//      Textura a aplicar al tornillo.
// #declare TMEE_DefaultTexturaLetra            = texture { ... }
//      Textura a aplicar a las letras grabadas.
// #declare TMEE_BanderaPropaganda              = on;
//      "on" grabado de propaganda visible, "off" lo elimina.
// #declare TMEE_TextoPropaganda                = "POV-Ray"
//      Texto grabado de propaganda.
// #declare TMEE_FraccionPropaganda             = 0.3;
//      Fraccion de desplazamiento en el plano inclinado, para ubicar
//      el texto de propaganda.
// #declare TMEE_RadioInterno
//      Se aplica si se define como un nuevo valor real para el radio
//      del lapiz.  El radio actual es 3.05*L.
// #declare TMEE_AltoInterno
//      Se aplica si se define como un nuevo alto real 
//      del cono interno del lapiz.  El alto actual es 12.09*L.
//
// Para colocarlo simplemente
// #include "TMEE.inc"
// object        { TMEE_Tajador() }
//
// Otro ejemplo con modificador
// #include "TMEE.inc"
// #declare TMEE_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 TMEE_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      TMEE_Tajador()
// }
//
// Otro ejemplo con macro de texturas
// #include "TMEE.inc"
// #include "textures.inc"
// object             {
//   TMEE_TajadorMetalicoEconomicoEstudiantil
//                ( PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                      PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#declare TMEE_L                 = 0.001;
#include "colors.inc"
#include "textures.inc"

#if ( version < 3.2 )
  #ifndef( TMEE_POV3_1 )
    #declare TMEE_POV3_1        = on;
  #end
#else
  #ifndef( TMEE_POV3_1 )
    #declare TMEE_POV3_1        = off;
  #end    
#end

#declare TMEE_BanderaPropaganda         = on;
#declare TMEE_TextoPropaganda           = "POV-Ray"
#declare TMEE_FraccionPropaganda        = 0.3;

#declare TMEE_TexturaPrincipal                  = texture       {
  pigment               {
    Silver*0.40+GreenCopper*0.20
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.01
  }
  finish                {
    specular            1.0
    roughness           0.01
    metallic
  }
}

#ifndef ( TMEE_DefaultTexturaPrincipal )
  #declare TMEE_DefaultTexturaPrincipal         = texture       {
    TMEE_TexturaPrincipal
  }
#end

#declare TMEE_TexturaPosterior                  = texture       {
  pigment               {
    gradient y
    turbulence          0.1
    triangle_wave
    scale               0.0003
    pigment_map         {
      [ 0 Silver*0.60   ]
      [ 1.0 Silver*0.30 ]
    }
  }
  normal                {
    bumps
    turbulence          0.05
    scale               0.005
  }
  finish                {
    specular            0.5
    roughness           0.1
    metallic
  }
}

#ifndef ( TMEE_DefaultTexturaPosterior )
  #declare TMEE_DefaultTexturaPosterior         = texture       {
    TMEE_TexturaPosterior
  }
#end

#declare TMEE_TexturaPlaca                      = texture       {
  pigment               {
    Silver*0.60
  }
  normal                {
    bumps
    scale               0.01
  }
  finish                {
    specular            0.5
    roughness           0.1
    metallic
  }
}

#ifndef ( TMEE_DefaultTexturaPlaca )
  #declare TMEE_DefaultTexturaPlaca             = texture       {
    TMEE_TexturaPlaca
  }
#end

#declare TMEE_TexturaTornillo                   = texture       {
  average
  texture_map   {
    [ 0.1 Rust ]
    [ 0.9 TMEE_TexturaPlaca ]
  }
}

#ifndef ( TMEE_DefaultTexturaTornillo )
  #declare TMEE_DefaultTexturaTornillo          = texture       {
    TMEE_TexturaTornillo
  }
#end

#declare TMEE_TexturaFilo                       = texture       {
  pigment               {
    Silver*0.90
  }
  normal                {
    gradient            y
    triangle_wave
    scale               0.0001
    rotate              45*z
  }
  finish                {
    specular            0.5
    roughness           0.1
    metallic
  }
}



#ifndef ( TMEE_DefaultTexturaFilo )
  #declare TMEE_DefaultTexturaFilo              = texture       {
    TMEE_TexturaFilo
  }
#end

#declare TMEE_TexturaLetra                      = texture       {
  TMEE_TexturaTornillo
}

#ifndef ( TMEE_DefaultTexturaLetra )
  #declare TMEE_DefaultTexturaLetra             = texture       {
    TMEE_TexturaLetra
  }
#end

#macro TMEE_Tornillo( Radio )
  difference            {
    sphere              {
      0         , 1
    }
    plane               {
      -z        , 0
    }
    box                 {
      <-0.85,-0.2,-0.1>,
      <+0.85,+0.2,-1.5>
      rotate            15*z
    }
    box                 {
      <-0.85,-0.2,-0.1>,
      <+0.85,+0.2,-1.5>
      rotate            90*z
      rotate            15*z
    }
    scale               <Radio,Radio,Radio/2>
  }
#end

#macro TMEE_TajadorMetalicoEconomicoEstudiantil
                ( TexturaPrincipal, TexturaPosterior,
                  TexturaPlaca, TexturaFilo, TexturaTornillo, TexturaLetra )
  #local L                      = TMEE_L;
  #local Alto                   = 18.60*L;
  #local Fondo                  =  7.89*L;
  #local Frente                 = 10.72*L;
  #local RadioInterno           =  3.05*L;
  #ifdef ( TMEE_RadioInterno )
    #local RadioInterno         = TMEE_RadioInterno;
  #end
  #local GruesoPlaca            = 0.170*Fondo/2;
  #local FrenteAmp              = 12.30*L;
  union                         {
    difference                  {
      cylinder                  {
        0.1*Fondo*z             , -Fondo*z              ,
        Alto/2
        translate               Alto/2*y
      }
      box                       {
        <-100*Fondo,-100*Fondo,0>,
        <+100*Fondo,+100*Fondo,+2*Alto>
        texture                 {
          TexturaPosterior
        }
      }
      union                     {
        #local Correccion       = 1.5*Alto;
        #local RCorreccion      = sqrt( Correccion*Correccion+Alto*Alto/4 );
        cylinder                {
          -2*Fondo*z            , 2*Fondo*z     , RCorreccion
          translate             ( Correccion+FrenteAmp/2 )*x
        }
        cylinder                {
          -2*Fondo*z            , 2*Fondo*z     , RCorreccion
          translate             -( Correccion+FrenteAmp/2 )*x
        }
        #local C                = 0;
        #local Angulo           = 5;
        #while ( C < 8 )
          cylinder              {
            -2*Fondo*z          , 2*Fondo*z     , Alto*0.025
            translate           -RCorreccion*x
            #if ( C >= 4 )
              rotate            -Angulo*(-3/2+C-4 )*z
            #else
              rotate            -Angulo*(-3/2+C )*z
            #end
            translate           ( Correccion+FrenteAmp/2 )*x
            #if ( C >= 4 )
              scale             <-1,1,1>
            #end
          }
          #local C              = C+1;
        #end
        translate               Alto/2*y
      }
      union                     {
        box                     {
          <-100*Alto,-100*Alto,0>,
          <100*Alto,100*Alto,-100*Alto>
        }
        box                     {
          <-Frente*0.15,0.10*Alto,+2*GruesoPlaca>,
          <+Frente*0.30,100*Alto,-100*Fondo>
        }
        #if ( TMEE_BanderaPropaganda )
          text                    {
            ttf "timrom.ttf"      TMEE_TextoPropaganda
            GruesoPlaca, 0
            translate             -0.50*GruesoPlaca*z
            rotate                +90*z
            scale                 <0.175*Frente,0.175*Frente,1>
            translate
                -0.22*Frente*x+TMEE_FraccionPropaganda*Alto*y
            texture               {
              TexturaLetra
            }
          }
        #end
        rotate                  10*x
        translate               -Fondo*z
      }
      cylinder                {
        0                     , 0.10*Alto*y        ,
        RadioInterno
        translate               -Fondo/2*z-Frente*0.075*x
      }
      cone                      {
        0.098*Alto*y            , RadioInterno        ,
        #declare TMEE_ConoLapiz   = <-Frente*0.075,0.10*Alto,-Fondo/2>;
        #declare TMEE_RadioLapiz  = RadioInterno;
        #ifdef ( TMEE_AltoInterno )
          #declare TMEE_PuntaLapiz  = TMEE_ConoLapiz+TMEE_AltoInterno*y;
          TMEE_AltoInterno+0.10*Alto*y
        #else
          0.75*Alto*y
          #declare TMEE_PuntaLapiz  = TMEE_ConoLapiz+0.75*Alto*y;
        #end
        0
        translate               -Fondo/2*z-Frente*0.075*x
      }
      cylinder                {
        0                     , 2*Alto*y        ,
        RadioInterno/5
        translate               -Fondo/2*z-Frente*0.075*x
      }
      cylinder                {
        0                     , 2*Alto*y        ,
        RadioInterno/3
        translate               -Fondo/2*z-Frente*0.075*x
        translate               0.60*Alto*y
      }
      texture                   {
        TexturaPrincipal
      }
    }
    union                     {
      difference                {
        box                     {
          <-Frente*0.05,0.10*Alto,+1.5*GruesoPlaca>,
          <+Frente*0.30,0.90*Alto,0*Fondo>
        }
        box                     {
          <-Frente*0.05,0.09*Alto,-GruesoPlaca>,
          <+Frente*0.00,0.91*Alto,0*Fondo>
          rotate        05*y
          texture               {
            TexturaFilo
          }
        }
      }
      cylinder                  {
        -0.5*GruesoPlaca*z      , GruesoPlaca*z ,
        0.05*Frente
        scale                   <1,2,1>
        translate               0.10*Alto*y+0.15*Frente*x
        texture                 {
          TexturaPrincipal
        }
      }
      cylinder                  {
        -0.5*GruesoPlaca*z      , GruesoPlaca*z ,
        0.05*Frente
        scale                   <1,2,1>
        translate               0.90*Alto*y+0.15*Frente*x
        texture                 {
          TexturaPrincipal
        }
      }
      object                    {
        TMEE_Tornillo( 0.075*Frente )
        translate               0.50*Alto*y+0.15*Frente*x
        texture                 {
          TexturaTornillo
        }
      }
      rotate                  10*x
      translate               -Fondo*z+0.5*GruesoPlaca*z
      texture                 {
        TexturaPlaca
      }
    }
    bounded_by         {
      sphere           { 0.5*Alto*y      , 0.7*Alto }
    }
  }
#end

#macro TMEE_Tajador()
  object                {
    TMEE_TajadorMetalicoEconomicoEstudiantil
        ( TMEE_DefaultTexturaPrincipal,
          TMEE_DefaultTexturaPosterior,
          TMEE_DefaultTexturaPlaca, TMEE_DefaultTexturaFilo,
          TMEE_DefaultTexturaTornillo,
          TMEE_DefaultTexturaLetra )
  }
#end
