// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 mayo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// TMEE TajadorMetalicoEconomicoEstudiantil
// El archivo dibuja un tajador corriente,
// lamentablemente es muy poco flexible.
// #macro TMEE_Tajador()
//
// La dimensiones del tajador son :
//      Alto total              = 18.6*L;
//      Fondo                   =  7.9*L;
//      Frente                  = 11.2*L;
// Se dibuja centrado en X sobre el plano XZ, y
// la zona posterior descansando sobre el plano XY.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite modificar las texturas facilmente.
// #macro TMEE_TajadorMetalicoEconomicoEstudiantil
//                ( TexturaPrincipal, TexturaPosterior, TexturaPlaca,
//                  TexturaFilo, TexturaTornillo, TexturaLetra )
//      TexturaPrincipal        : Textura principal del tajador.
//      TexturaPosterior        : Textura para la zona posterior.
//      TexturaPlaca            : Textura para la placa filosa.
//      TexturaFilo             : Textura para dar la apariencia de filo.
//      TexturaTornillo         : Textura a aplicar al tornillo.
//      TexturaLetra            : Textura a aplicar 
//                                al grabado de propaganda.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare TMEE_TexturaPrincipal
//      Textura principal del tajador.
// #declare TMEE_TexturaPosterior
//      Textura a aplicar a la zona posterior del tajador.
// #declare TMEE_TexturaPlaca
//      Textura a aplicar a la plaquita de dar filo.
// #declare TMEE_TexturaFilo
//      Textura a aplicar para dar la apariencia de filo.
// #declare TMEE_TexturaTornillo
//      Textura a aplicar al tornillo.
// #declare TMEE_TexturaLetra
//      Textura a aplicar al grabado de propaganda.
// #declare TMEE_ConoLapiz
//      Vector 3D para la base del cono interior
//      de la abertura ajustada de lapiz.
// #declare TMEE_PuntaLapiz
//      Vector 3D para la punta del cono interior ajustado del lapiz.
// #declare TMEE_RadioLapiz
//      Radio real interior ajustado del lapiz.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TMEE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare TMEE_DefaultTexturaPrincipal        = texture { ... }
//      Textura principal del tajador.
// #declare TMEE_DefaultTexturaPosterior        = texture { ... }
//      Textura de la zona posterior del tajador.
// #declare TMEE_DefaultTexturaPlaca            = texture { ... }
//      Textura de la placa cortante.
// #declare TMEE_DefaultTexturaFilo             = texture { ... }
//      Textura para dar la apariencia de filo.
// #declare TMEE_DefaultTexturaTornillo         = texture { ... }
//      Textura a aplicar al tornillo.
// #declare TMEE_DefaultTexturaLetra            = texture { ... }
//      Textura a aplicar a las letras grabadas.
// #declare TMEE_BanderaPropaganda              = on;
//      "on" grabado de propaganda visible, "off" lo elimina.
// #declare TMEE_TextoPropaganda                = "POV-Ray"
//      Texto grabado de propaganda.
// #declare TMEE_FraccionPropaganda             = 0.3;
//      Fraccion de desplazamiento en el plano inclinado, para ubicar
//      el texto de propaganda.
// #declare TMEE_RadioInterno
//      Se aplica si se define como un nuevo valor real para el radio
//      del lapiz.  El radio actual es 3.05*L.
// #declare TMEE_AltoInterno
//      Se aplica si se define como un nuevo alto real 
//      del cono interno del lapiz.  El alto actual es 12.09*L.
//
// Para colocarlo simplemente
// #include "TMEE.inc"
// object        { TMEE_Tajador() }
//
// Otro ejemplo con modificador
// #include "TMEE.inc"
// #declare TMEE_DefaultTexturaPrincipal        = texture       {
//   average
//   texture_map        {
//     [ 0.5 TMEE_TexturaPrincipal      ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      TMEE_Tajador()
// }
//
// Otro ejemplo con macro de texturas
// #include "TMEE.inc"
// #include "textures.inc"
// object             {
//   TMEE_TajadorMetalicoEconomicoEstudiantil
//                ( PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                      PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#local OjoAbsoluto            = 256;
#local VecesCentroAbsoluto    = 10;
#local L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -5000 >*L
         White
}
background      {
         Gray50
}    

#include "TMEE.inc"

#local   FactorAcercamiento     = 50;

object          {
  TMEE_Tajador()
  translate             -9.30*L*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z
}


