// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 abril 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// MCRE MapaCostaRicaExtendido
// El archivo dibuja un mapa de Costa Rica colegial con
// decorado de relieve enmarcado en madera.
// #macro MCRE_MapaCostaRicaExtendido
//                ( BanderaRelieve, BanderaGif, BanderaVidrio )
//      BanderaRelieve          : on, el mapa tiene relieve
//                                off, un mapa plano
//      BanderaGif              : on, utiliza un dibujo
//                                off, utiliza un indice de mapeo de texturas
//                                se ignora si BanderaRelieve  off
//      BanderaVidrio           : on, dibuja el vidrio
//                                off, no dibuja el vidrio
//
// La dimensiones del cuadro son
//      Largo del marco         = 1000*L
//      Largo sin marco         =  800*L
//      Ancho del marco         =  800*L
//      Ancho sin marco         =  600*L
//      Profundidad Z total     =   58*L
//      Grueso corcho           =    5*L
// El cuadro descansa centrado sobre el plano XY con frente hacia Z-,
// el marco se levanta 5*L sobre el plano debido al corcho posterior.
//
// Puede dibujarse solo el marco con la macro ( se ve el fondo )
// #macro MCRE_Marco( LargoFundamental, AnchoFundamental,
//                ProfundidadFundamental,
//                AnchoMarco, FraccionCorcho,
//                BanderaVidrio, TexturaMarco, TexturaFondo, MaterialVidrio )
//      LargoFundamental        : Largo en X del dibujo.  Default es 800*L.
//      AnchoFundamental        : Largo en Y del dibujo.  Default es 600*L.
//      ProfundidadFundamental  : Dimension basica en Z.  Default es 50*L.
//      AnchoMarco              : Ancho del marco.  Default es 100*L.
//      FraccionCorcho          : Grueso del corcho posterior es
//              FraccionCorcho*ProfundidadFundamental.  Default es 1/20.
//      BanderaVidrio           : on, dibuja el vidrio
//                                off, no dibuja el vidrio
//      TexturaMarco            : Textura a aplicar al marco.
//              Default es MCRE_DefaultTexturaMadera.
//      TexturaFondo            : Textura a aplicar al fondo de corcho.
//              Default es MCRE_DefaultTexturaCorcho.
//      MateriaVidrio           : Material a aplicar al vidrio.
//              Default es MCRE_DefaultMaterialVidrio.
//
// Una macro para incorporar cuadros planos facilmente.
// #macro MCRE_CuadroCorriente
//        ( LargoFundamental, AnchoFundamental, ProfundidadFundamental,
//          AnchoMarco, ImagenFundamental, BanderaVidrio )
//      LargoFundamental        : Largo en X del dibujo.
//      AnchoFundamental        : Largo en Y del dibujo.
//      ProfundidadFundamental  : Dimension basica en Z.
//      AnchoMarco              : Ancho del macro.
//      ImagenFundamental       : Imagen GIF, para el dibujo.
//              Si se desea deberia incluir el borde.
//      BanderaVidrio           : on, dibuja el vidrio
//                                off, no dibuja el vidrio
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare MCRE_TexturaMadera          = Textura del madera.
// #declare MCRE_TexturaCorcho          = Textura del fondo de corcho.
// #declare MCRE_MaterialVidrio         = Material a aplicar al vidrio.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare MCRE_POV3_1                        = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare MCRE_DefaultTexturaMadera          = texture { ... }
//      Textura default a aplicar al marco.
// #declare MCRE_DefaultTexturaCorcho          = texture { ... }
//      Textura default a aplicar al fondo de corcho.
// #declare MCRE_DefaultMaterialVidrio         = material { ... }
//      Material default a aplicar al vidrio.
// #declare MCRE_CurvasNivelGif                = "MCRE_IM1.GIF"
//      Dibujo GIF de relieve.  La version actual, utiliza la siguiente
//      clave en escala de grises;  pero es innecesario atenerse a ella.
//      10      : Nivel del mar
//      9       : Plataforma continental
//      7       : Mar abierto
//      254     : altitud del Cerro Chirripo en Costa Rica
//      Para que un extranjero dibuje su propio pais es suficiente con
//      cambiar este y MCRE_DibujoGIF utilizando BanderaGif on.
// #declare MCRE_DibujoGif                     = "MCRE_IM2.GIF"
//      Dibujo GIF del mapa.  El costarricense que quiera incorporar su
//      propio mapa, deberia cambiar este y utilizar BanderaGif on.
// #declare MCRE_GifPattern                    = "MCRE_IM3.GIF"
//      Para el caso BanderaGif off.  Utiliza una clave de 8 texturas
//      con indice.  Si usted quiere cambiar de pais dibujado,
//      probablemente mejor ignorar este apartado y utilizar BanderaGif on.
//      Nosotros utilizamos XNView.EXE para GIF de ocho colores,
//      pero es probable que tenga
//      problemas en colocar el numero correcto.
//      Siendo pocas las posibilidades, intente por prueba y error.
//      0               : Plataforma continental
//      1               : Segunda zona altitudinal
//      2               : Primera mitad de primera zona altitudinal
//      3               : Agua Profunda
//      4               : Segunda mitad de primera zona altitudinal
//      5               : Cuarta zona altitudinal
//      6               : Tercera zona altitudinal
//      7               : Lagos interiores
// #declare MCRE_ArregloCubic                  = on;
//      El marco se dibuja con un prisma que utiliza interpolacion
//      cubica "on", o lineal "off".
// #declare MCRE_ArregloMarco                  = array [ 10 ]
//      El arreglo contiene los puntos de interpolacion del marco
//      en un cuadrado unitario en XZ desde <0,0> a <1,1>
//      El fondo esta en <0,0> a <1,0>.
//      El vidrio toca el punto <0,1>, que es innecesario si carece de vidrio.
//      Por ejemplo para un marco triangular lineal con vidrio
//      #declare MCRE_ArregloCubic      = off;
//      #declare MCRE_ArregloMarco      = array [3] {<0,0>,<0,1>,<1,0>}
// #declare MCRE_HeightFieldSmooth             = on;
//      Suaviza las aristas del mapa.  El efecto se percibe con la vista,
//      asi que vale la pena, pero alerda el proceso un poco.
//      "on" para aplicar smooth "off" no lo aplica.
//
// Para colocarlo simplemente
// #include "MCRE.inc"
// object        { MCRE_MapaCostaRicaExtendido(on,off,on) }
//
// Otro ejemplo con modificador
// #include "MCRE.inc"
// #declare MCRE_DefaultTexturaMadera           = texture       {
//   average
//   texture_map        {
//     [ 0.5 MCRE_TexturaMadera         ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      MCRE_CuadroCorriente( 0.8, 0.6, 0.05, 0.1, "MCRE_IM2.GIF", off )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50

}


#include "MCRE.INC"

object          {
  MCRE_MapaCostaRicaExtendido( on, off, off )
  translate     -1*z
}
