// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 12 marzo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// PCFU PercoladorCafeFamiliarUso
// El archivo dibuja un percolador de cafe
// en posicion default con la macro
// #macro PCFU_PercoladorCafe( EncendidoApagado, FiltroPresente,
//                CafeteraPresente, Angulo, NivelCafe )
//      EncendidoApagado        : true dibuja el interruptor
//                      en posicion de encendido, false apagado
//      FiltroPresente          : true dibuja el soporte de filtro,
//                      false no lo dibuja
//      CafeteraPresente        : true dibuja la cafetera, false no lo hace
//      Angulo                  : angulo en grados de rotacion de cafetera
//      NivelCafe               : nivel actual del cafe respecto plano XY,
//                      utilice cero, para no dibujar del todo
//                      Sugerencia : 0.050
//
// Las caracteristicas serian
//      Altura cafetera         : 235*L
//      Altura Base             : 25*L
//      Largo Base              : 183*L (-129.5*x, +53.5*x)*L
//      Ancho Base              : 107*L
//      Altura recipiente con tapa      : 100*L
// La base del recipiente con tapa est directamente sobre el origen
// del plano XY, sobre el que descansa la cafetera alineada
// a lo largo del eje X.  Gravedad Y-.
//
// Los elementos de la cafetera puede dibujarse en forma independiente.
// Su posicion por defecto sera identica al dibujo conjunto,
// salvo que se indique lo contrario.
//
// El pichel sin tapa puede dibujarse con
// #macro PCFU_PichelCafe ( Angulo, NivelCafe )
//      Angulo                  : angulo en grados de rotacion de cafetera
//      NivelCafe               : nivel actual del cafe respecto plano XY,
//                      utilice cero, para no dibujar del todo
//                      Sugerencia : 0.050
//
// La tapa del pichel puede dibujarse con
// #macro PCFU_TapaPichelCafe ( Angulo )
//      Angulo                  : angulo en grados de rotacion de cafetera
//
// El soporte del filtro puede dibujarse con
// #macro PCFU_SoporteFiltroCafe()
//
// La base del percolador tambien puede dibujarse con esta
// macro alternativa algo mas complicada
// #macro PCFU_BasePercolador
//      ( AltoPercolador, AnchoPercolador, LargoPercolador,
//                EncendidoApagado,
//                TexturaBase, TexturaCuero, TexturaMetal )
//      AltoPercolador          : referencia para la altura del percolador,
//                      default es 214*L
//      AnchoPercolador         : referencia para el ancho Z del percolador,
//                      default es 107*L
//      LargoPercolador         : referencia para el largo X del percolador,
//                      default es 183*L
//      EncendidoApagado        : on/off se aplican al boton
//      TexturaBase             : textura principal del objeto
//      TexturaCuero            : textura a aplicar a la proteccion de calor
//      TexturaMetal            : textura de la base de calentamiento
//
// El pichel tambien puede dibujarse con la siguiente macro.
// Esta la dibuja sobre el plano XY y sin rotacion ni cafe
// #macro PCFU_Pichel( AnchoPercolador, AltoPercolador,
//                TexturaTransparente, TexturaAgarradera, TexturaMetal )
//      AnchoPercolador         : corresponde a AnchoPercolador
//                      en la macro PCFU_BasePercolador
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      TexturaTransparente     : textura principal del pichel
//      TexturaAgarradera       : textura a aplicar a la agarradera
//      TexturaMetal            : textura de la placa de metal
//                      que rodea la cafetera
//
// Dibuja la tapa correspondiente a la macro
// PCFU_Pichel, en posicion correcta respecto a dicha macro
// PCFU_Pichel, es decir el pichel sobre el plano XY y sin rotacion
// #macro PCFU_TapaPichel( AnchoPercolador, AltoPercolador,
//                        TexturaTapa )
//      AnchoPercolador         : corresponde a AnchoPercolador
//                      en la macro PCFU_BasePercolador
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      TexturaTapa             : textura a aplicar a la tapa
//
// Dibuja el soporte de filtro con cilindro centrado sobre el plano XY
// a una altura de 138/214*AltoPercolador, y la agarradera hacia X+
// #macro PCFU_SoporteFiltro( AltoPercolador,
//          AnchoPercolador, LargoPercolador, TexturaBase )
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      AnchoPercolador         : corresponde a AnchoPercolador
//                      en la macro PCFU_BasePercolador
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      TexturaBase             : textura a aplicar al soporte
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare PCFU_VolumenCafe            = Sirve para agregar cafe
//      al pichel.  Se genera automaticamente con las macros de Pichel
//      intersection { object { PCFU_VolumenCafe } object{ ... } }
// #declare PCFU_TexturaBase            = texture { ... }
//      Textura a aplicar a la base principal del objeto
// #declare PCFU_TexturaTransparente    = texture { ... }
//      Textura a aplicar al pichel
// #declare PCFU_TexturaTapa            = texture { ... }
//      Textura a aplicar a la tapa del pichel
// #declare PCFU_TexturaAgarradera      = texture { ... }
//      Textura a aplicar a la agarradera del pichel
// #declare PCFU_TexturaCuero           = texture { ... }
//      Textura a aplicar a la proteccion de calor de la base
// #declare PCFU_TexturaMetal           = texture { ... }
//      Textura a aplicar a zonas metalizadas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare PCFU_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare PCFU_DefaultTexturaBase            = texture { ... }
//      Textura a aplicar a la base principal del objeto
// #declare PCFU_DefaultTexturaTransparente    = texture { ... }
//      Textura a aplicar al pichel
// #declare PCFU_DefaultTexturaTapa            = texture { ... }
//      Textura a aplicar a la tapa del pichel
// #declare PCFU_DefaultTexturaAgarradera      = texture { ... }
//      Textura a aplicar a la agarradera del pichel
// #declare PCFU_DefaultTexturaCuero           = texture { ... }
//      Textura a aplicar a la proteccion de calor de la base
// #declare PCFU_DefaultTexturaMetal           = texture { ... }
//      Textura a aplicar a zonas metalizadas
// #declare PCFU_DefaultTexturaRoja            = texture { ... }
//      Textura a aplicar al indicador rojo del boton
// #declare PCFU_DefaultTexturaGris            = texture { ... }
//      Textura a aplicar al indicaror oscuro del boton
//
// Para colocarlo simplemente
// #include "PCFU.inc"
// object        { PCFU_PercoladorCafe( on, on, on, 0, 0.050 ) }
//
// Otro ejemplo con modificador
// #include "PCFU.inc"
// #declare PCFU_DefaultTexturaBase             = texture       {
//   PinkAlabaster
// }
// #declare PCFU_DefaultTexturaTransparente     = texture       {
//   average
//   texture_map        {
//     [ 0.5 PCFU_TexturaTransparente   ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// union                {
//   object        { PCFU_PercoladorCafe( on, on, on, 0, 0.0 ) }
//   intersection       {
//     cylinder { 0, 20*L*y, 100*L }
//     object   { PCFU_VolumenCafe }
//     pigment  { Orange           }
//   }
// }
//

#include "colors.inc"
#include "metals.inc"

#declare PCFU_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( PCFU_POV3_1 )
    #declare PCFU_POV3_1        = on;
  #end
#else
  #ifndef( PCFU_POV3_1 )
    #declare PCFU_POV3_1        = off;
  #end
#end

#declare PCFU_TexturaBase       = texture       {
  pigment               {
    Quartz
  }
  normal                {
    bumps
  }
}

#ifndef ( PCFU_DefaultTexturaBase )
  #declare PCFU_DefaultTexturaBase      = texture       {
    PCFU_TexturaBase
  }
#end

#declare PCFU_TexturaCuero       = texture       {
  pigment               {
    Mica
  }
  normal                {
    bumps
  }
}

#ifndef ( PCFU_DefaultTexturaCuero )
  #declare PCFU_DefaultTexturaCuero      = texture       {
    PCFU_TexturaCuero
  }
#end

#declare PCFU_TexturaMetal       =
texture       {
  T_Silver_1E
  normal                {
    agate
    scale       0.02
  }
}
texture                 {
  pigment { MediumWood transmit 0.05 }
}

#ifndef ( PCFU_DefaultTexturaMetal )
  #declare PCFU_DefaultTexturaMetal      = texture       {
    PCFU_TexturaMetal
  }
#end

#declare PCFU_TexturaTransparente       = texture       {
  pigment               {
    rgbt        < 0.8, 1.0, 0.8, 0.8 >
  }
}

#ifndef ( PCFU_DefaultTexturaTransparente )
  #declare PCFU_DefaultTexturaTransparente      = texture       {
    PCFU_TexturaTransparente
  }
#end

#declare PCFU_TexturaAgarradera         = texture       {
  pigment               {
    VeryDarkBrown
  }
}

#ifndef ( PCFU_DefaultTexturaAgarradera   )
  #declare PCFU_DefaultTexturaAgarradera        = texture       {
    PCFU_TexturaAgarradera
  }
#end

#declare PCFU_TexturaTapa               = texture       {
  pigment               {
    VeryDarkBrown
  }
}

#ifndef ( PCFU_DefaultTexturaTapa )
  #declare PCFU_DefaultTexturaTapa              = texture       {
    PCFU_TexturaTapa
  }
#end    

#ifndef ( PCFU_DefaultTexturaRoja )             
  #declare PCFU_DefaultTexturaRoja              = texture       {
    pigment       {
      Red
    }
  }         
#end

#ifndef ( PCFU_DefaultTexturaGris )             
  #declare PCFU_DefaultTexturaGris              = texture       {
    pigment       {
      Gray70
    }
  }         
#end

#macro PCFU_Pichel( AnchoPercolador, AltoPercolador,
                TexturaTransparente, TexturaAgarradera, TexturaMetal )
  #local Diametro               = 0.8*AnchoPercolador;
  #local Alto                   = 0.4*AltoPercolador;
  merge         {
    #declare PCFU_VolumenCafe   = difference    {
      cylinder          {
        0               , Alto*0.9*y        ,
        Diametro/2*0.98
      }
      cylinder          {
        0               , 0.035*Alto*y
        Diametro/2
      }
    }
    difference          {
      difference        {
        cylinder          {
          0               , Alto*y        ,
          Diametro
        }
        cylinder          {
          0.03*Alto*y     , 1.01*Alto*y   ,
          Diametro/2
        }
        superellipsoid      {
          < 1.0,0.1 >
          scale     <0.5,1.0,0.4>*Alto/3
          rotate            -20*x
          translate         Alto*y-Diametro/2*z
        }
        plane             {
          -y              , 0
          rotate          -35*x
          translate       Alto*y-Diametro/2*z
        }
      }
      difference        {
        cylinder          {
          0               , Alto*y        ,
          Diametro
        }
        cylinder          {
          0.03*Alto*y     , 1.01*Alto*y   ,
          Diametro/2
        }
        superellipsoid      {
          < 1.0,0.1 >
          scale     <0.5,1.0,0.4>*Alto/3
          rotate            -20*x
          translate         Alto*y-Diametro/2*z
        }
        plane             {
          -y              , 0
          rotate          -35*x
          translate       Alto*y-Diametro/2*z
        }
        scale     1.04
        translate -1.04*0.03*Alto*y
      }
    }
    difference          {
      torus             {
        1.04*Diametro/2 , 0.01*Diametro
        translate       0.95*Alto*y
      }
      superellipsoid      {
        < 1.0,0.1 >
        scale     <0.5,1.0,0.4>*Alto/3
        rotate            -20*x
        translate         Alto*y-Diametro/2*z
      }
      torus             {
        Alto/2          , 0.9*Alto/5
        rotate          90*z
        scale             <1,1.2,0.5>
        translate         Alto/2*y+Diametro/2*z
        translate         -Diametro/2*z
        rotate            10*x
        translate         +Diametro/2*z
      }
    }
    difference          {
      difference          {
        torus             {
          Alto/2          , Alto/5
          rotate          90*z
          scale             <1,1.2,0.5>
          translate         Alto/2*y+Diametro/2*z
        }
        torus             {
          Alto/2          , 0.9*Alto/5
          rotate          90*z
          scale             <1,1.2,0.5>
          translate         Alto/2*y+Diametro/2*z
        }
        difference        {
          cylinder        {
            -Alto/2*x     , Alto/2*x      ,
            Alto
          }
          cylinder        {
            -Alto*x       , Alto*x        ,
            Alto/2
          }
          scale         <1,1.2,0.5>
          translate       Alto/2*y+Diametro/2*z
        }
        translate         -Diametro/2*z
        rotate            10*x
        translate         +Diametro/2*z
      }
      cylinder          {
        0               , 2*Alto*y      ,
        Diametro/2
      }
      scale             <1,0.7,1>
      translate         0.3*Alto*y
      texture           {
        TexturaAgarradera
      }
    }
    difference          {
      cylinder          {
        0.50*Alto*y,        0.65*Alto*y,
        Diametro*1.02*0.525
      }
      cylinder          {
        0.49*Alto*y,        0.66*Alto*y,
        Diametro*1.01*0.525
      }
      translate         -0.50*Alto*y
      rotate            0.5
      translate         +0.50*Alto*y
      texture           {
        TexturaMetal
      }
    }
    rotate              90*y
    texture             {
      TexturaTransparente
    }
  }
#end

#macro PCFU_TapaPichel( AnchoPercolador, AltoPercolador,
                        TexturaTapa )
  #local Diametro               = 0.8*AnchoPercolador;
  #local Alto                   = 0.4*AltoPercolador;
  merge         {
    difference          {
      superellipsoid    {
        < 0.8, 1.0 >
        scale           <Diametro/2,Alto/6,Diametro/2>*1.04
      }
      superellipsoid    {
        < 0.8, 1.0 >
        scale           <Diametro/2,Alto/7,Diametro/2>
      }
      cylinder          {
        0               , Alto/3*y      ,
        Diametro/4
      }
      plane             {
        y               , 0
      }
    }
    difference          {
      sphere            {
        0               , Diametro/4*1.04
      }
      sphere            {
        0               , Diametro/4
      }
      plane             {
        -y               , 0
      }
      cylinder          {
        Alto*y          , -Alto*y               ,
        Diametro/30
      }
      #local C          = 0;
      #while ( C < 24 )
        cylinder          {
          Alto*y          , -Alto*y               ,
          Diametro/200
          translate     Diametro/16*x
          rotate        15*y*C
        }      
        #local C        = C+1;
      #end
      #local C          = 0;
      #while ( C < 48 )
        cylinder          {
          Alto*y          , -Alto*y               ,
          Diametro/200
          translate     Diametro/8*x
          rotate        7.5*y*C
        }      
        #local C        = C+1;
      #end
      scale             <1,0.03,1>
      translate         Alto*0.15*y
    }
    difference          {
      cylinder          {
        0               , -0.03*Alto*y  ,
        Diametro/2
        scale   <1.08,1.0,1.08>
      }
      cylinder          {
        -0.015*Alto*y   , -0.04*Alto*y  ,
        Diametro/2
        scale   <1.04,1.0,1.04>
      }
      cylinder          {
        0.1*Alto*y      , -0.04*Alto*y  ,
        Diametro/2
      }
    }
    translate           1.015*Alto*y
    texture             {
      TexturaTapa
    }
  }
#end

#macro PCFU_SoporteFiltro( AltoPercolador,
        AnchoPercolador, LargoPercolador, TexturaBase )
  #local L                      = PCFU_L;
  #local RadioFrente            = AnchoPercolador/2;
  #local RadioDecorativo        = 2/107*AltoPercolador;//
  #local AltoTecho              = 196/214*AltoPercolador;
  // nuevos datos
  #local AltoFiltro             = 58/214*AltoPercolador;
  #local RadioFiltro            = 48.6/107*AnchoPercolador;
  #local PuntoFiltro            = < RadioFiltro, AltoFiltro >;
  union                         {
    lathe                       {
      linear_spline
      6,
      < 0.12    , 0     >*PuntoFiltro,
      < 0.12    , 0.035 >*PuntoFiltro,
      < 0.734   , 0.064 >*PuntoFiltro,
      < 0.850   , 0.94  >*PuntoFiltro,
      < 0.860   , 0.99  >*PuntoFiltro,
      < 1.0     , 1.0   >*PuntoFiltro
    }
    #local C                    = 0;
    #while ( C < 12 )
      box                       {
        < 0.150*RadioFiltro, 0.070*AltoFiltro, -0.005*RadioFiltro >,
        < 0.700*RadioFiltro, 0.090*AltoFiltro, +0.005*RadioFiltro >
        rotate          C*30*y
      }
      #local C                  = C+1;
    #end
    difference                  {
      #local PuntoFiltro2       = < PuntoFiltro.y, PuntoFiltro.x >;
      prism                     {
        cubic_spline
        -0.1*RadioFiltro,
        +0.1*RadioFiltro,
        11,
        < 0.86, 1.0  >*PuntoFiltro,
        < 1.0 , 1.0  >*PuntoFiltro,
        < 1.3 , 0.90 >*PuntoFiltro,
        < 1.4 , 0.25 >*PuntoFiltro,
        < 1.3 , 0.35 >*PuntoFiltro,
        < 1.2 , 0.8  >*PuntoFiltro,
        < 0.83, 0.82 >*PuntoFiltro,
        < 0.85, 0.94 >*PuntoFiltro,
        < 0.86, 1.0  >*PuntoFiltro,
        < 1.0 , 1.0  >*PuntoFiltro,
        < 1.4 , 0.95 >*PuntoFiltro
        rotate          -90*x
      }
      prism                     {
        cubic_spline
        -0.1*RadioFiltro,
        +0.1*RadioFiltro,
        11,
        < 0.86, 1.0  >*PuntoFiltro,
        < 1.0 , 1.0  >*PuntoFiltro,
        < 1.3 , 0.90 >*PuntoFiltro,
        < 1.4 , 0.25 >*PuntoFiltro,
        < 1.3 , 0.35 >*PuntoFiltro,
        < 1.2 , 0.8  >*PuntoFiltro,
        < 0.83, 0.82 >*PuntoFiltro,
        < 0.85, 0.94 >*PuntoFiltro,
        < 0.86, 1.0  >*PuntoFiltro,
        < 1.0 , 1.0  >*PuntoFiltro,
        < 1.4 , 0.95 >*PuntoFiltro
        scale           0.95
        rotate          -90*x
      }
    }
    difference                  {
      cylinder                  {
        AltoFiltro*y    , AltoFiltro*y-0.10*AltoFiltro*y,
        1.025*RadioFiltro
      }
      cylinder                  {
        1.2*AltoFiltro*y    , AltoFiltro*y-0.15*AltoFiltro*y,
        0.975*RadioFiltro
      }
      plane                     {
        x , 0
      }
    }
    translate   ( AltoTecho-AltoFiltro )*y
    texture                     {
      TexturaBase
    }
  }
#end

#macro PCFU_BasePercolador( AltoPercolador, AnchoPercolador, LargoPercolador,
                EncendidoApagado,
                TexturaBase, TexturaCuero, TexturaMetal )
  #local L                      = PCFU_L;
  #local RadioFrente            = AnchoPercolador/2;
  #local RadioDecorativo        = 2/214*AltoPercolador;//
  #local SoporteGrueso          =
        LargoPercolador-AnchoPercolador-10/107*AnchoPercolador;
  #local BasePercolador         = 25/214*AltoPercolador;
  #local AltoTecho              = 196/214*AltoPercolador;
  #local MedioTronco            = 91.5/214*AltoPercolador;
  #macro PCFU_BaseFundamental( BaseBase )
    union               {
      cylinder            {
        0                 , ( BaseBase-RadioDecorativo )*y  ,
        RadioFrente
      }
      box               {
        < -( LargoPercolador- RadioFrente-RadioDecorativo ),
                0       , -RadioFrente >,
        < 0, BaseBase-RadioDecorativo, RadioFrente >
      }
      box               {
        < -( LargoPercolador-RadioFrente ),
                0       , -( RadioFrente-RadioDecorativo )      >,
        < 0, BaseBase, RadioFrente-RadioDecorativo >
      }
      cylinder            {
        0                 , BaseBase*y            ,
        RadioFrente-RadioDecorativo
      }
      torus             {
        RadioFrente-RadioDecorativo     , RadioDecorativo
        translate       ( BaseBase-RadioDecorativo )*y
      }
      union             {
        cylinder          {
          0               , BaseBase*y, RadioDecorativo
        }
        cylinder        {
          ( BaseBase-RadioDecorativo )*y      ,
          ( BaseBase-RadioDecorativo )*y
          +( LargoPercolador-RadioFrente-RadioDecorativo )*x,
          RadioDecorativo
        }
        translate -( LargoPercolador-RadioFrente-RadioDecorativo )*x
                  -( RadioFrente-RadioDecorativo )*z
      }
      union             {
        cylinder          {
          0               , BaseBase*y, RadioDecorativo
        }
        cylinder        {
          ( BaseBase-RadioDecorativo )*y      ,
          ( BaseBase-RadioDecorativo )*y
          +( LargoPercolador-RadioFrente-RadioDecorativo )*x,
          RadioDecorativo
        }
        translate -( LargoPercolador-RadioFrente-RadioDecorativo )*x
                  +( RadioFrente-RadioDecorativo )*z
      }
      texture           {
        TexturaBase
      }
    }
  #end
  
  #macro PCFU_Boton()
    union                       {    
      superellipsoid            {
        < 0.2, 0.2 >
        scale           < 0.15, 0.075, 0.01 >*SoporteGrueso
      }
      difference                {
        cylinder                {
          -0.050*SoporteGrueso*y*0.99,
          +0.050*SoporteGrueso*y*0.99       ,
          0.11*SoporteGrueso*0.99
        }
        plane                   {
          z                     , 0
          translate             -0.012*SoporteGrueso*z
        }
        #if ( EncendidoApagado )
          rotate          -30*y
        #end
        texture                 {
          PCFU_DefaultTexturaRoja
        }
      }
      difference                {
        cylinder                {
          -0.050*SoporteGrueso*y, +0.050*SoporteGrueso*y        ,
          0.11*SoporteGrueso
        }
        plane                   {
          z                     , 0
          translate             -0.012*SoporteGrueso*z
          rotate                30*y
        }
        #if ( EncendidoApagado )
          rotate          -30*y
        #end
        texture                 {
          PCFU_DefaultTexturaGris
        }
      }
      texture           {
        TexturaCuero
      }
    }
  #end
  
  #macro PCFU_TroncoFundamental( Boton, BaseBase, AltoTronco )
    #local TF1          = < -( LargoPercolador-RadioFrente-RadioDecorativo ),
                 ( BaseBase-RadioDecorativo ),
                 -( RadioFrente-RadioDecorativo ) >;
    #local TF2          = < -( LargoPercolador-RadioFrente-SoporteGrueso ),
                 ( BaseBase-RadioDecorativo ),
                 -( RadioFrente-RadioDecorativo ) >;
    #local TF3          = < TF2.x, TF2.y, -TF1.z >;
    #local TF4          = < TF1.x, TF1.y, -TF1.z >;
    #local DesplazarTF  = 2*< RadioDecorativo,0,RadioDecorativo >;
    #local AltoTronco2  = AltoTronco-RadioDecorativo/2;
    #local TT1          = < TF1.x, AltoTronco2, TF1.z >+DesplazarTF;
    #local TT2          = < TF2.x, AltoTronco2, TF2.z >+DesplazarTF*<-1,0,1>;
    #local TT3          = < TF3.x, AltoTronco2, TF3.z >-DesplazarTF;
    #local TT4          = < TF4.x, AltoTronco2, TF4.z >+DesplazarTF*<1,0,-1>;
    union             {
      cylinder        {
        TF1, TT1, RadioDecorativo
      }
      polygon         {
        5,
        TF1, TF2, TT2, TT1, TF1
      }
      cylinder        {
        TF2, TT2, RadioDecorativo
      }
      polygon         {
        5,
        TF2, TF3, TT3, TT2, TF2
      }
      cylinder        {
        TF3, TT3, RadioDecorativo
      }
      polygon         {
        5,
        TF3, TF4, TT4, TT3, TF3
      }
      cylinder        {
        TF4, TT4, RadioDecorativo
      }
      polygon         {
        5,
        TF4, TF1, TT1, TT4, TF4
      }
      box             {
        TT1+DesplazarTF, TT3+RadioDecorativo*y-DesplazarTF
      }
      #if ( Boton )
        object              {
          PCFU_Boton()
          rotate          degrees( atan2( abs( TT2.z-TF1.z ),
                                      abs( TT2.y-TF1.y ) ) )*x
          translate         ( TF1+TT2 )/2
        }
      #end
      texture           {
          TexturaBase
      }
    }
  #end
  
  union                 {
    object              {
      PCFU_BaseFundamental( BasePercolador )
    }
    difference          {
      object              {
        PCFU_BaseFundamental( AltoPercolador-AltoTecho )
        rotate            180*x
        translate         AltoPercolador*y
      }
      sphere            {
        0, 0.1*RadioFrente
        scale   <1,0.1,1>
        translate       AltoTecho*y
        pigment {
          Black
        }
      }
      #local C          = 0;
      #while ( C < 6 )
        sphere            {
          0, 0.1*RadioFrente
          scale   <1,0.1,1>*0.2
          translate       AltoTecho*y
          translate     0.2*RadioFrente*x
          rotate        60*C*y
          pigment {
            Black
          }
        }
        #local C        = C+1;
      #end
      #local C          = 0;
      #while ( C < 12 )
        sphere            {
          0, 0.1*RadioFrente
          scale   <1,0.1,1>*0.2
          translate       AltoTecho*y
          translate     0.5*RadioFrente*x
          rotate        30*C*y
          rotate        5*y
          pigment {
            Black
          }
        }
        #local C        = C+1;
      #end
    }
    difference          {
      object              {
        PCFU_BaseFundamental( 1/4*( AltoPercolador-AltoTecho ) )
        translate         AltoPercolador*y
      }
      superellipsoid    {
        < 0.2, 0.2 >
        scale           < 0.15, 0.03, 0.85 >*
                < LargoPercolador, AltoTecho, RadioFrente >
        translate       -LargoPercolador*x*0.5
        translate       AltoPercolador*y+1/4*( AltoPercolador-AltoTecho )*y
      }
    }
    difference          {
      superellipsoid    {
        < 0.2, 0.2 >
        scale           < 0.15, 0.03, 0.85 >*
                < LargoPercolador, AltoTecho, RadioFrente >*0.98
        translate       -LargoPercolador*x*0.5
        translate       AltoPercolador*y+1/4*( AltoPercolador-AltoTecho )*y
      }
      plane             {
        -y, 0
        translate       AltoPercolador*y+1/4*( AltoPercolador-AltoTecho )*y
      }
      texture           {
        TexturaBase
      }
    }
    object              {
      PCFU_BaseFundamental( 1/8*( AltoPercolador-AltoTecho ) )
      scale             <1.02,1,1.02>
      translate
        ( AltoPercolador-1/16*( AltoPercolador-AltoTecho ) )*y
    }
    object              {
      PCFU_TroncoFundamental( on, BasePercolador, MedioTronco )
    }
    object              {
      PCFU_TroncoFundamental
                ( off, AltoPercolador-AltoTecho, AltoPercolador-MedioTronco )
      rotate            180*x
      translate         AltoPercolador*y
    }
    difference          {
      cylinder            {
        AltoPercolador*y  ,
        AltoTecho*y,
        0.95*RadioFrente
        translate       -0.2*( AltoPercolador-AltoTecho )*y
      }
      cylinder            {
        AltoPercolador*y  ,
        AltoTecho*y,
        0.95*RadioFrente
        scale           <0.975,1,0.975>
        translate       -0.3*( AltoPercolador-AltoTecho )*y
      }
      plane               {
        -x, 0
      }
      texture           {
        TexturaBase
      }
    }
    torus               {
      0.95*RadioFrente, 0.03*RadioFrente
      scale             <1,1,1>
      translate         BasePercolador*y
      texture           {
        TexturaCuero
      }
    }
    torus               {
      0.925*RadioFrente, 0.03*RadioFrente
      scale             <1,1,1>
      translate         BasePercolador*y
      texture           {
        TexturaMetal
      }
    }
    cylinder            {
      0                 , 0.05*RadioDecorativo*y ,
      0.925*RadioFrente
      translate         BasePercolador*y
      texture           {
        TexturaMetal
      }
    }
  }
#end

#macro PCFU_PercoladorCafe( EncendidoApagado, FiltroPresente,
                CafeteraPresente, Angulo, NivelCafe )
  #local L                      = PCFU_L;
  #local AltoPercolador         = 214*L;//
  #local AnchoPercolador        = 107*L;//
  #local LargoPercolador        = 183*L;//
  union                 {
    object              {
      PCFU_BasePercolador( AltoPercolador, AnchoPercolador, LargoPercolador,
        EncendidoApagado,
        PCFU_DefaultTexturaBase, PCFU_DefaultTexturaCuero,
        PCFU_DefaultTexturaMetal )
    }
    #if ( FiltroPresente )
      object              {
        PCFU_SoporteFiltro( AltoPercolador, AnchoPercolador, LargoPercolador,
                  PCFU_DefaultTexturaBase )
      }
    #end
    #if ( CafeteraPresente )
      object              {
        PCFU_Pichel( AnchoPercolador, AltoPercolador,
          PCFU_DefaultTexturaTransparente, PCFU_DefaultTexturaAgarradera,
          PCFU_DefaultTexturaMetal )
        translate         25/214*AltoPercolador*y
        rotate            Angulo*y
      }
      object              {
        PCFU_TapaPichel( AnchoPercolador, AltoPercolador,
          PCFU_DefaultTexturaTapa )
        translate         25/214*AltoPercolador*y
        rotate            Angulo*y
      }
      #declare PCFU_VolumenCafe   = difference    {
        #local Diametro           = 0.8*AnchoPercolador;
        #local Alto               = 0.4*AltoPercolador;
        cylinder          {
          0               , Alto*0.9*y        ,
          Diametro/2*0.98
        }
        cylinder          {
          0               , 0.035*Alto*y
          Diametro/2
        }
        translate         25/214*AltoPercolador*y
      }
      #if ( NivelCafe > 0 )
        intersection  {
          cylinder    {
            0         , NivelCafe*y, 1
            pigment   {
              agate
              scale   0.01
              pigment_map     {
                [ 0.95 color Brown transmit 0.4 ]
                [ 0.05 color Yellow filter  0.4 ]
              }
            }
            normal    {
              waves
              scale   0.05
            }
          }
          object      {
            PCFU_VolumenCafe
          }
        }
      #end
    #end
  }
#end

#macro PCFU_PichelCafe ( Angulo, NivelCafe )
  #local L                      = PCFU_L;
  #local AltoPercolador         = 214*L;//
  #local AnchoPercolador        = 107*L;//
  #local LargoPercolador        = 183*L;//
  union                 {
    object              {
      PCFU_Pichel( AnchoPercolador, AltoPercolador,
        PCFU_DefaultTexturaTransparente, PCFU_DefaultTexturaAgarradera,
        PCFU_DefaultTexturaMetal )
      translate         25/214*AltoPercolador*y
      rotate            Angulo*y
      #declare PCFU_VolumenCafe   = difference    {
        #local Diametro           = 0.8*AnchoPercolador;
        #local Alto               = 0.4*AltoPercolador;
        cylinder          {
          0               , Alto*0.9*y        ,
          Diametro/2*0.98
        }
        cylinder          {
          0               , 0.035*Alto*y
          Diametro/2
        }
        translate         25/214*AltoPercolador*y
      }
    }
    #if ( NivelCafe > 0 )
      intersection  {
        cylinder    {
          0         , NivelCafe*y, 1
          pigment   {
            agate
            scale   0.01
            pigment_map     {
              [ 0.95 color Brown transmit 0.4 ]
              [ 0.05 color Yellow filter  0.4 ]
            }
          }
          normal    {
            waves
            scale   0.05
          }
        }
        object      {
          PCFU_VolumenCafe
        }
      }
    #end
  }
#end

#macro PCFU_TapaPichelCafe ( Angulo )
  #local L                      = PCFU_L;
  #local AltoPercolador         = 214*L;//
  #local AnchoPercolador        = 107*L;//
  #local LargoPercolador        = 183*L;//
  object              {
    PCFU_TapaPichel( AnchoPercolador, AltoPercolador,
      PCFU_DefaultTexturaTapa )
    translate         25/214*AltoPercolador*y
    rotate            Angulo*y
  }
#end

#macro PCFU_SoporteFiltroCafe()
  #local L                      = PCFU_L;
  #local AltoPercolador         = 214*L;//
  #local AnchoPercolador        = 107*L;//
  #local LargoPercolador        = 183*L;//
  object              {
    PCFU_SoporteFiltro( AltoPercolador, AnchoPercolador, LargoPercolador,
              PCFU_DefaultTexturaBase )
  }
#end


