// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 12 marzo 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// PCFU PercoladorCafeFamiliarUso
// El archivo dibuja un percolador de cafe
// en posicion default con la macro
// #macro PCFU_PercoladorCafe( EncendidoApagado, FiltroPresente,
//                CafeteraPresente, Angulo, NivelCafe )
//      EncendidoApagado        : true dibuja el interruptor
//                      en posicion de encendido, false apagado
//      FiltroPresente          : true dibuja el soporte de filtro,
//                      false no lo dibuja
//      CafeteraPresente        : true dibuja la cafetera, false no lo hace
//      Angulo                  : angulo en grados de rotacion de cafetera
//      NivelCafe               : nivel actual del cafe respecto plano XY,
//                      utilice cero, para no dibujar del todo
//                      Sugerencia : 0.050
//
// Las caracteristicas serian
//      Altura cafetera         : 235*L
//      Altura Base             : 25*L
//      Largo Base              : 183*L (-129.5*x, +53.5*x)*L
//      Ancho Base              : 107*L
//      Altura recipiente con tapa      : 100*L
// La base del recipiente con tapa est directamente sobre el origen
// del plano XY, sobre el que descansa la cafetera alineada
// a lo largo del eje X.  Gravedad Y-.
//
// Los elementos de la cafetera puede dibujarse en forma independiente.
// Su posicion por defecto sera identica al dibujo conjunto,
// salvo que se indique lo contrario.
//
// El pichel sin tapa puede dibujarse con
// #macro PCFU_PichelCafe ( Angulo, NivelCafe )
//      Angulo                  : angulo en grados de rotacion de cafetera
//      NivelCafe               : nivel actual del cafe respecto plano XY,
//                      utilice cero, para no dibujar del todo
//                      Sugerencia : 0.050
//
// La tapa del pichel puede dibujarse con
// #macro PCFU_TapaPichelCafe ( Angulo )
//      Angulo                  : angulo en grados de rotacion de cafetera
//
// El soporte del filtro puede dibujarse con
// #macro PCFU_SoporteFiltroCafe()
//
// La base del percolador tambien puede dibujarse con esta
// macro alternativa algo mas complicada
// #macro PCFU_BasePercolador
//      ( AltoPercolador, AnchoPercolador, LargoPercolador,
//                EncendidoApagado,
//                TexturaBase, TexturaCuero, TexturaMetal )
//      AltoPercolador          : referencia para la altura del percolador,
//                      default es 214*L
//      AnchoPercolador         : referencia para el ancho Z del percolador,
//                      default es 107*L
//      LargoPercolador         : referencia para el largo X del percolador,
//                      default es 183*L
//      EncendidoApagado        : on/off se aplican al boton
//      TexturaBase             : textura principal del objeto
//      TexturaCuero            : textura a aplicar a la proteccion de calor
//      TexturaMetal            : textura de la base de calentamiento
//
// El pichel tambien puede dibujarse con la siguiente macro.
// Esta la dibuja sobre el plano XY y sin rotacion ni cafe
// #macro PCFU_Pichel( AnchoPercolador, AltoPercolador,
//                TexturaTransparente, TexturaAgarradera, TexturaMetal )
//      AnchoPercolador         : corresponde a AnchoPercolador
//                      en la macro PCFU_BasePercolador
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      TexturaTransparente     : textura principal del pichel
//      TexturaAgarradera       : textura a aplicar a la agarradera
//      TexturaMetal            : textura de la placa de metal
//                      que rodea la cafetera
//
// Dibuja la tapa correspondiente a la macro
// PCFU_Pichel, en posicion correcta respecto a dicha macro
// PCFU_Pichel, es decir el pichel sobre el plano XY y sin rotacion
// #macro PCFU_TapaPichel( AnchoPercolador, AltoPercolador,
//                        TexturaTapa )
//      AnchoPercolador         : corresponde a AnchoPercolador
//                      en la macro PCFU_BasePercolador
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      TexturaTapa             : textura a aplicar a la tapa
//
// Dibuja el soporte de filtro con cilindro centrado sobre el plano XY
// a una altura de 138/214*AltoPercolador, y la agarradera hacia X+
// #macro PCFU_SoporteFiltro( AltoPercolador,
//          AnchoPercolador, LargoPercolador, TexturaBase )
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      AnchoPercolador         : corresponde a AnchoPercolador
//                      en la macro PCFU_BasePercolador
//      AltoPercolador          : corresponde a AltoPercolador
//                      en la macro PCFU_BasePercolador
//      TexturaBase             : textura a aplicar al soporte
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare PCFU_VolumenCafe            = Sirve para agregar cafe
//      al pichel.  Se genera automaticamente con las macros de Pichel
//      intersection { object { PCFU_VolumenCafe } object{ ... } }
// #declare PCFU_TexturaBase            = texture { ... }
//      Textura a aplicar a la base principal del objeto
// #declare PCFU_TexturaTransparente    = texture { ... }
//      Textura a aplicar al pichel
// #declare PCFU_TexturaTapa            = texture { ... }
//      Textura a aplicar a la tapa del pichel
// #declare PCFU_TexturaAgarradera      = texture { ... }
//      Textura a aplicar a la agarradera del pichel
// #declare PCFU_TexturaCuero           = texture { ... }
//      Textura a aplicar a la proteccion de calor de la base
// #declare PCFU_TexturaMetal           = texture { ... }
//      Textura a aplicar a zonas metalizadas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare PCFU_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare PCFU_DefaultTexturaBase            = texture { ... }
//      Textura a aplicar a la base principal del objeto
// #declare PCFU_DefaultTexturaTransparente    = texture { ... }
//      Textura a aplicar al pichel
// #declare PCFU_DefaultTexturaTapa            = texture { ... }
//      Textura a aplicar a la tapa del pichel
// #declare PCFU_DefaultTexturaAgarradera      = texture { ... }
//      Textura a aplicar a la agarradera del pichel
// #declare PCFU_DefaultTexturaCuero           = texture { ... }
//      Textura a aplicar a la proteccion de calor de la base
// #declare PCFU_DefaultTexturaMetal           = texture { ... }
//      Textura a aplicar a zonas metalizadas
// #declare PCFU_DefaultTexturaRoja            = texture { ... }
//      Textura a aplicar al indicador rojo del boton
// #declare PCFU_DefaultTexturaGris            = texture { ... }
//      Textura a aplicar al indicaror oscuro del boton
//
// Para colocarlo simplemente
// #include "PCFU.inc"
// object        { PCFU_PercoladorCafe( on, on, on, 0, 0.050 ) }
//
// Otro ejemplo con modificador
// #include "PCFU.inc"
// #declare PCFU_DefaultTexturaBase             = texture       {
//   PinkAlabaster
// }
// #declare PCFU_DefaultTexturaTransparente     = texture       {
//   average
//   texture_map        {
//     [ 0.5 PCFU_TexturaTransparente   ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// union                {
//   object        { PCFU_PercoladorCafe( on, on, on, 0, 0.0 ) }
//   intersection       {
//     cylinder { 0, 20*L*y, 100*L }
//     object   { PCFU_VolumenCafe }
//     pigment  { Orange           }
//   }
// }
//

#include "colors.inc"

#local   L                      = 0.001;
#local   OjoAbsoluto            = 256*L;
#local   VecesCentroAbsoluto    = 10;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >
        direction z
        sky       y
        angle     38.74
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         < 500  , 500   , +3000 >*L
         White
}
background      {
         Gray50
}    

#include "PCFU.inc"
#local   FactorAcercamiento     = 4;

object        {
  PCFU_PercoladorCafe( on, on, on, 0, 0.050 )
  translate     -100*L*y+40*L*x
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*z
}



